// dg_dgggg.cc is a part of the VINCIA plug-in to the PYTHIA 8 generator.
// Copyright (C) 2019 P. Skands.
// VINCIA is licenced under the GNU GPL version 2.
// Please respect the MCnet Guidelines for Event Generator Authors and Users,
//               http://www.montecarlonet.org/GUIDELINES

// This file was created on Thu  8 Jun 2017 15:37:56 CEST by ./convertMG5.sh
// VINCIA C++ wrapper for dg_dgggg.f

#include "VinciaMG5/dg_dgggg.h"

namespace Vincia {

//====================================================================

// Wrapper for the MG5 FORTRAN subroutine itself

extern "C" {
  extern void sheldg_dgggg_(int *cMode, int *ICOL, double P1[7][4], int *HEL, double* ANS);
}

//--------------------------------------------------------------------

// initHelMap(): create map from vector of helicities to IHEL number

void MG5dg_dgggg::initHelMap() {
  // Hardcoded helicity map extracted from .f file
  vector<int> h; h.resize(7);
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 1;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 2;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 3;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 4;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 5;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 6;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 7;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 8;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 9;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 10;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 11;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 12;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 13;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 14;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 15;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 16;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 17;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 18;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 19;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 20;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 21;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 22;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 23;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 24;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 25;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 26;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 27;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 28;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 29;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 30;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 31;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 32;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 33;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 34;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 35;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 36;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 37;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 38;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 39;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 40;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 41;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 42;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 43;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 44;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 45;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 46;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 47;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 48;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 49;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 50;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 51;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 52;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 53;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 54;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 55;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 56;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 57;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 58;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 59;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 60;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 61;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 62;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 63;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 64;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 65;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 66;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 67;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 68;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 69;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 70;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 71;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 72;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 73;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 74;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 75;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 76;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 77;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 78;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 79;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 80;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 81;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 82;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 83;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 84;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 85;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 86;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 87;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 88;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 89;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 90;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 91;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 92;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 93;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 94;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 95;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 96;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 97;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 98;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 99;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 100;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 101;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 102;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 103;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 104;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 105;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 106;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 107;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 108;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 109;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 110;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 111;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 112;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 113;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 114;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 115;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 116;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 117;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 118;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 119;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 120;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 121;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 122;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 123;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 124;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 125;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 126;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 127;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 128;
}

//--------------------------------------------------------------------

// initColMap(): create map from vector of MG indices to ICOL numbers

void MG5dg_dgggg::initColMap() {
  // Hardcoded colour-index map extracted from .f file
  // Colour traces extracted from MG5 fortran file
  vector< vector<int> > traces; traces.resize(0);
  vector<int> traceNow;
  traceNow.resize(0);
  // ICOL 1
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=1;
  traceNow.resize(0);
  // ICOL 2
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=2;
  traceNow.resize(0);
  // ICOL 3
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=3;
  traceNow.resize(0);
  // ICOL 4
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=4;
  traceNow.resize(0);
  // ICOL 5
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=5;
  traceNow.resize(0);
  // ICOL 6
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=6;
  traceNow.resize(0);
  // ICOL 7
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=7;
  traceNow.resize(0);
  // ICOL 8
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=8;
  traceNow.resize(0);
  // ICOL 9
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=9;
  traceNow.resize(0);
  // ICOL 10
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=10;
  traceNow.resize(0);
  // ICOL 11
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=11;
  traceNow.resize(0);
  // ICOL 12
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=12;
  traceNow.resize(0);
  // ICOL 13
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=13;
  traceNow.resize(0);
  // ICOL 14
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=14;
  traceNow.resize(0);
  // ICOL 15
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=15;
  traceNow.resize(0);
  // ICOL 16
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=16;
  traceNow.resize(0);
  // ICOL 17
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=17;
  traceNow.resize(0);
  // ICOL 18
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=18;
  traceNow.resize(0);
  // ICOL 19
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=19;
  traceNow.resize(0);
  // ICOL 20
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=20;
  traceNow.resize(0);
  // ICOL 21
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=21;
  traceNow.resize(0);
  // ICOL 22
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=22;
  traceNow.resize(0);
  // ICOL 23
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=23;
  traceNow.resize(0);
  // ICOL 24
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=24;
  traceNow.resize(0);
  // ICOL 25
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=25;
  traceNow.resize(0);
  // ICOL 26
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=26;
  traceNow.resize(0);
  // ICOL 27
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=27;
  traceNow.resize(0);
  // ICOL 28
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=28;
  traceNow.resize(0);
  // ICOL 29
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=29;
  traceNow.resize(0);
  // ICOL 30
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=30;
  traceNow.resize(0);
  // ICOL 31
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=31;
  traceNow.resize(0);
  // ICOL 32
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=32;
  traceNow.resize(0);
  // ICOL 33
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=33;
  traceNow.resize(0);
  // ICOL 34
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=34;
  traceNow.resize(0);
  // ICOL 35
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=35;
  traceNow.resize(0);
  // ICOL 36
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=36;
  traceNow.resize(0);
  // ICOL 37
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=37;
  traceNow.resize(0);
  // ICOL 38
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=38;
  traceNow.resize(0);
  // ICOL 39
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=39;
  traceNow.resize(0);
  // ICOL 40
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=40;
  traceNow.resize(0);
  // ICOL 41
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=41;
  traceNow.resize(0);
  // ICOL 42
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=42;
  traceNow.resize(0);
  // ICOL 43
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=43;
  traceNow.resize(0);
  // ICOL 44
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=44;
  traceNow.resize(0);
  // ICOL 45
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=45;
  traceNow.resize(0);
  // ICOL 46
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=46;
  traceNow.resize(0);
  // ICOL 47
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=47;
  traceNow.resize(0);
  // ICOL 48
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=48;
  traceNow.resize(0);
  // ICOL 49
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=49;
  traceNow.resize(0);
  // ICOL 50
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=50;
  traceNow.resize(0);
  // ICOL 51
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=51;
  traceNow.resize(0);
  // ICOL 52
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=52;
  traceNow.resize(0);
  // ICOL 53
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=53;
  traceNow.resize(0);
  // ICOL 54
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=54;
  traceNow.resize(0);
  // ICOL 55
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=55;
  traceNow.resize(0);
  // ICOL 56
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=56;
  traceNow.resize(0);
  // ICOL 57
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=57;
  traceNow.resize(0);
  // ICOL 58
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=58;
  traceNow.resize(0);
  // ICOL 59
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=59;
  traceNow.resize(0);
  // ICOL 60
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=60;
  traceNow.resize(0);
  // ICOL 61
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=61;
  traceNow.resize(0);
  // ICOL 62
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=62;
  traceNow.resize(0);
  // ICOL 63
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=63;
  traceNow.resize(0);
  // ICOL 64
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=64;
  traceNow.resize(0);
  // ICOL 65
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=65;
  traceNow.resize(0);
  // ICOL 66
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=66;
  traceNow.resize(0);
  // ICOL 67
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=67;
  traceNow.resize(0);
  // ICOL 68
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=68;
  traceNow.resize(0);
  // ICOL 69
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=69;
  traceNow.resize(0);
  // ICOL 70
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=70;
  traceNow.resize(0);
  // ICOL 71
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=71;
  traceNow.resize(0);
  // ICOL 72
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=72;
  traceNow.resize(0);
  // ICOL 73
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=73;
  traceNow.resize(0);
  // ICOL 74
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=74;
  traceNow.resize(0);
  // ICOL 75
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=75;
  traceNow.resize(0);
  // ICOL 76
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=76;
  traceNow.resize(0);
  // ICOL 77
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=77;
  traceNow.resize(0);
  // ICOL 78
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=78;
  traceNow.resize(0);
  // ICOL 79
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=79;
  traceNow.resize(0);
  // ICOL 80
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=80;
  traceNow.resize(0);
  // ICOL 81
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=81;
  traceNow.resize(0);
  // ICOL 82
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=82;
  traceNow.resize(0);
  // ICOL 83
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=83;
  traceNow.resize(0);
  // ICOL 84
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=84;
  traceNow.resize(0);
  // ICOL 85
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=85;
  traceNow.resize(0);
  // ICOL 86
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=86;
  traceNow.resize(0);
  // ICOL 87
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(7);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=87;
  traceNow.resize(0);
  // ICOL 88
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=88;
  traceNow.resize(0);
  // ICOL 89
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=89;
  traceNow.resize(0);
  // ICOL 90
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=90;
  traceNow.resize(0);
  // ICOL 91
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=91;
  traceNow.resize(0);
  // ICOL 92
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=92;
  traceNow.resize(0);
  // ICOL 93
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=93;
  traceNow.resize(0);
  // ICOL 94
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=94;
  traceNow.resize(0);
  // ICOL 95
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=95;
  traceNow.resize(0);
  // ICOL 96
  traceNow.push_back(6);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=96;
  traceNow.resize(0);
  // ICOL 97
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=97;
  traceNow.resize(0);
  // ICOL 98
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=98;
  traceNow.resize(0);
  // ICOL 99
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=99;
  traceNow.resize(0);
  // ICOL 100
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=100;
  traceNow.resize(0);
  // ICOL 101
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=101;
  traceNow.resize(0);
  // ICOL 102
  traceNow.push_back(7);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=102;
  traceNow.resize(0);
  // ICOL 103
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=103;
  traceNow.resize(0);
  // ICOL 104
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=104;
  traceNow.resize(0);
  // ICOL 105
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=105;
  traceNow.resize(0);
  // ICOL 106
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=106;
  traceNow.resize(0);
  // ICOL 107
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=107;
  traceNow.resize(0);
  // ICOL 108
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=108;
  traceNow.resize(0);
  // ICOL 109
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=109;
  traceNow.resize(0);
  // ICOL 110
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=110;
  traceNow.resize(0);
  // ICOL 111
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=111;
  traceNow.resize(0);
  // ICOL 112
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=112;
  traceNow.resize(0);
  // ICOL 113
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=113;
  traceNow.resize(0);
  // ICOL 114
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=114;
  traceNow.resize(0);
  // ICOL 115
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=115;
  traceNow.resize(0);
  // ICOL 116
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=116;
  traceNow.resize(0);
  // ICOL 117
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=117;
  traceNow.resize(0);
  // ICOL 118
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(4);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=118;
  traceNow.resize(0);
  // ICOL 119
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=119;
  traceNow.resize(0);
  // ICOL 120
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(5);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traceNow.push_back(3);
  traceNow.push_back(1);
  cMapSav[traceNow]=120;
}

//------------------------------------------------------------------

// Return vector of all process labels matched by this ME

vector< vector<int> > MG5dg_dgggg::processList() {
  vector< vector<int> > labels; labels.resize(0);
  vector<int> thisLabel;
  thisLabel.resize(0);
  thisLabel.push_back(1);
  thisLabel.push_back(21);
  thisLabel.push_back(1);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(2);
  thisLabel.push_back(21);
  thisLabel.push_back(2);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(3);
  thisLabel.push_back(21);
  thisLabel.push_back(3);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(4);
  thisLabel.push_back(21);
  thisLabel.push_back(4);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  // Sanity check
  for (int i=0; i<(int)labels.size(); ++i) {
    if (nLegs() != (int)labels[i].size())
      cout<<"  MG5${procName}::processList(): ERROR! inconsistent number of legs"<<endl;
  }
  return labels;
}

//------------------------------------------------------------------

// Wrapper for MG5 ME, with variables set by the other methods

double MG5dg_dgggg::getME2(int mcMode) {
  // Call wrapped matrix element
  double ans;
  sheldg_dgggg_(&mcMode, &icolSav, pSav, &ihelSav, &ans);
  return ans;
}

} // End namespace Vincia

