// du_sxdusg.cc is a part of the VINCIA plug-in to the PYTHIA 8 generator.
// Copyright (C) 2019 P. Skands.
// VINCIA is licenced under the GNU GPL version 2.
// Please respect the MCnet Guidelines for Event Generator Authors and Users,
//               http://www.montecarlonet.org/GUIDELINES

// This file was created on Thu  8 Jun 2017 15:38:06 CEST by ./convertMG5.sh
// VINCIA C++ wrapper for du_sxdusg.f

#include "VinciaMG5/du_sxdusg.h"

namespace Vincia {

//====================================================================

// Wrapper for the MG5 FORTRAN subroutine itself

extern "C" {
  extern void sheldu_sxdusg_(int *cMode, int *ICOL, double P1[7][4], int *HEL, double* ANS);
}

//--------------------------------------------------------------------

// initHelMap(): create map from vector of helicities to IHEL number

void MG5du_sxdusg::initHelMap() {
  // Hardcoded helicity map extracted from .f file
  vector<int> h; h.resize(7);
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 1;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 2;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 3;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 4;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 5;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 6;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 7;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 8;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 9;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 10;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 11;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 12;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 13;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 14;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 15;
  h[0]=1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 16;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 17;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 18;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 19;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 20;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 21;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 22;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 23;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 24;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 25;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 26;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 27;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 28;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 29;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 30;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 31;
  h[0]=1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 32;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 33;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 34;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 35;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 36;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 37;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 38;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 39;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 40;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 41;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 42;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 43;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 44;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 45;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 46;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 47;
  h[0]=1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 48;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 49;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 50;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 51;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 52;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 53;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 54;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 55;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 56;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 57;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 58;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 59;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 60;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 61;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 62;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 63;
  h[0]=1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 64;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 65;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 66;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 67;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 68;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 69;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 70;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 71;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 72;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 73;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 74;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 75;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 76;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 77;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 78;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 79;
  h[0]=-1;  h[1]=1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 80;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 81;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 82;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 83;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 84;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 85;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 86;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 87;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 88;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 89;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 90;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 91;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 92;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 93;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 94;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 95;
  h[0]=-1;  h[1]=1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 96;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 97;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 98;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 99;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 100;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 101;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 102;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 103;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 104;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 105;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 106;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 107;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 108;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 109;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 110;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 111;
  h[0]=-1;  h[1]=-1;  h[2]=1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 112;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 113;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 114;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 115;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 116;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 117;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 118;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 119;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=-1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 120;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 121;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 122;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 123;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=-1;  h[5]=1;  h[6]=1;  hMapSav[h] = 124;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=-1;  hMapSav[h] = 125;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=-1;  h[6]=1;  hMapSav[h] = 126;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=-1;  hMapSav[h] = 127;
  h[0]=-1;  h[1]=-1;  h[2]=-1;  h[3]=1;  h[4]=1;  h[5]=1;  h[6]=1;  hMapSav[h] = 128;
}

//--------------------------------------------------------------------

// initColMap(): create map from vector of MG indices to ICOL numbers

void MG5du_sxdusg::initColMap() {
  // Hardcoded colour-index map extracted from .f file
  // Colour traces extracted from MG5 fortran file
  vector< vector<int> > traces; traces.resize(0);
  vector<int> traceNow;
  traceNow.resize(0);
  // ICOL 1
  traceNow.push_back(4);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=1;
  traceNow.resize(0);
  // ICOL 2
  traceNow.push_back(4);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=2;
  traceNow.resize(0);
  // ICOL 3
  traceNow.push_back(4);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=3;
  traceNow.resize(0);
  // ICOL 4
  traceNow.push_back(4);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=4;
  traceNow.resize(0);
  // ICOL 5
  traceNow.push_back(4);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(5);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=5;
  traceNow.resize(0);
  // ICOL 6
  traceNow.push_back(4);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=6;
  traceNow.resize(0);
  // ICOL 7
  traceNow.push_back(4);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=7;
  traceNow.resize(0);
  // ICOL 8
  traceNow.push_back(4);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=8;
  traceNow.resize(0);
  // ICOL 9
  traceNow.push_back(4);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(5);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=9;
  traceNow.resize(0);
  // ICOL 10
  traceNow.push_back(4);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(6);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=10;
  traceNow.resize(0);
  // ICOL 11
  traceNow.push_back(4);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=11;
  traceNow.resize(0);
  // ICOL 12
  traceNow.push_back(4);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(5);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=12;
  traceNow.resize(0);
  // ICOL 13
  traceNow.push_back(5);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=13;
  traceNow.resize(0);
  // ICOL 14
  traceNow.push_back(5);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=14;
  traceNow.resize(0);
  // ICOL 15
  traceNow.push_back(5);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=15;
  traceNow.resize(0);
  // ICOL 16
  traceNow.push_back(5);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=16;
  traceNow.resize(0);
  // ICOL 17
  traceNow.push_back(5);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=17;
  traceNow.resize(0);
  // ICOL 18
  traceNow.push_back(5);
  traceNow.push_back(3);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(6);
  traceNow.push_back(2);
  traces.push_back(traceNow);
  traceNow.resize(0);
  traceNow.push_back(7);
  traceNow.push_back(4);
  traceNow.push_back(1);
  traces.push_back(traceNow);
  // Traces should appear ordered by lowest first index
  for (int i=0; i<=1; ++i) {
    if (traces[2][0] < traces[i][0]) {
      vector<int> tmp = traces[i];
      traces[i] = traces[2];
      traces[2] = tmp;
    }
  }
  if (traces[1][0] < traces[0][0]) {
    vector<int> tmp = traces[0];
    traces[0] = traces[1];
    traces[1] = tmp;
  }
  // Put elements of traces[] into traceNow in correct order
  traceNow=traces[0];
  for (int i=1; i<(int)traces.size(); ++i)
    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());
  traces.resize(0);
  cMapSav[traceNow]=18;
}

//------------------------------------------------------------------

// Return vector of all process labels matched by this ME

vector< vector<int> > MG5du_sxdusg::processList() {
  vector< vector<int> > labels; labels.resize(0);
  vector<int> thisLabel;
  thisLabel.resize(0);
  thisLabel.push_back(1);
  thisLabel.push_back(2);
  thisLabel.push_back(-3);
  thisLabel.push_back(1);
  thisLabel.push_back(2);
  thisLabel.push_back(3);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(1);
  thisLabel.push_back(2);
  thisLabel.push_back(-4);
  thisLabel.push_back(1);
  thisLabel.push_back(2);
  thisLabel.push_back(4);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(1);
  thisLabel.push_back(3);
  thisLabel.push_back(-2);
  thisLabel.push_back(1);
  thisLabel.push_back(3);
  thisLabel.push_back(2);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(1);
  thisLabel.push_back(4);
  thisLabel.push_back(-2);
  thisLabel.push_back(1);
  thisLabel.push_back(4);
  thisLabel.push_back(2);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(1);
  thisLabel.push_back(3);
  thisLabel.push_back(-4);
  thisLabel.push_back(1);
  thisLabel.push_back(3);
  thisLabel.push_back(4);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(1);
  thisLabel.push_back(4);
  thisLabel.push_back(-3);
  thisLabel.push_back(1);
  thisLabel.push_back(4);
  thisLabel.push_back(3);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(2);
  thisLabel.push_back(3);
  thisLabel.push_back(-4);
  thisLabel.push_back(2);
  thisLabel.push_back(3);
  thisLabel.push_back(4);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  thisLabel.resize(0);
  thisLabel.push_back(2);
  thisLabel.push_back(4);
  thisLabel.push_back(-3);
  thisLabel.push_back(2);
  thisLabel.push_back(4);
  thisLabel.push_back(3);
  thisLabel.push_back(21);
  labels.push_back(thisLabel);
  // Sanity check
  for (int i=0; i<(int)labels.size(); ++i) {
    if (nLegs() != (int)labels[i].size())
      cout<<"  MG5${procName}::processList(): ERROR! inconsistent number of legs"<<endl;
  }
  return labels;
}

//------------------------------------------------------------------

// Wrapper for MG5 ME, with variables set by the other methods

double MG5du_sxdusg::getME2(int mcMode) {
  // Call wrapped matrix element
  double ans;
  sheldu_sxdusg_(&mcMode, &icolSav, pSav, &ihelSav, &ans);
  return ans;
}

} // End namespace Vincia

