C...du_uxduu.f is a part of the VINCIA event generator.
C...This file was generated by MADGRAPH 5
C...Modified by VINCIA Thu  8 Jun 2017 15:38:05 CEST
C...VINCIA is licenced under the GNU GPL version 2.
C...Copyright (C) 2019 Peter Skands
C...Please respect the work of the MadGraph authors by
C...citing MadGraph 5 when this part of VINCIA is used.
C...See: https://arxiv.org/abs/1106.0522
 
      SUBROUTINE SHELdu_uxduu(MCMODE,ICOL,P,HEL,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: HEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)

C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER HEL
C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C     ----------
C     BEGIN CODE
C     ----------
      USERHEL=HEL
      CALL Sdu_uxduu(MCMODE,ICOL,P,ANS)
      USERHEL=-1

      END

      SUBROUTINE Sdu_uxduu(MCMODE,ICOL,P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO StandAlone Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: d u > u~ d u u WEIGHTED<=4 @900
C     Process: d s > s~ d s s WEIGHTED<=4 @900
C     Process: d c > c~ d c c WEIGHTED<=4 @900
C     Process: u s > s~ u s s WEIGHTED<=4 @900
C     Process: u c > c~ u c c WEIGHTED<=4 @900
C     Process: s c > c~ s c c WEIGHTED<=4 @900
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    NINITIAL
      PARAMETER (NINITIAL=2)
      INTEGER NPOLENTRIES
      PARAMETER (NPOLENTRIES=(NEXTERNAL+1)*6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
      INTEGER HELAVGFACTOR
      PARAMETER (HELAVGFACTOR=4)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      DOUBLE PRECISION T
      DOUBLE PRECISION du_uxduu
      INTEGER IHEL,IDEN, I, J
C     For a 1>N process, them BEAMTWO_HELAVGFACTOR would be set to 1.
      INTEGER BEAMS_HELAVGFACTOR(2)
      DATA (BEAMS_HELAVGFACTOR(I),I=1,2)/2,2/
      INTEGER JC(NEXTERNAL)
      LOGICAL GOODHEL(NCOMB)
      DATA NTRY/0/
      DATA GOODHEL/NCOMB*.FALSE./

C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C...VINCIA: USERHEL is initialised by MG5interface
C      DATA USERHEL/-1/

      DATA (NHEL(I,   1),I=1,6) / 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,   2),I=1,6) / 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,   3),I=1,6) / 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,   4),I=1,6) / 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,   5),I=1,6) / 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,   6),I=1,6) / 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,   7),I=1,6) / 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,   8),I=1,6) / 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,   9),I=1,6) / 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  10),I=1,6) / 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  11),I=1,6) / 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  12),I=1,6) / 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  13),I=1,6) / 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  14),I=1,6) / 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  15),I=1,6) / 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  16),I=1,6) / 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  17),I=1,6) / 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  18),I=1,6) / 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  19),I=1,6) / 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  20),I=1,6) / 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  21),I=1,6) / 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  22),I=1,6) / 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  23),I=1,6) / 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  24),I=1,6) / 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  25),I=1,6) / 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  26),I=1,6) / 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  27),I=1,6) / 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  28),I=1,6) / 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  29),I=1,6) / 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  30),I=1,6) / 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  31),I=1,6) / 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  32),I=1,6) / 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  33),I=1,6) /-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  34),I=1,6) /-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  35),I=1,6) /-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  36),I=1,6) /-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  37),I=1,6) /-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  38),I=1,6) /-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  39),I=1,6) /-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  40),I=1,6) /-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  41),I=1,6) /-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  42),I=1,6) /-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  43),I=1,6) /-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  44),I=1,6) /-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  45),I=1,6) /-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  46),I=1,6) /-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  47),I=1,6) /-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  48),I=1,6) /-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  49),I=1,6) /-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  50),I=1,6) /-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  51),I=1,6) /-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  52),I=1,6) /-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  53),I=1,6) /-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  54),I=1,6) /-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  55),I=1,6) /-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  56),I=1,6) /-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  57),I=1,6) /-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  58),I=1,6) /-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  59),I=1,6) /-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  60),I=1,6) /-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  61),I=1,6) /-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  62),I=1,6) /-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  63),I=1,6) /-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  64),I=1,6) /-1,-1,-1, 1, 1, 1/
      DATA IDEN/72/

      INTEGER POLARIZATIONS(0:NEXTERNAL,0:5)
      DATA ((POLARIZATIONS(I,J),I=0,NEXTERNAL),J=0,5)/NPOLENTRIES*-1/
C...Vincia: BORN_BEAM_POL not used (POLARIZATIONS local and = -1)
C      COMMON/BORN_BEAM_POL/POLARIZATIONS
C     
C     FUNCTIONS
C     
C...Vincia conversion hardcodes for IS_BORN_HEL_SELECTED = .TRUE.
C      LOGICAL IS_BORN_HEL_SELECTED

C     ----------
C     BEGIN CODE
C     ----------
      IF(USERHEL.EQ.-1) NTRY=0
C...(VINCIA: no NTRY optimisation)
      DO IHEL=1,NEXTERNAL
        JC(IHEL) = +1
      ENDDO
C     When spin-2 particles are involved, the Helicity filtering is
C      dangerous for the 2->1 topology.
C     This is because depending on the MC setup the initial PS points
C      have back-to-back initial states
C     for which some of the spin-2 helicity configurations are zero.
C      But they are no longer zero
C     if the point is boosted on the z-axis. Remember that HELAS
C      helicity amplitudes are no longer
C     lorentz invariant with expternal spin-2 particles (only the
C      helicity sum is).
C     For this reason, we simply remove the filterin when there is
C      only three external particles.
      IF (NEXTERNAL.LE.3) THEN
        DO IHEL=1,NCOMB
          GOODHEL(IHEL)=.TRUE.
        ENDDO
      ENDIF
      ANS = 0D0
      DO IHEL=1,NCOMB
        IF (USERHEL.EQ.-1.OR.USERHEL.EQ.IHEL) THEN
          IF (GOODHEL(IHEL) .OR. NTRY .LT. 20.OR.USERHEL.NE.-1) THEN
            IF(NTRY.GE.2.AND.POLARIZATIONS(0,0).NE.
     $       -1.AND.(.FALSE.)) THEN
              CYCLE
            ENDIF
            T=du_uxduu(MCMODE,ICOL,P ,NHEL(1,IHEL),JC(1))
            IF(POLARIZATIONS(0,0).EQ.-1.OR..TRUE.)
     $        THEN
              ANS=ANS+T
            ENDIF
            IF (T .NE. 0D0 .AND. .NOT.    GOODHEL(IHEL)) THEN
              GOODHEL(IHEL)=.TRUE.
            ENDIF
          ENDIF
        ENDIF
      ENDDO

C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/DBLE(IDEN)
      IF(USERHEL.NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
        ANS=ANS*HELAVGFACTOR
      ELSE
        DO J=1,NINITIAL
          IF (POLARIZATIONS(J,0).NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
            ANS=ANS*BEAMS_HELAVGFACTOR(J)
      
C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/POLARIZATIONS(J,0)
          ENDIF
        ENDDO
      ENDIF
      END


      DOUBLE PRECISION FUNCTION du_uxduu(MCMODE,ICOL,P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: d u > u~ d u u WEIGHTED<=4 @900
C     Process: d s > s~ d s s WEIGHTED<=4 @900
C     Process: d c > c~ d c c WEIGHTED<=4 @900
C     Process: u s > s~ u s s WEIGHTED<=4 @900
C     Process: u c > c~ u c c WEIGHTED<=4 @900
C     Process: s c > c~ s c c WEIGHTED<=4 @900
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=14)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    NWAVEFUNCS, NCOLOR
      PARAMETER (NWAVEFUNCS=13, NCOLOR=6)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
      DOUBLE PRECISION ZLCSUM, FSLC
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J
      COMPLEX*16 ZTEMP
      DOUBLE PRECISION DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(20,NWAVEFUNCS)
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'

C     
C     COLOR DATA
C     
      DATA DENOM(1)/1/
      DATA (CF(I,  1),I=  1,  6) /   27,    9,    9,    3,    3,    9/
C     1 T(4,1) T(5,2) T(6,3)
      DATA DENOM(2)/1/
      DATA (CF(I,  2),I=  1,  6) /    9,   27,    3,    9,    9,    3/
C     1 T(4,1) T(5,3) T(6,2)
      DATA DENOM(3)/1/
      DATA (CF(I,  3),I=  1,  6) /    9,    3,   27,    9,    9,    3/
C     1 T(4,2) T(5,1) T(6,3)
      DATA DENOM(4)/1/
      DATA (CF(I,  4),I=  1,  6) /    3,    9,    9,   27,    3,    9/
C     1 T(4,2) T(5,3) T(6,1)
      DATA DENOM(5)/1/
      DATA (CF(I,  5),I=  1,  6) /    3,    9,    9,    3,   27,    9/
C     1 T(4,3) T(5,1) T(6,2)
      DATA DENOM(6)/1/
      DATA (CF(I,  6),I=  1,  6) /    9,    3,    3,    9,    9,   27/
C     1 T(4,3) T(5,2) T(6,1)
C     ----------
C     BEGIN CODE
C     ----------
      CALL IXXXXX(P(0,1),ZERO,NHEL(1),+1*IC(1),W(1,1))
      CALL IXXXXX(P(0,2),ZERO,NHEL(2),+1*IC(2),W(1,2))
      CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
      CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
      CALL OXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      CALL OXXXXX(P(0,6),ZERO,NHEL(6),+1*IC(6),W(1,6))
      CALL FFV1P0_3(W(1,1),W(1,4),GC_11,ZERO,ZERO,W(1,7))
      CALL FFV1P0_3(W(1,2),W(1,5),GC_11,ZERO,ZERO,W(1,8))
      CALL FFV1_2(W(1,3),W(1,7),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 1
      CALL FFV1_0(W(1,9),W(1,6),W(1,8),GC_11,AMP(1))
      CALL FFV1_1(W(1,6),W(1,7),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 2
      CALL FFV1_0(W(1,3),W(1,10),W(1,8),GC_11,AMP(2))
      CALL FFV1P0_3(W(1,3),W(1,6),GC_11,ZERO,ZERO,W(1,11))
C     Amplitude(s) for diagram number 3
      CALL VVV1_0(W(1,7),W(1,8),W(1,11),GC_10,AMP(3))
      CALL FFV1P0_3(W(1,2),W(1,6),GC_11,ZERO,ZERO,W(1,12))
C     Amplitude(s) for diagram number 4
      CALL FFV1_0(W(1,9),W(1,5),W(1,12),GC_11,AMP(4))
      CALL FFV1_1(W(1,5),W(1,7),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 5
      CALL FFV1_0(W(1,3),W(1,9),W(1,12),GC_11,AMP(5))
      CALL FFV1P0_3(W(1,3),W(1,5),GC_11,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 6
      CALL VVV1_0(W(1,7),W(1,12),W(1,13),GC_10,AMP(6))
      CALL FFV1_2(W(1,2),W(1,7),GC_11,ZERO,ZERO,W(1,3))
C     Amplitude(s) for diagram number 7
      CALL FFV1_0(W(1,3),W(1,6),W(1,13),GC_11,AMP(7))
C     Amplitude(s) for diagram number 8
      CALL FFV1_0(W(1,2),W(1,10),W(1,13),GC_11,AMP(8))
C     Amplitude(s) for diagram number 9
      CALL FFV1_0(W(1,3),W(1,5),W(1,11),GC_11,AMP(9))
C     Amplitude(s) for diagram number 10
      CALL FFV1_0(W(1,2),W(1,9),W(1,11),GC_11,AMP(10))
      CALL FFV1_2(W(1,1),W(1,8),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 11
      CALL FFV1_0(W(1,9),W(1,4),W(1,11),GC_11,AMP(11))
      CALL FFV1_2(W(1,1),W(1,11),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 12
      CALL FFV1_0(W(1,9),W(1,4),W(1,8),GC_11,AMP(12))
      CALL FFV1_2(W(1,1),W(1,12),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 13
      CALL FFV1_0(W(1,9),W(1,4),W(1,13),GC_11,AMP(13))
      CALL FFV1_2(W(1,1),W(1,13),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 14
      CALL FFV1_0(W(1,9),W(1,4),W(1,12),GC_11,AMP(14))
      JAMP(1)=+1D0/4D0*(-1D0/9D0*AMP(1)-1D0/9D0*AMP(2)-1D0/3D0*AMP(4)
     $ -1D0/3D0*AMP(5)-1D0/3D0*AMP(7)-1D0/3D0*AMP(8)-1D0/9D0*AMP(9)
     $ -1D0/9D0*AMP(10)-1D0/9D0*AMP(11)-1D0/9D0*AMP(12))
      JAMP(2)=+1D0/4D0*(+1D0/3D0*AMP(1)+1D0/3D0*AMP(2)+1D0/9D0*AMP(4)
     $ +1D0/9D0*AMP(5)+1D0/9D0*AMP(7)+1D0/9D0*AMP(8)+1D0/3D0*AMP(9)
     $ +1D0/3D0*AMP(10)+1D0/9D0*AMP(13)+1D0/9D0*AMP(14))
      JAMP(3)=+1D0/4D0*(+AMP(5)-IMAG1*AMP(6)+AMP(7)+1D0/3D0*AMP(9)+1D0
     $ /3D0*AMP(10)+1D0/3D0*AMP(11)+1D0/3D0*AMP(12)+AMP(14))
      JAMP(4)=+1D0/4D0*(-AMP(2)+IMAG1*AMP(3)-1D0/3D0*AMP(7)-1D0/3D0
     $ *AMP(8)-AMP(9)-AMP(12)-1D0/3D0*AMP(13)-1D0/3D0*AMP(14))
      JAMP(5)=+1D0/4D0*(-AMP(1)-IMAG1*AMP(3)-1D0/3D0*AMP(4)-1D0/3D0
     $ *AMP(5)-AMP(10)-AMP(11)-1D0/3D0*AMP(13)-1D0/3D0*AMP(14))
      JAMP(6)=+1D0/4D0*(+1D0/3D0*AMP(1)+1D0/3D0*AMP(2)+AMP(4)+IMAG1
     $ *AMP(6)+AMP(8)+1D0/3D0*AMP(11)+1D0/3D0*AMP(12)+AMP(13))

C...VINCIA: Leading Color for Diagonal Entry ICOL
      du_uxduu = CF(ICOL,ICOL)*JAMP(ICOL)
     &         *DCONJG(JAMP(ICOL))/DENOM(ICOL)
C...VINCIA: Absorb subleading color proportional to FSLC = LC/Sum(LC)
      IF (MCMODE.EQ.0) RETURN
      IF (MCMODE.EQ.1.AND.du_uxduu.LE.ZERO) RETURN
        ZLCSUM = 0D0
        DO I = 1, NCOLOR
          ZLCSUM = ZLCSUM + CF(I,I)*JAMP(I)*DCONJG(JAMP(I))/DENOM(I)
        ENDDO
C...VINCIA: MCMODE = 2 returns full colour-summed ME
        IF (MCMODE.EQ.2) du_uxduu = ZLCSUM
C...VINCIA: Fraction of subleading color to absorb into this permutation
        FSLC = du_uxduu/ZLCSUM
C...VINCIA: Sum over subleading contributions multiplied by FSLC
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          IF (I.NE.J) ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
        ENDDO
        du_uxduu = du_uxduu+FSLC*ZTEMP*DCONJG(JAMP(I))/DENOM(I)
      ENDDO

      END

      SUBROUTINE GETdu_uxduu(MCMODE,ICOL,P, ALPHAS, NHEL ,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL
      DOUBLE PRECISION ALPHAS
      DOUBLE PRECISION PI
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: NHEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
CF2PY INTENT(IN) :: ALPHAS
C     ROUTINE FOR F2PY to read the benchmark point.    
C     the include file with the values of the parameters and masses 
      INCLUDE 'coupl.inc'

      PI = 3.141592653589793D0
      G = 2* DSQRT(ALPHAS*PI)
C...VINCIA: only static MG couplings are interfaced
C      CALL UPDATE_AS_PARAM()
      IF (NHEL.NE.0) THEN
        CALL SHELdu_uxduu(MCMODE,ICOL,P, NHEL, ANS)
      ELSE
        CALL Sdu_uxduu(MCMODE,ICOL,P, ANS)
      ENDIF
      RETURN
      END


