C...gg_dxdgg.f is a part of the VINCIA event generator.
C...This file was generated by MADGRAPH 5
C...Modified by VINCIA Thu  8 Jun 2017 15:38:04 CEST
C...VINCIA is licenced under the GNU GPL version 2.
C...Copyright (C) 2019 Peter Skands
C...Please respect the work of the MadGraph authors by
C...citing MadGraph 5 when this part of VINCIA is used.
C...See: https://arxiv.org/abs/1106.0522
 
      SUBROUTINE SHELgg_dxdgg(MCMODE,ICOL,P,HEL,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: HEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)

C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER HEL
C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C     ----------
C     BEGIN CODE
C     ----------
      USERHEL=HEL
      CALL Sgg_dxdgg(MCMODE,ICOL,P,ANS)
      USERHEL=-1

      END

      SUBROUTINE Sgg_dxdgg(MCMODE,ICOL,P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO StandAlone Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: g g > d~ d g g WEIGHTED<=4 @8
C     Process: g g > u~ u g g WEIGHTED<=4 @8
C     Process: g g > s~ s g g WEIGHTED<=4 @8
C     Process: g g > c~ c g g WEIGHTED<=4 @8
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    NINITIAL
      PARAMETER (NINITIAL=2)
      INTEGER NPOLENTRIES
      PARAMETER (NPOLENTRIES=(NEXTERNAL+1)*6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
      INTEGER HELAVGFACTOR
      PARAMETER (HELAVGFACTOR=4)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      DOUBLE PRECISION T
      DOUBLE PRECISION gg_dxdgg
      INTEGER IHEL,IDEN, I, J
C     For a 1>N process, them BEAMTWO_HELAVGFACTOR would be set to 1.
      INTEGER BEAMS_HELAVGFACTOR(2)
      DATA (BEAMS_HELAVGFACTOR(I),I=1,2)/2,2/
      INTEGER JC(NEXTERNAL)
      LOGICAL GOODHEL(NCOMB)
      DATA NTRY/0/
      DATA GOODHEL/NCOMB*.FALSE./

C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C...VINCIA: USERHEL is initialised by MG5interface
C      DATA USERHEL/-1/

      DATA (NHEL(I,   1),I=1,6) /-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,   2),I=1,6) /-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,   3),I=1,6) /-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,   4),I=1,6) /-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,   5),I=1,6) /-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,   6),I=1,6) /-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,   7),I=1,6) /-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,   8),I=1,6) /-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,   9),I=1,6) /-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  10),I=1,6) /-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  11),I=1,6) /-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  12),I=1,6) /-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  13),I=1,6) /-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  14),I=1,6) /-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  15),I=1,6) /-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  16),I=1,6) /-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  17),I=1,6) /-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  18),I=1,6) /-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  19),I=1,6) /-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  20),I=1,6) /-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  21),I=1,6) /-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  22),I=1,6) /-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  23),I=1,6) /-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  24),I=1,6) /-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  25),I=1,6) /-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  26),I=1,6) /-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  27),I=1,6) /-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  28),I=1,6) /-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  29),I=1,6) /-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  30),I=1,6) /-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  31),I=1,6) /-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  32),I=1,6) /-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  33),I=1,6) / 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  34),I=1,6) / 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  35),I=1,6) / 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  36),I=1,6) / 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  37),I=1,6) / 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  38),I=1,6) / 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  39),I=1,6) / 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  40),I=1,6) / 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  41),I=1,6) / 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  42),I=1,6) / 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  43),I=1,6) / 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  44),I=1,6) / 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  45),I=1,6) / 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  46),I=1,6) / 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  47),I=1,6) / 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  48),I=1,6) / 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  49),I=1,6) / 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  50),I=1,6) / 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  51),I=1,6) / 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  52),I=1,6) / 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  53),I=1,6) / 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  54),I=1,6) / 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  55),I=1,6) / 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  56),I=1,6) / 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  57),I=1,6) / 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  58),I=1,6) / 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  59),I=1,6) / 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  60),I=1,6) / 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  61),I=1,6) / 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  62),I=1,6) / 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  63),I=1,6) / 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  64),I=1,6) / 1, 1,-1, 1, 1, 1/
      DATA IDEN/512/

      INTEGER POLARIZATIONS(0:NEXTERNAL,0:5)
      DATA ((POLARIZATIONS(I,J),I=0,NEXTERNAL),J=0,5)/NPOLENTRIES*-1/
C...Vincia: BORN_BEAM_POL not used (POLARIZATIONS local and = -1)
C      COMMON/BORN_BEAM_POL/POLARIZATIONS
C     
C     FUNCTIONS
C     
C...Vincia conversion hardcodes for IS_BORN_HEL_SELECTED = .TRUE.
C      LOGICAL IS_BORN_HEL_SELECTED

C     ----------
C     BEGIN CODE
C     ----------
      IF(USERHEL.EQ.-1) NTRY=0
C...(VINCIA: no NTRY optimisation)
      DO IHEL=1,NEXTERNAL
        JC(IHEL) = +1
      ENDDO
C     When spin-2 particles are involved, the Helicity filtering is
C      dangerous for the 2->1 topology.
C     This is because depending on the MC setup the initial PS points
C      have back-to-back initial states
C     for which some of the spin-2 helicity configurations are zero.
C      But they are no longer zero
C     if the point is boosted on the z-axis. Remember that HELAS
C      helicity amplitudes are no longer
C     lorentz invariant with expternal spin-2 particles (only the
C      helicity sum is).
C     For this reason, we simply remove the filterin when there is
C      only three external particles.
      IF (NEXTERNAL.LE.3) THEN
        DO IHEL=1,NCOMB
          GOODHEL(IHEL)=.TRUE.
        ENDDO
      ENDIF
      ANS = 0D0
      DO IHEL=1,NCOMB
        IF (USERHEL.EQ.-1.OR.USERHEL.EQ.IHEL) THEN
          IF (GOODHEL(IHEL) .OR. NTRY .LT. 20.OR.USERHEL.NE.-1) THEN
            IF(NTRY.GE.2.AND.POLARIZATIONS(0,0).NE.
     $       -1.AND.(.FALSE.)) THEN
              CYCLE
            ENDIF
            T=gg_dxdgg(MCMODE,ICOL,P ,NHEL(1,IHEL),JC(1))
            IF(POLARIZATIONS(0,0).EQ.-1.OR..TRUE.)
     $        THEN
              ANS=ANS+T
            ENDIF
            IF (T .NE. 0D0 .AND. .NOT.    GOODHEL(IHEL)) THEN
              GOODHEL(IHEL)=.TRUE.
            ENDIF
          ENDIF
        ENDIF
      ENDDO

C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/DBLE(IDEN)
      IF(USERHEL.NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
        ANS=ANS*HELAVGFACTOR
      ELSE
        DO J=1,NINITIAL
          IF (POLARIZATIONS(J,0).NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
            ANS=ANS*BEAMS_HELAVGFACTOR(J)
      
C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/POLARIZATIONS(J,0)
          ENDIF
        ENDDO
      ENDIF
      END


      DOUBLE PRECISION FUNCTION gg_dxdgg(MCMODE,ICOL,P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: g g > d~ d g g WEIGHTED<=4 @8
C     Process: g g > u~ u g g WEIGHTED<=4 @8
C     Process: g g > s~ s g g WEIGHTED<=4 @8
C     Process: g g > c~ c g g WEIGHTED<=4 @8
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=159)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    NWAVEFUNCS, NCOLOR
      PARAMETER (NWAVEFUNCS=26, NCOLOR=24)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
      DOUBLE PRECISION ZLCSUM, FSLC
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J
      COMPLEX*16 ZTEMP
      DOUBLE PRECISION DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(20,NWAVEFUNCS)
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'

C     
C     COLOR DATA
C     
      DATA DENOM(1)/54/
      DATA (CF(I,  1),I=  1,  6) /  512,  -64,  -64,    8,    8,   80/
      DATA (CF(I,  1),I=  7, 12) /  -64,    8,    8,   -1,   -1,  -10/
      DATA (CF(I,  1),I= 13, 18) /    8,   -1,   80,  -10,   71,   62/
      DATA (CF(I,  1),I= 19, 24) /   -1,  -10,  -10,   62,   62,  -28/
C     1 T(1,2,5,6,4,3)
      DATA DENOM(2)/54/
      DATA (CF(I,  2),I=  1,  6) /  -64,  512,    8,   80,  -64,    8/
      DATA (CF(I,  2),I=  7, 12) /    8,  -64,   -1,  -10,    8,   -1/
      DATA (CF(I,  2),I= 13, 18) /   -1,  -10,  -10,   62,   62,  -28/
      DATA (CF(I,  2),I= 19, 24) /    8,   -1,   80,  -10,   71,   62/
C     1 T(1,2,6,5,4,3)
      DATA DENOM(3)/54/
      DATA (CF(I,  3),I=  1,  6) /  -64,    8,  512,  -64,   80,    8/
      DATA (CF(I,  3),I=  7, 12) /    8,   -1,   80,  -10,   71,   62/
      DATA (CF(I,  3),I= 13, 18) /  -64,    8,    8,   -1,   -1,  -10/
      DATA (CF(I,  3),I= 19, 24) /  -10,   -1,   62,  -28,  -10,   62/
C     1 T(1,5,2,6,4,3)
      DATA DENOM(4)/54/
      DATA (CF(I,  4),I=  1,  6) /    8,   80,  -64,  512,    8,  -64/
      DATA (CF(I,  4),I=  7, 12) /   -1,  -10,  -10,   62,   62,  -28/
      DATA (CF(I,  4),I= 13, 18) /    8,  -64,   -1,  -10,    8,   -1/
      DATA (CF(I,  4),I= 19, 24) /   -1,    8,   71,   62,   80,  -10/
C     1 T(1,5,6,2,4,3)
      DATA DENOM(5)/54/
      DATA (CF(I,  5),I=  1,  6) /    8,  -64,   80,    8,  512,  -64/
      DATA (CF(I,  5),I=  7, 12) /   -1,    8,   71,   62,   80,  -10/
      DATA (CF(I,  5),I= 13, 18) /  -10,   -1,   62,  -28,  -10,   62/
      DATA (CF(I,  5),I= 19, 24) /  -64,    8,    8,   -1,   -1,  -10/
C     1 T(1,6,2,5,4,3)
      DATA DENOM(6)/54/
      DATA (CF(I,  6),I=  1,  6) /   80,    8,    8,  -64,  -64,  512/
      DATA (CF(I,  6),I=  7, 12) /  -10,   -1,   62,  -28,  -10,   62/
      DATA (CF(I,  6),I= 13, 18) /   -1,    8,   71,   62,   80,  -10/
      DATA (CF(I,  6),I= 19, 24) /    8,  -64,   -1,  -10,    8,   -1/
C     1 T(1,6,5,2,4,3)
      DATA DENOM(7)/54/
      DATA (CF(I,  7),I=  1,  6) /  -64,    8,    8,   -1,   -1,  -10/
      DATA (CF(I,  7),I=  7, 12) /  512,  -64,  -64,    8,    8,   80/
      DATA (CF(I,  7),I= 13, 18) /   80,  -10,    8,   -1,   62,   71/
      DATA (CF(I,  7),I= 19, 24) /  -10,   62,   -1,  -10,  -28,   62/
C     1 T(2,1,5,6,4,3)
      DATA DENOM(8)/54/
      DATA (CF(I,  8),I=  1,  6) /    8,  -64,   -1,  -10,    8,   -1/
      DATA (CF(I,  8),I=  7, 12) /  -64,  512,    8,   80,  -64,    8/
      DATA (CF(I,  8),I= 13, 18) /  -10,   62,   -1,  -10,  -28,   62/
      DATA (CF(I,  8),I= 19, 24) /   80,  -10,    8,   -1,   62,   71/
C     1 T(2,1,6,5,4,3)
      DATA DENOM(9)/54/
      DATA (CF(I,  9),I=  1,  6) /    8,   -1,   80,  -10,   71,   62/
      DATA (CF(I,  9),I=  7, 12) /  -64,    8,  512,  -64,   80,    8/
      DATA (CF(I,  9),I= 13, 18) /    8,   -1,  -64,    8,  -10,   -1/
      DATA (CF(I,  9),I= 19, 24) /   62,  -28,  -10,   -1,   62,  -10/
C     1 T(2,5,1,6,4,3)
      DATA DENOM(10)/54/
      DATA (CF(I, 10),I=  1,  6) /   -1,  -10,  -10,   62,   62,  -28/
      DATA (CF(I, 10),I=  7, 12) /    8,   80,  -64,  512,    8,  -64/
      DATA (CF(I, 10),I= 13, 18) /   -1,  -10,    8,  -64,   -1,    8/
      DATA (CF(I, 10),I= 19, 24) /   71,   62,   -1,    8,  -10,   80/
C     1 T(2,5,6,1,4,3)
      DATA DENOM(11)/54/
      DATA (CF(I, 11),I=  1,  6) /   -1,    8,   71,   62,   80,  -10/
      DATA (CF(I, 11),I=  7, 12) /    8,  -64,   80,    8,  512,  -64/
      DATA (CF(I, 11),I= 13, 18) /   62,  -28,  -10,   -1,   62,  -10/
      DATA (CF(I, 11),I= 19, 24) /    8,   -1,  -64,    8,  -10,   -1/
C     1 T(2,6,1,5,4,3)
      DATA DENOM(12)/54/
      DATA (CF(I, 12),I=  1,  6) /  -10,   -1,   62,  -28,  -10,   62/
      DATA (CF(I, 12),I=  7, 12) /   80,    8,    8,  -64,  -64,  512/
      DATA (CF(I, 12),I= 13, 18) /   71,   62,   -1,    8,  -10,   80/
      DATA (CF(I, 12),I= 19, 24) /   -1,  -10,    8,  -64,   -1,    8/
C     1 T(2,6,5,1,4,3)
      DATA DENOM(13)/54/
      DATA (CF(I, 13),I=  1,  6) /    8,   -1,  -64,    8,  -10,   -1/
      DATA (CF(I, 13),I=  7, 12) /   80,  -10,    8,   -1,   62,   71/
      DATA (CF(I, 13),I= 13, 18) /  512,  -64,  -64,    8,    8,   80/
      DATA (CF(I, 13),I= 19, 24) /   62,  -10,  -28,   62,   -1,  -10/
C     1 T(5,1,2,6,4,3)
      DATA DENOM(14)/54/
      DATA (CF(I, 14),I=  1,  6) /   -1,  -10,    8,  -64,   -1,    8/
      DATA (CF(I, 14),I=  7, 12) /  -10,   62,   -1,  -10,  -28,   62/
      DATA (CF(I, 14),I= 13, 18) /  -64,  512,    8,   80,  -64,    8/
      DATA (CF(I, 14),I= 19, 24) /  -10,   80,   62,   71,    8,   -1/
C     1 T(5,1,6,2,4,3)
      DATA DENOM(15)/54/
      DATA (CF(I, 15),I=  1,  6) /   80,  -10,    8,   -1,   62,   71/
      DATA (CF(I, 15),I=  7, 12) /    8,   -1,  -64,    8,  -10,   -1/
      DATA (CF(I, 15),I= 13, 18) /  -64,    8,  512,  -64,   80,    8/
      DATA (CF(I, 15),I= 19, 24) /  -28,   62,   62,  -10,  -10,   -1/
C     1 T(5,2,1,6,4,3)
      DATA DENOM(16)/54/
      DATA (CF(I, 16),I=  1,  6) /  -10,   62,   -1,  -10,  -28,   62/
      DATA (CF(I, 16),I=  7, 12) /   -1,  -10,    8,  -64,   -1,    8/
      DATA (CF(I, 16),I= 13, 18) /    8,   80,  -64,  512,    8,  -64/
      DATA (CF(I, 16),I= 19, 24) /   62,   71,  -10,   80,   -1,    8/
C     1 T(5,2,6,1,4,3)
      DATA DENOM(17)/54/
      DATA (CF(I, 17),I=  1,  6) /   71,   62,   -1,    8,  -10,   80/
      DATA (CF(I, 17),I=  7, 12) /   62,  -28,  -10,   -1,   62,  -10/
      DATA (CF(I, 17),I= 13, 18) /    8,  -64,   80,    8,  512,  -64/
      DATA (CF(I, 17),I= 19, 24) /   -1,    8,  -10,   -1,  -64,    8/
C     1 T(5,6,1,2,4,3)
      DATA DENOM(18)/54/
      DATA (CF(I, 18),I=  1,  6) /   62,  -28,  -10,   -1,   62,  -10/
      DATA (CF(I, 18),I=  7, 12) /   71,   62,   -1,    8,  -10,   80/
      DATA (CF(I, 18),I= 13, 18) /   80,    8,    8,  -64,  -64,  512/
      DATA (CF(I, 18),I= 19, 24) /  -10,   -1,   -1,    8,    8,  -64/
C     1 T(5,6,2,1,4,3)
      DATA DENOM(19)/54/
      DATA (CF(I, 19),I=  1,  6) /   -1,    8,  -10,   -1,  -64,    8/
      DATA (CF(I, 19),I=  7, 12) /  -10,   80,   62,   71,    8,   -1/
      DATA (CF(I, 19),I= 13, 18) /   62,  -10,  -28,   62,   -1,  -10/
      DATA (CF(I, 19),I= 19, 24) /  512,  -64,  -64,    8,    8,   80/
C     1 T(6,1,2,5,4,3)
      DATA DENOM(20)/54/
      DATA (CF(I, 20),I=  1,  6) /  -10,   -1,   -1,    8,    8,  -64/
      DATA (CF(I, 20),I=  7, 12) /   62,  -10,  -28,   62,   -1,  -10/
      DATA (CF(I, 20),I= 13, 18) /  -10,   80,   62,   71,    8,   -1/
      DATA (CF(I, 20),I= 19, 24) /  -64,  512,    8,   80,  -64,    8/
C     1 T(6,1,5,2,4,3)
      DATA DENOM(21)/54/
      DATA (CF(I, 21),I=  1,  6) /  -10,   80,   62,   71,    8,   -1/
      DATA (CF(I, 21),I=  7, 12) /   -1,    8,  -10,   -1,  -64,    8/
      DATA (CF(I, 21),I= 13, 18) /  -28,   62,   62,  -10,  -10,   -1/
      DATA (CF(I, 21),I= 19, 24) /  -64,    8,  512,  -64,   80,    8/
C     1 T(6,2,1,5,4,3)
      DATA DENOM(22)/54/
      DATA (CF(I, 22),I=  1,  6) /   62,  -10,  -28,   62,   -1,  -10/
      DATA (CF(I, 22),I=  7, 12) /  -10,   -1,   -1,    8,    8,  -64/
      DATA (CF(I, 22),I= 13, 18) /   62,   71,  -10,   80,   -1,    8/
      DATA (CF(I, 22),I= 19, 24) /    8,   80,  -64,  512,    8,  -64/
C     1 T(6,2,5,1,4,3)
      DATA DENOM(23)/54/
      DATA (CF(I, 23),I=  1,  6) /   62,   71,  -10,   80,   -1,    8/
      DATA (CF(I, 23),I=  7, 12) /  -28,   62,   62,  -10,  -10,   -1/
      DATA (CF(I, 23),I= 13, 18) /   -1,    8,  -10,   -1,  -64,    8/
      DATA (CF(I, 23),I= 19, 24) /    8,  -64,   80,    8,  512,  -64/
C     1 T(6,5,1,2,4,3)
      DATA DENOM(24)/54/
      DATA (CF(I, 24),I=  1,  6) /  -28,   62,   62,  -10,  -10,   -1/
      DATA (CF(I, 24),I=  7, 12) /   62,   71,  -10,   80,   -1,    8/
      DATA (CF(I, 24),I= 13, 18) /  -10,   -1,   -1,    8,    8,  -64/
      DATA (CF(I, 24),I= 19, 24) /   80,    8,    8,  -64,  -64,  512/
C     1 T(6,5,2,1,4,3)
C     ----------
C     BEGIN CODE
C     ----------
      CALL VXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
      CALL VXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
      CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
      CALL VXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      CALL VXXXXX(P(0,6),ZERO,NHEL(6),+1*IC(6),W(1,6))
      CALL VVV1P0_1(W(1,1),W(1,2),GC_10,ZERO,ZERO,W(1,7))
      CALL FFV1P0_3(W(1,3),W(1,4),GC_11,ZERO,ZERO,W(1,8))
C     Amplitude(s) for diagram number 1
      CALL VVVV1_0(W(1,7),W(1,8),W(1,5),W(1,6),GC_12,AMP(1))
      CALL VVVV3_0(W(1,7),W(1,8),W(1,5),W(1,6),GC_12,AMP(2))
      CALL VVVV4_0(W(1,7),W(1,8),W(1,5),W(1,6),GC_12,AMP(3))
      CALL VVV1P0_1(W(1,7),W(1,5),GC_10,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 2
      CALL VVV1_0(W(1,8),W(1,6),W(1,9),GC_10,AMP(4))
      CALL VVV1P0_1(W(1,7),W(1,6),GC_10,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 3
      CALL VVV1_0(W(1,8),W(1,5),W(1,10),GC_10,AMP(5))
      CALL VVV1P0_1(W(1,5),W(1,6),GC_10,ZERO,ZERO,W(1,11))
C     Amplitude(s) for diagram number 4
      CALL VVV1_0(W(1,7),W(1,8),W(1,11),GC_10,AMP(6))
      CALL FFV1_2(W(1,3),W(1,5),GC_11,ZERO,ZERO,W(1,12))
      CALL FFV1_1(W(1,4),W(1,7),GC_11,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 5
      CALL FFV1_0(W(1,12),W(1,13),W(1,6),GC_11,AMP(7))
C     Amplitude(s) for diagram number 6
      CALL FFV1_0(W(1,12),W(1,4),W(1,10),GC_11,AMP(8))
      CALL FFV1_1(W(1,4),W(1,6),GC_11,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 7
      CALL FFV1_0(W(1,12),W(1,14),W(1,7),GC_11,AMP(9))
      CALL FFV1_2(W(1,3),W(1,6),GC_11,ZERO,ZERO,W(1,15))
C     Amplitude(s) for diagram number 8
      CALL FFV1_0(W(1,15),W(1,13),W(1,5),GC_11,AMP(10))
C     Amplitude(s) for diagram number 9
      CALL FFV1_0(W(1,15),W(1,4),W(1,9),GC_11,AMP(11))
      CALL FFV1_1(W(1,4),W(1,5),GC_11,ZERO,ZERO,W(1,16))
C     Amplitude(s) for diagram number 10
      CALL FFV1_0(W(1,15),W(1,16),W(1,7),GC_11,AMP(12))
      CALL FFV1_2(W(1,3),W(1,7),GC_11,ZERO,ZERO,W(1,17))
C     Amplitude(s) for diagram number 11
      CALL FFV1_0(W(1,17),W(1,16),W(1,6),GC_11,AMP(13))
C     Amplitude(s) for diagram number 12
      CALL FFV1_0(W(1,3),W(1,16),W(1,10),GC_11,AMP(14))
C     Amplitude(s) for diagram number 13
      CALL FFV1_0(W(1,17),W(1,14),W(1,5),GC_11,AMP(15))
C     Amplitude(s) for diagram number 14
      CALL FFV1_0(W(1,3),W(1,14),W(1,9),GC_11,AMP(16))
C     Amplitude(s) for diagram number 15
      CALL FFV1_0(W(1,17),W(1,4),W(1,11),GC_11,AMP(17))
C     Amplitude(s) for diagram number 16
      CALL FFV1_0(W(1,3),W(1,13),W(1,11),GC_11,AMP(18))
      CALL FFV1_2(W(1,3),W(1,1),GC_11,ZERO,ZERO,W(1,13))
      CALL FFV1_1(W(1,4),W(1,2),GC_11,ZERO,ZERO,W(1,17))
      CALL FFV1_2(W(1,13),W(1,5),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 17
      CALL FFV1_0(W(1,9),W(1,17),W(1,6),GC_11,AMP(19))
      CALL FFV1_2(W(1,13),W(1,6),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 18
      CALL FFV1_0(W(1,10),W(1,17),W(1,5),GC_11,AMP(20))
C     Amplitude(s) for diagram number 19
      CALL FFV1_0(W(1,13),W(1,17),W(1,11),GC_11,AMP(21))
      CALL VVV1P0_1(W(1,2),W(1,5),GC_10,ZERO,ZERO,W(1,7))
      CALL FFV1P0_3(W(1,13),W(1,4),GC_11,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 20
      CALL VVV1_0(W(1,7),W(1,6),W(1,18),GC_10,AMP(22))
C     Amplitude(s) for diagram number 21
      CALL FFV1_0(W(1,10),W(1,4),W(1,7),GC_11,AMP(23))
C     Amplitude(s) for diagram number 22
      CALL FFV1_0(W(1,13),W(1,14),W(1,7),GC_11,AMP(24))
      CALL VVV1P0_1(W(1,2),W(1,6),GC_10,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 23
      CALL VVV1_0(W(1,19),W(1,5),W(1,18),GC_10,AMP(25))
C     Amplitude(s) for diagram number 24
      CALL FFV1_0(W(1,9),W(1,4),W(1,19),GC_11,AMP(26))
C     Amplitude(s) for diagram number 25
      CALL FFV1_0(W(1,13),W(1,16),W(1,19),GC_11,AMP(27))
      CALL FFV1_2(W(1,13),W(1,2),GC_11,ZERO,ZERO,W(1,20))
C     Amplitude(s) for diagram number 26
      CALL FFV1_0(W(1,20),W(1,16),W(1,6),GC_11,AMP(28))
C     Amplitude(s) for diagram number 27
      CALL FFV1_0(W(1,10),W(1,16),W(1,2),GC_11,AMP(29))
C     Amplitude(s) for diagram number 28
      CALL FFV1_0(W(1,20),W(1,14),W(1,5),GC_11,AMP(30))
C     Amplitude(s) for diagram number 29
      CALL FFV1_0(W(1,9),W(1,14),W(1,2),GC_11,AMP(31))
C     Amplitude(s) for diagram number 30
      CALL FFV1_0(W(1,20),W(1,4),W(1,11),GC_11,AMP(32))
C     Amplitude(s) for diagram number 31
      CALL VVV1_0(W(1,2),W(1,11),W(1,18),GC_10,AMP(33))
      CALL VVVV1P0_1(W(1,2),W(1,5),W(1,6),GC_12,ZERO,ZERO,W(1,18))
      CALL VVVV3P0_1(W(1,2),W(1,5),W(1,6),GC_12,ZERO,ZERO,W(1,20))
      CALL VVVV4P0_1(W(1,2),W(1,5),W(1,6),GC_12,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 32
      CALL FFV1_0(W(1,13),W(1,4),W(1,18),GC_11,AMP(34))
      CALL FFV1_0(W(1,13),W(1,4),W(1,20),GC_11,AMP(35))
      CALL FFV1_0(W(1,13),W(1,4),W(1,9),GC_11,AMP(36))
      CALL FFV1_1(W(1,4),W(1,1),GC_11,ZERO,ZERO,W(1,13))
      CALL FFV1_2(W(1,3),W(1,2),GC_11,ZERO,ZERO,W(1,10))
      CALL FFV1_1(W(1,13),W(1,5),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 33
      CALL FFV1_0(W(1,10),W(1,21),W(1,6),GC_11,AMP(37))
      CALL FFV1_1(W(1,13),W(1,6),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 34
      CALL FFV1_0(W(1,10),W(1,22),W(1,5),GC_11,AMP(38))
C     Amplitude(s) for diagram number 35
      CALL FFV1_0(W(1,10),W(1,13),W(1,11),GC_11,AMP(39))
      CALL FFV1P0_3(W(1,3),W(1,13),GC_11,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 36
      CALL VVV1_0(W(1,7),W(1,6),W(1,23),GC_10,AMP(40))
C     Amplitude(s) for diagram number 37
      CALL FFV1_0(W(1,3),W(1,22),W(1,7),GC_11,AMP(41))
C     Amplitude(s) for diagram number 38
      CALL FFV1_0(W(1,15),W(1,13),W(1,7),GC_11,AMP(42))
C     Amplitude(s) for diagram number 39
      CALL VVV1_0(W(1,19),W(1,5),W(1,23),GC_10,AMP(43))
C     Amplitude(s) for diagram number 40
      CALL FFV1_0(W(1,3),W(1,21),W(1,19),GC_11,AMP(44))
C     Amplitude(s) for diagram number 41
      CALL FFV1_0(W(1,12),W(1,13),W(1,19),GC_11,AMP(45))
      CALL FFV1_1(W(1,13),W(1,2),GC_11,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 42
      CALL FFV1_0(W(1,12),W(1,24),W(1,6),GC_11,AMP(46))
C     Amplitude(s) for diagram number 43
      CALL FFV1_0(W(1,12),W(1,22),W(1,2),GC_11,AMP(47))
C     Amplitude(s) for diagram number 44
      CALL FFV1_0(W(1,15),W(1,24),W(1,5),GC_11,AMP(48))
C     Amplitude(s) for diagram number 45
      CALL FFV1_0(W(1,15),W(1,21),W(1,2),GC_11,AMP(49))
C     Amplitude(s) for diagram number 46
      CALL FFV1_0(W(1,3),W(1,24),W(1,11),GC_11,AMP(50))
C     Amplitude(s) for diagram number 47
      CALL VVV1_0(W(1,2),W(1,11),W(1,23),GC_10,AMP(51))
C     Amplitude(s) for diagram number 48
      CALL FFV1_0(W(1,3),W(1,13),W(1,18),GC_11,AMP(52))
      CALL FFV1_0(W(1,3),W(1,13),W(1,20),GC_11,AMP(53))
      CALL FFV1_0(W(1,3),W(1,13),W(1,9),GC_11,AMP(54))
      CALL VVV1P0_1(W(1,1),W(1,5),GC_10,ZERO,ZERO,W(1,13))
      CALL FFV1_1(W(1,4),W(1,13),GC_11,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 49
      CALL FFV1_0(W(1,10),W(1,23),W(1,6),GC_11,AMP(55))
      CALL VVV1P0_1(W(1,13),W(1,6),GC_10,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 50
      CALL FFV1_0(W(1,10),W(1,4),W(1,24),GC_11,AMP(56))
C     Amplitude(s) for diagram number 51
      CALL FFV1_0(W(1,10),W(1,14),W(1,13),GC_11,AMP(57))
      CALL FFV1_2(W(1,3),W(1,13),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 52
      CALL FFV1_0(W(1,21),W(1,17),W(1,6),GC_11,AMP(58))
C     Amplitude(s) for diagram number 53
      CALL FFV1_0(W(1,3),W(1,17),W(1,24),GC_11,AMP(59))
C     Amplitude(s) for diagram number 54
      CALL FFV1_0(W(1,15),W(1,17),W(1,13),GC_11,AMP(60))
C     Amplitude(s) for diagram number 55
      CALL FFV1_0(W(1,21),W(1,4),W(1,19),GC_11,AMP(61))
C     Amplitude(s) for diagram number 56
      CALL FFV1_0(W(1,3),W(1,23),W(1,19),GC_11,AMP(62))
C     Amplitude(s) for diagram number 57
      CALL VVV1_0(W(1,13),W(1,19),W(1,8),GC_10,AMP(63))
C     Amplitude(s) for diagram number 58
      CALL VVVV1_0(W(1,13),W(1,2),W(1,8),W(1,6),GC_12,AMP(64))
      CALL VVVV3_0(W(1,13),W(1,2),W(1,8),W(1,6),GC_12,AMP(65))
      CALL VVVV4_0(W(1,13),W(1,2),W(1,8),W(1,6),GC_12,AMP(66))
      CALL VVV1P0_1(W(1,13),W(1,2),GC_10,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 59
      CALL VVV1_0(W(1,8),W(1,6),W(1,22),GC_10,AMP(67))
C     Amplitude(s) for diagram number 60
      CALL VVV1_0(W(1,2),W(1,8),W(1,24),GC_10,AMP(68))
C     Amplitude(s) for diagram number 61
      CALL FFV1_0(W(1,15),W(1,4),W(1,22),GC_11,AMP(69))
C     Amplitude(s) for diagram number 62
      CALL FFV1_0(W(1,15),W(1,23),W(1,2),GC_11,AMP(70))
C     Amplitude(s) for diagram number 63
      CALL FFV1_0(W(1,3),W(1,14),W(1,22),GC_11,AMP(71))
C     Amplitude(s) for diagram number 64
      CALL FFV1_0(W(1,21),W(1,14),W(1,2),GC_11,AMP(72))
      CALL VVV1P0_1(W(1,1),W(1,6),GC_10,ZERO,ZERO,W(1,21))
      CALL FFV1_1(W(1,4),W(1,21),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 65
      CALL FFV1_0(W(1,10),W(1,22),W(1,5),GC_11,AMP(73))
      CALL VVV1P0_1(W(1,21),W(1,5),GC_10,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 66
      CALL FFV1_0(W(1,10),W(1,4),W(1,23),GC_11,AMP(74))
C     Amplitude(s) for diagram number 67
      CALL FFV1_0(W(1,10),W(1,16),W(1,21),GC_11,AMP(75))
      CALL FFV1_2(W(1,3),W(1,21),GC_11,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 68
      CALL FFV1_0(W(1,24),W(1,17),W(1,5),GC_11,AMP(76))
C     Amplitude(s) for diagram number 69
      CALL FFV1_0(W(1,3),W(1,17),W(1,23),GC_11,AMP(77))
C     Amplitude(s) for diagram number 70
      CALL FFV1_0(W(1,12),W(1,17),W(1,21),GC_11,AMP(78))
C     Amplitude(s) for diagram number 71
      CALL FFV1_0(W(1,24),W(1,4),W(1,7),GC_11,AMP(79))
C     Amplitude(s) for diagram number 72
      CALL FFV1_0(W(1,3),W(1,22),W(1,7),GC_11,AMP(80))
C     Amplitude(s) for diagram number 73
      CALL VVV1_0(W(1,21),W(1,7),W(1,8),GC_10,AMP(81))
C     Amplitude(s) for diagram number 74
      CALL VVVV1_0(W(1,21),W(1,2),W(1,8),W(1,5),GC_12,AMP(82))
      CALL VVVV3_0(W(1,21),W(1,2),W(1,8),W(1,5),GC_12,AMP(83))
      CALL VVVV4_0(W(1,21),W(1,2),W(1,8),W(1,5),GC_12,AMP(84))
      CALL VVV1P0_1(W(1,21),W(1,2),GC_10,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 75
      CALL VVV1_0(W(1,8),W(1,5),W(1,13),GC_10,AMP(85))
C     Amplitude(s) for diagram number 76
      CALL VVV1_0(W(1,2),W(1,8),W(1,23),GC_10,AMP(86))
C     Amplitude(s) for diagram number 77
      CALL FFV1_0(W(1,12),W(1,4),W(1,13),GC_11,AMP(87))
C     Amplitude(s) for diagram number 78
      CALL FFV1_0(W(1,12),W(1,22),W(1,2),GC_11,AMP(88))
C     Amplitude(s) for diagram number 79
      CALL FFV1_0(W(1,3),W(1,16),W(1,13),GC_11,AMP(89))
C     Amplitude(s) for diagram number 80
      CALL FFV1_0(W(1,24),W(1,16),W(1,2),GC_11,AMP(90))
      CALL FFV1_2(W(1,10),W(1,1),GC_11,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 81
      CALL FFV1_0(W(1,24),W(1,16),W(1,6),GC_11,AMP(91))
      CALL FFV1_1(W(1,16),W(1,1),GC_11,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 82
      CALL FFV1_0(W(1,10),W(1,13),W(1,6),GC_11,AMP(92))
C     Amplitude(s) for diagram number 83
      CALL FFV1_0(W(1,24),W(1,14),W(1,5),GC_11,AMP(93))
      CALL FFV1_1(W(1,14),W(1,1),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 84
      CALL FFV1_0(W(1,10),W(1,22),W(1,5),GC_11,AMP(94))
C     Amplitude(s) for diagram number 85
      CALL FFV1_0(W(1,24),W(1,4),W(1,11),GC_11,AMP(95))
      CALL VVV1P0_1(W(1,1),W(1,11),GC_10,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 86
      CALL FFV1_0(W(1,10),W(1,4),W(1,24),GC_11,AMP(96))
      CALL FFV1_1(W(1,17),W(1,1),GC_11,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 87
      CALL FFV1_0(W(1,12),W(1,23),W(1,6),GC_11,AMP(97))
      CALL FFV1_2(W(1,12),W(1,1),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 88
      CALL FFV1_0(W(1,21),W(1,17),W(1,6),GC_11,AMP(98))
C     Amplitude(s) for diagram number 89
      CALL FFV1_0(W(1,15),W(1,23),W(1,5),GC_11,AMP(99))
      CALL FFV1_2(W(1,15),W(1,1),GC_11,ZERO,ZERO,W(1,25))
C     Amplitude(s) for diagram number 90
      CALL FFV1_0(W(1,25),W(1,17),W(1,5),GC_11,AMP(100))
C     Amplitude(s) for diagram number 91
      CALL FFV1_0(W(1,3),W(1,23),W(1,11),GC_11,AMP(101))
C     Amplitude(s) for diagram number 92
      CALL FFV1_0(W(1,3),W(1,17),W(1,24),GC_11,AMP(102))
C     Amplitude(s) for diagram number 93
      CALL VVVV1_0(W(1,1),W(1,7),W(1,8),W(1,6),GC_12,AMP(103))
      CALL VVVV3_0(W(1,1),W(1,7),W(1,8),W(1,6),GC_12,AMP(104))
      CALL VVVV4_0(W(1,1),W(1,7),W(1,8),W(1,6),GC_12,AMP(105))
      CALL VVV1P0_1(W(1,1),W(1,7),GC_10,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 94
      CALL VVV1_0(W(1,8),W(1,6),W(1,23),GC_10,AMP(106))
      CALL VVV1P0_1(W(1,1),W(1,8),GC_10,ZERO,ZERO,W(1,26))
C     Amplitude(s) for diagram number 95
      CALL VVV1_0(W(1,7),W(1,6),W(1,26),GC_10,AMP(107))
C     Amplitude(s) for diagram number 96
      CALL FFV1_0(W(1,15),W(1,4),W(1,23),GC_11,AMP(108))
C     Amplitude(s) for diagram number 97
      CALL FFV1_0(W(1,25),W(1,4),W(1,7),GC_11,AMP(109))
C     Amplitude(s) for diagram number 98
      CALL FFV1_0(W(1,3),W(1,14),W(1,23),GC_11,AMP(110))
C     Amplitude(s) for diagram number 99
      CALL FFV1_0(W(1,3),W(1,22),W(1,7),GC_11,AMP(111))
C     Amplitude(s) for diagram number 100
      CALL VVVV1_0(W(1,1),W(1,19),W(1,8),W(1,5),GC_12,AMP(112))
      CALL VVVV3_0(W(1,1),W(1,19),W(1,8),W(1,5),GC_12,AMP(113))
      CALL VVVV4_0(W(1,1),W(1,19),W(1,8),W(1,5),GC_12,AMP(114))
      CALL VVV1P0_1(W(1,1),W(1,19),GC_10,ZERO,ZERO,W(1,7))
C     Amplitude(s) for diagram number 101
      CALL VVV1_0(W(1,8),W(1,5),W(1,7),GC_10,AMP(115))
C     Amplitude(s) for diagram number 102
      CALL VVV1_0(W(1,19),W(1,5),W(1,26),GC_10,AMP(116))
C     Amplitude(s) for diagram number 103
      CALL FFV1_0(W(1,12),W(1,4),W(1,7),GC_11,AMP(117))
C     Amplitude(s) for diagram number 104
      CALL FFV1_0(W(1,21),W(1,4),W(1,19),GC_11,AMP(118))
C     Amplitude(s) for diagram number 105
      CALL FFV1_0(W(1,3),W(1,16),W(1,7),GC_11,AMP(119))
C     Amplitude(s) for diagram number 106
      CALL FFV1_0(W(1,3),W(1,13),W(1,19),GC_11,AMP(120))
C     Amplitude(s) for diagram number 107
      CALL VVVV1_0(W(1,1),W(1,2),W(1,8),W(1,11),GC_12,AMP(121))
      CALL VVVV3_0(W(1,1),W(1,2),W(1,8),W(1,11),GC_12,AMP(122))
      CALL VVVV4_0(W(1,1),W(1,2),W(1,8),W(1,11),GC_12,AMP(123))
C     Amplitude(s) for diagram number 108
      CALL VVV1_0(W(1,2),W(1,11),W(1,26),GC_10,AMP(124))
C     Amplitude(s) for diagram number 109
      CALL VVV1_0(W(1,2),W(1,8),W(1,24),GC_10,AMP(125))
C     Amplitude(s) for diagram number 110
      CALL FFV1_0(W(1,21),W(1,14),W(1,2),GC_11,AMP(126))
C     Amplitude(s) for diagram number 111
      CALL FFV1_0(W(1,12),W(1,22),W(1,2),GC_11,AMP(127))
C     Amplitude(s) for diagram number 112
      CALL FFV1_0(W(1,25),W(1,16),W(1,2),GC_11,AMP(128))
C     Amplitude(s) for diagram number 113
      CALL FFV1_0(W(1,15),W(1,13),W(1,2),GC_11,AMP(129))
      CALL VVVV1P0_1(W(1,1),W(1,2),W(1,5),GC_12,ZERO,ZERO,W(1,13))
      CALL VVVV3P0_1(W(1,1),W(1,2),W(1,5),GC_12,ZERO,ZERO,W(1,25))
      CALL VVVV4P0_1(W(1,1),W(1,2),W(1,5),GC_12,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 114
      CALL VVV1_0(W(1,13),W(1,8),W(1,6),GC_10,AMP(130))
      CALL VVV1_0(W(1,25),W(1,8),W(1,6),GC_10,AMP(131))
      CALL VVV1_0(W(1,22),W(1,8),W(1,6),GC_10,AMP(132))
C     Amplitude(s) for diagram number 115
      CALL FFV1_0(W(1,15),W(1,4),W(1,13),GC_11,AMP(133))
      CALL FFV1_0(W(1,15),W(1,4),W(1,25),GC_11,AMP(134))
      CALL FFV1_0(W(1,15),W(1,4),W(1,22),GC_11,AMP(135))
C     Amplitude(s) for diagram number 116
      CALL FFV1_0(W(1,3),W(1,14),W(1,13),GC_11,AMP(136))
      CALL FFV1_0(W(1,3),W(1,14),W(1,25),GC_11,AMP(137))
      CALL FFV1_0(W(1,3),W(1,14),W(1,22),GC_11,AMP(138))
      CALL VVVV1P0_1(W(1,1),W(1,2),W(1,6),GC_12,ZERO,ZERO,W(1,22))
      CALL VVVV3P0_1(W(1,1),W(1,2),W(1,6),GC_12,ZERO,ZERO,W(1,14))
      CALL VVVV4P0_1(W(1,1),W(1,2),W(1,6),GC_12,ZERO,ZERO,W(1,25))
C     Amplitude(s) for diagram number 117
      CALL VVV1_0(W(1,22),W(1,8),W(1,5),GC_10,AMP(139))
      CALL VVV1_0(W(1,14),W(1,8),W(1,5),GC_10,AMP(140))
      CALL VVV1_0(W(1,25),W(1,8),W(1,5),GC_10,AMP(141))
C     Amplitude(s) for diagram number 118
      CALL FFV1_0(W(1,12),W(1,4),W(1,22),GC_11,AMP(142))
      CALL FFV1_0(W(1,12),W(1,4),W(1,14),GC_11,AMP(143))
      CALL FFV1_0(W(1,12),W(1,4),W(1,25),GC_11,AMP(144))
C     Amplitude(s) for diagram number 119
      CALL FFV1_0(W(1,3),W(1,16),W(1,22),GC_11,AMP(145))
      CALL FFV1_0(W(1,3),W(1,16),W(1,14),GC_11,AMP(146))
      CALL FFV1_0(W(1,3),W(1,16),W(1,25),GC_11,AMP(147))
      CALL VVVV1P0_1(W(1,1),W(1,5),W(1,6),GC_12,ZERO,ZERO,W(1,25))
      CALL VVVV3P0_1(W(1,1),W(1,5),W(1,6),GC_12,ZERO,ZERO,W(1,16))
      CALL VVVV4P0_1(W(1,1),W(1,5),W(1,6),GC_12,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 120
      CALL FFV1_0(W(1,10),W(1,4),W(1,25),GC_11,AMP(148))
      CALL FFV1_0(W(1,10),W(1,4),W(1,16),GC_11,AMP(149))
      CALL FFV1_0(W(1,10),W(1,4),W(1,14),GC_11,AMP(150))
C     Amplitude(s) for diagram number 121
      CALL FFV1_0(W(1,3),W(1,17),W(1,25),GC_11,AMP(151))
      CALL FFV1_0(W(1,3),W(1,17),W(1,16),GC_11,AMP(152))
      CALL FFV1_0(W(1,3),W(1,17),W(1,14),GC_11,AMP(153))
C     Amplitude(s) for diagram number 122
      CALL VVV1_0(W(1,25),W(1,2),W(1,8),GC_10,AMP(154))
      CALL VVV1_0(W(1,16),W(1,2),W(1,8),GC_10,AMP(155))
      CALL VVV1_0(W(1,14),W(1,2),W(1,8),GC_10,AMP(156))
C     Amplitude(s) for diagram number 123
      CALL VVV1_0(W(1,1),W(1,18),W(1,8),GC_10,AMP(157))
      CALL VVV1_0(W(1,1),W(1,20),W(1,8),GC_10,AMP(158))
      CALL VVV1_0(W(1,1),W(1,9),W(1,8),GC_10,AMP(159))
      JAMP(1)=-IMAG1*AMP(1)-IMAG1*AMP(2)-IMAG1*AMP(4)-IMAG1*AMP(6)
     $ -IMAG1*AMP(10)-AMP(11)-AMP(18)-AMP(40)-IMAG1*AMP(42)+AMP(48)
     $ -IMAG1*AMP(50)-AMP(51)+AMP(54)-AMP(52)-IMAG1*AMP(103)-IMAG1
     $ *AMP(104)-IMAG1*AMP(106)-IMAG1*AMP(107)-AMP(108)-IMAG1*AMP(121)
     $ -IMAG1*AMP(122)-IMAG1*AMP(124)-IMAG1*AMP(130)+IMAG1*AMP(132)
     $ +AMP(135)-AMP(133)+IMAG1*AMP(157)-IMAG1*AMP(159)
      JAMP(2)=+IMAG1*AMP(1)-IMAG1*AMP(3)-IMAG1*AMP(5)+IMAG1*AMP(6)
     $ -IMAG1*AMP(7)-AMP(8)+AMP(18)-AMP(43)-IMAG1*AMP(45)+AMP(46)
     $ +IMAG1*AMP(50)+AMP(51)+AMP(53)+AMP(52)-IMAG1*AMP(112)-IMAG1
     $ *AMP(113)-IMAG1*AMP(115)-IMAG1*AMP(116)-AMP(117)+IMAG1*AMP(121)
     $ +IMAG1*AMP(122)+IMAG1*AMP(124)-IMAG1*AMP(139)+IMAG1*AMP(141)
     $ +AMP(144)-AMP(142)-IMAG1*AMP(158)-IMAG1*AMP(157)
      JAMP(3)=+AMP(40)+IMAG1*AMP(42)+AMP(43)-IMAG1*AMP(44)+AMP(49)
     $ -AMP(54)-AMP(53)-AMP(62)+IMAG1*AMP(63)-IMAG1*AMP(64)-IMAG1
     $ *AMP(65)-IMAG1*AMP(67)-AMP(69)-IMAG1*AMP(70)+IMAG1*AMP(103)
     $ +IMAG1*AMP(104)+IMAG1*AMP(106)+IMAG1*AMP(107)+AMP(108)+IMAG1
     $ *AMP(113)+IMAG1*AMP(114)+IMAG1*AMP(116)+IMAG1*AMP(131)+IMAG1
     $ *AMP(130)+AMP(134)+AMP(133)+IMAG1*AMP(158)+IMAG1*AMP(159)
      JAMP(4)=+AMP(37)-IMAG1*AMP(39)-AMP(43)+IMAG1*AMP(44)+AMP(51)
     $ +AMP(53)+AMP(52)-IMAG1*AMP(55)-AMP(56)+AMP(62)-IMAG1*AMP(63)
     $ +IMAG1*AMP(65)+IMAG1*AMP(66)+IMAG1*AMP(68)-AMP(96)-IMAG1
     $ *AMP(113)-IMAG1*AMP(114)-IMAG1*AMP(116)+IMAG1*AMP(122)+IMAG1
     $ *AMP(123)+IMAG1*AMP(124)+IMAG1*AMP(125)+AMP(150)-AMP(148)+IMAG1
     $ *AMP(154)-IMAG1*AMP(156)-IMAG1*AMP(158)-IMAG1*AMP(157)
      JAMP(5)=+AMP(40)-IMAG1*AMP(41)+AMP(43)+IMAG1*AMP(45)+AMP(47)
     $ -AMP(54)-AMP(53)-AMP(80)+IMAG1*AMP(81)-IMAG1*AMP(82)-IMAG1
     $ *AMP(83)-IMAG1*AMP(85)-AMP(87)-IMAG1*AMP(88)+IMAG1*AMP(104)
     $ +IMAG1*AMP(105)+IMAG1*AMP(107)+IMAG1*AMP(112)+IMAG1*AMP(113)
     $ +IMAG1*AMP(115)+IMAG1*AMP(116)+AMP(117)+IMAG1*AMP(140)+IMAG1
     $ *AMP(139)+AMP(143)+AMP(142)+IMAG1*AMP(158)+IMAG1*AMP(159)
      JAMP(6)=+AMP(38)+IMAG1*AMP(39)-AMP(40)+IMAG1*AMP(41)-AMP(51)
     $ +AMP(54)-AMP(52)-IMAG1*AMP(73)-AMP(74)+AMP(80)-IMAG1*AMP(81)
     $ +IMAG1*AMP(83)+IMAG1*AMP(84)+IMAG1*AMP(86)+AMP(96)-IMAG1
     $ *AMP(104)-IMAG1*AMP(105)-IMAG1*AMP(107)-IMAG1*AMP(122)-IMAG1
     $ *AMP(123)-IMAG1*AMP(124)-IMAG1*AMP(125)+AMP(149)+AMP(148)-IMAG1
     $ *AMP(155)-IMAG1*AMP(154)+IMAG1*AMP(157)-IMAG1*AMP(159)
      JAMP(7)=+IMAG1*AMP(1)+IMAG1*AMP(2)+IMAG1*AMP(4)+IMAG1*AMP(6)
     $ +IMAG1*AMP(10)+AMP(11)+AMP(18)-AMP(59)-IMAG1*AMP(60)+IMAG1
     $ *AMP(64)-IMAG1*AMP(66)+IMAG1*AMP(67)-IMAG1*AMP(68)+AMP(69)
     $ +AMP(99)-IMAG1*AMP(101)-AMP(102)+IMAG1*AMP(121)-IMAG1*AMP(123)
     $ -IMAG1*AMP(125)-IMAG1*AMP(131)-IMAG1*AMP(132)-AMP(135)-AMP(134)
     $ +AMP(153)-AMP(151)-IMAG1*AMP(154)+IMAG1*AMP(156)
      JAMP(8)=-IMAG1*AMP(1)+IMAG1*AMP(3)+IMAG1*AMP(5)-IMAG1*AMP(6)
     $ +IMAG1*AMP(7)+AMP(8)-AMP(18)-AMP(77)-IMAG1*AMP(78)+IMAG1*AMP(82)
     $ -IMAG1*AMP(84)+IMAG1*AMP(85)-IMAG1*AMP(86)+AMP(87)+AMP(97)
     $ +IMAG1*AMP(101)+AMP(102)-IMAG1*AMP(121)+IMAG1*AMP(123)+IMAG1
     $ *AMP(125)-IMAG1*AMP(140)-IMAG1*AMP(141)-AMP(144)-AMP(143)
     $ +AMP(152)+AMP(151)+IMAG1*AMP(155)+IMAG1*AMP(154)
      JAMP(9)=+AMP(59)+IMAG1*AMP(60)-IMAG1*AMP(64)+IMAG1*AMP(66)-IMAG1
     $ *AMP(67)+IMAG1*AMP(68)-AMP(69)-IMAG1*AMP(76)+AMP(77)-AMP(79)
     $ -IMAG1*AMP(81)+IMAG1*AMP(83)+IMAG1*AMP(84)+IMAG1*AMP(86)
     $ +AMP(100)+IMAG1*AMP(103)-IMAG1*AMP(105)+IMAG1*AMP(106)+AMP(108)
     $ -IMAG1*AMP(109)+IMAG1*AMP(131)+IMAG1*AMP(130)+AMP(134)+AMP(133)
     $ -AMP(153)-AMP(152)-IMAG1*AMP(155)-IMAG1*AMP(156)
      JAMP(10)=+AMP(20)-IMAG1*AMP(21)-AMP(22)-IMAG1*AMP(23)-AMP(33)
     $ +AMP(36)-AMP(34)+IMAG1*AMP(76)-AMP(77)+AMP(79)+IMAG1*AMP(81)
     $ -IMAG1*AMP(83)-IMAG1*AMP(84)-IMAG1*AMP(86)+AMP(102)+IMAG1
     $ *AMP(104)+IMAG1*AMP(105)+IMAG1*AMP(107)+IMAG1*AMP(122)+IMAG1
     $ *AMP(123)+IMAG1*AMP(124)+IMAG1*AMP(125)+AMP(152)+AMP(151)+IMAG1
     $ *AMP(155)+IMAG1*AMP(154)-IMAG1*AMP(157)+IMAG1*AMP(159)
      JAMP(11)=-IMAG1*AMP(58)+AMP(59)-AMP(61)-IMAG1*AMP(63)+IMAG1
     $ *AMP(65)+IMAG1*AMP(66)+IMAG1*AMP(68)+AMP(77)+IMAG1*AMP(78)
     $ -IMAG1*AMP(82)+IMAG1*AMP(84)-IMAG1*AMP(85)+IMAG1*AMP(86)-AMP(87)
     $ +AMP(98)+IMAG1*AMP(112)-IMAG1*AMP(114)+IMAG1*AMP(115)+AMP(117)
     $ -IMAG1*AMP(118)+IMAG1*AMP(140)+IMAG1*AMP(139)+AMP(143)+AMP(142)
     $ -AMP(153)-AMP(152)-IMAG1*AMP(155)-IMAG1*AMP(156)
      JAMP(12)=+AMP(19)+IMAG1*AMP(21)-AMP(25)-IMAG1*AMP(26)+AMP(33)
     $ +AMP(35)+AMP(34)+IMAG1*AMP(58)-AMP(59)+AMP(61)+IMAG1*AMP(63)
     $ -IMAG1*AMP(65)-IMAG1*AMP(66)-IMAG1*AMP(68)-AMP(102)+IMAG1
     $ *AMP(113)+IMAG1*AMP(114)+IMAG1*AMP(116)-IMAG1*AMP(122)-IMAG1
     $ *AMP(123)-IMAG1*AMP(124)-IMAG1*AMP(125)+AMP(153)-AMP(151)-IMAG1
     $ *AMP(154)+IMAG1*AMP(156)+IMAG1*AMP(158)+IMAG1*AMP(157)
      JAMP(13)=+IMAG1*AMP(2)+IMAG1*AMP(3)+IMAG1*AMP(4)+IMAG1*AMP(5)
     $ +AMP(11)-IMAG1*AMP(12)-AMP(14)+AMP(62)-IMAG1*AMP(63)+IMAG1
     $ *AMP(64)+IMAG1*AMP(65)+IMAG1*AMP(67)+AMP(69)+IMAG1*AMP(70)
     $ +IMAG1*AMP(112)-IMAG1*AMP(114)+IMAG1*AMP(115)-AMP(119)-IMAG1
     $ *AMP(120)+AMP(129)-IMAG1*AMP(131)-IMAG1*AMP(132)-AMP(135)
     $ -AMP(134)+IMAG1*AMP(139)-IMAG1*AMP(141)+AMP(147)-AMP(145)
      JAMP(14)=+IMAG1*AMP(55)+AMP(56)-AMP(62)+IMAG1*AMP(63)-IMAG1
     $ *AMP(65)-IMAG1*AMP(66)-IMAG1*AMP(68)+AMP(74)-IMAG1*AMP(75)
     $ +IMAG1*AMP(82)-IMAG1*AMP(84)+IMAG1*AMP(85)-IMAG1*AMP(86)-AMP(89)
     $ +AMP(92)-IMAG1*AMP(112)+IMAG1*AMP(114)-IMAG1*AMP(115)+AMP(119)
     $ +IMAG1*AMP(120)-IMAG1*AMP(140)-IMAG1*AMP(139)+AMP(146)+AMP(145)
     $ -AMP(150)-AMP(149)+IMAG1*AMP(155)+IMAG1*AMP(156)
      JAMP(15)=-IMAG1*AMP(2)-IMAG1*AMP(3)-IMAG1*AMP(4)-IMAG1*AMP(5)
     $ -AMP(11)+IMAG1*AMP(12)+AMP(14)+AMP(79)+IMAG1*AMP(81)-IMAG1
     $ *AMP(82)-IMAG1*AMP(83)-IMAG1*AMP(85)+AMP(89)-IMAG1*AMP(90)
     $ -IMAG1*AMP(103)+IMAG1*AMP(105)-IMAG1*AMP(106)-AMP(108)+IMAG1
     $ *AMP(109)+AMP(128)-IMAG1*AMP(130)+IMAG1*AMP(132)+AMP(135)
     $ -AMP(133)+IMAG1*AMP(140)+IMAG1*AMP(141)-AMP(147)-AMP(146)
      JAMP(16)=+AMP(22)+IMAG1*AMP(23)+AMP(25)-IMAG1*AMP(27)+AMP(29)
     $ -AMP(36)-AMP(35)-AMP(79)-IMAG1*AMP(81)+IMAG1*AMP(82)+IMAG1
     $ *AMP(83)+IMAG1*AMP(85)-AMP(89)+IMAG1*AMP(90)-IMAG1*AMP(104)
     $ -IMAG1*AMP(105)-IMAG1*AMP(107)-IMAG1*AMP(112)-IMAG1*AMP(113)
     $ -IMAG1*AMP(115)-IMAG1*AMP(116)+AMP(119)-IMAG1*AMP(140)-IMAG1
     $ *AMP(139)+AMP(146)+AMP(145)-IMAG1*AMP(158)-IMAG1*AMP(159)
      JAMP(17)=+IMAG1*AMP(1)-IMAG1*AMP(3)-IMAG1*AMP(5)+IMAG1*AMP(6)
     $ -IMAG1*AMP(13)+AMP(14)-AMP(17)-AMP(74)+IMAG1*AMP(75)-IMAG1
     $ *AMP(82)+IMAG1*AMP(84)-IMAG1*AMP(85)+IMAG1*AMP(86)+AMP(89)
     $ +AMP(91)-IMAG1*AMP(95)+AMP(96)+IMAG1*AMP(121)-IMAG1*AMP(123)
     $ -IMAG1*AMP(125)+IMAG1*AMP(140)+IMAG1*AMP(141)-AMP(147)-AMP(146)
     $ +AMP(149)+AMP(148)-IMAG1*AMP(155)-IMAG1*AMP(154)
      JAMP(18)=-IMAG1*AMP(1)+IMAG1*AMP(3)+IMAG1*AMP(5)-IMAG1*AMP(6)
     $ +IMAG1*AMP(13)-AMP(14)+AMP(17)-AMP(25)+IMAG1*AMP(27)+AMP(28)
     $ -IMAG1*AMP(32)+AMP(33)+AMP(35)+AMP(34)+IMAG1*AMP(112)+IMAG1
     $ *AMP(113)+IMAG1*AMP(115)+IMAG1*AMP(116)-AMP(119)-IMAG1*AMP(121)
     $ -IMAG1*AMP(122)-IMAG1*AMP(124)+IMAG1*AMP(139)-IMAG1*AMP(141)
     $ +AMP(147)-AMP(145)+IMAG1*AMP(158)+IMAG1*AMP(157)
      JAMP(19)=+IMAG1*AMP(2)+IMAG1*AMP(3)+IMAG1*AMP(4)+IMAG1*AMP(5)
     $ +AMP(8)-IMAG1*AMP(9)-AMP(16)+AMP(80)-IMAG1*AMP(81)+IMAG1*AMP(82)
     $ +IMAG1*AMP(83)+IMAG1*AMP(85)+AMP(87)+IMAG1*AMP(88)+IMAG1
     $ *AMP(103)-IMAG1*AMP(105)+IMAG1*AMP(106)-AMP(110)-IMAG1*AMP(111)
     $ +AMP(127)+IMAG1*AMP(130)-IMAG1*AMP(132)+AMP(138)-AMP(136)-IMAG1
     $ *AMP(140)-IMAG1*AMP(141)-AMP(144)-AMP(143)
      JAMP(20)=+AMP(56)-IMAG1*AMP(57)+IMAG1*AMP(64)-IMAG1*AMP(66)
     $ +IMAG1*AMP(67)-IMAG1*AMP(68)-AMP(71)+IMAG1*AMP(73)+AMP(74)
     $ -AMP(80)+IMAG1*AMP(81)-IMAG1*AMP(83)-IMAG1*AMP(84)-IMAG1*AMP(86)
     $ +AMP(94)-IMAG1*AMP(103)+IMAG1*AMP(105)-IMAG1*AMP(106)+AMP(110)
     $ +IMAG1*AMP(111)-IMAG1*AMP(131)-IMAG1*AMP(130)+AMP(137)+AMP(136)
     $ -AMP(150)-AMP(149)+IMAG1*AMP(155)+IMAG1*AMP(156)
      JAMP(21)=-IMAG1*AMP(2)-IMAG1*AMP(3)-IMAG1*AMP(4)-IMAG1*AMP(5)
     $ -AMP(8)+IMAG1*AMP(9)+AMP(16)+AMP(61)+IMAG1*AMP(63)-IMAG1*AMP(64)
     $ -IMAG1*AMP(65)-IMAG1*AMP(67)+AMP(71)-IMAG1*AMP(72)-IMAG1
     $ *AMP(112)+IMAG1*AMP(114)-IMAG1*AMP(115)-AMP(117)+IMAG1*AMP(118)
     $ +AMP(126)+IMAG1*AMP(131)+IMAG1*AMP(132)-AMP(138)-AMP(137)-IMAG1
     $ *AMP(139)+IMAG1*AMP(141)+AMP(144)-AMP(142)
      JAMP(22)=+AMP(22)-IMAG1*AMP(24)+AMP(25)+IMAG1*AMP(26)+AMP(31)
     $ -AMP(36)-AMP(35)-AMP(61)-IMAG1*AMP(63)+IMAG1*AMP(64)+IMAG1
     $ *AMP(65)+IMAG1*AMP(67)-AMP(71)+IMAG1*AMP(72)-IMAG1*AMP(103)
     $ -IMAG1*AMP(104)-IMAG1*AMP(106)-IMAG1*AMP(107)+AMP(110)-IMAG1
     $ *AMP(113)-IMAG1*AMP(114)-IMAG1*AMP(116)-IMAG1*AMP(131)-IMAG1
     $ *AMP(130)+AMP(137)+AMP(136)-IMAG1*AMP(158)-IMAG1*AMP(159)
      JAMP(23)=-IMAG1*AMP(1)-IMAG1*AMP(2)-IMAG1*AMP(4)-IMAG1*AMP(6)
     $ -IMAG1*AMP(15)+AMP(16)+AMP(17)-AMP(56)+IMAG1*AMP(57)-IMAG1
     $ *AMP(64)+IMAG1*AMP(66)-IMAG1*AMP(67)+IMAG1*AMP(68)+AMP(71)
     $ +AMP(93)+IMAG1*AMP(95)-AMP(96)-IMAG1*AMP(121)+IMAG1*AMP(123)
     $ +IMAG1*AMP(125)+IMAG1*AMP(131)+IMAG1*AMP(132)-AMP(138)-AMP(137)
     $ +AMP(150)-AMP(148)+IMAG1*AMP(154)-IMAG1*AMP(156)
      JAMP(24)=+IMAG1*AMP(1)+IMAG1*AMP(2)+IMAG1*AMP(4)+IMAG1*AMP(6)
     $ +IMAG1*AMP(15)-AMP(16)-AMP(17)-AMP(22)+IMAG1*AMP(24)+AMP(30)
     $ +IMAG1*AMP(32)-AMP(33)+AMP(36)-AMP(34)+IMAG1*AMP(103)+IMAG1
     $ *AMP(104)+IMAG1*AMP(106)+IMAG1*AMP(107)-AMP(110)+IMAG1*AMP(121)
     $ +IMAG1*AMP(122)+IMAG1*AMP(124)+IMAG1*AMP(130)-IMAG1*AMP(132)
     $ +AMP(138)-AMP(136)-IMAG1*AMP(157)+IMAG1*AMP(159)

C...VINCIA: Leading Color for Diagonal Entry ICOL
      gg_dxdgg = CF(ICOL,ICOL)*JAMP(ICOL)
     &         *DCONJG(JAMP(ICOL))/DENOM(ICOL)
C...VINCIA: Absorb subleading color proportional to FSLC = LC/Sum(LC)
      IF (MCMODE.EQ.0) RETURN
      IF (MCMODE.EQ.1.AND.gg_dxdgg.LE.ZERO) RETURN
        ZLCSUM = 0D0
        DO I = 1, NCOLOR
          ZLCSUM = ZLCSUM + CF(I,I)*JAMP(I)*DCONJG(JAMP(I))/DENOM(I)
        ENDDO
C...VINCIA: MCMODE = 2 returns full colour-summed ME
        IF (MCMODE.EQ.2) gg_dxdgg = ZLCSUM
C...VINCIA: Fraction of subleading color to absorb into this permutation
        FSLC = gg_dxdgg/ZLCSUM
C...VINCIA: Sum over subleading contributions multiplied by FSLC
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          IF (I.NE.J) ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
        ENDDO
        gg_dxdgg = gg_dxdgg+FSLC*ZTEMP*DCONJG(JAMP(I))/DENOM(I)
      ENDDO

      END

      SUBROUTINE GETgg_dxdgg(MCMODE,ICOL,P, ALPHAS, NHEL ,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL
      DOUBLE PRECISION ALPHAS
      DOUBLE PRECISION PI
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: NHEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
CF2PY INTENT(IN) :: ALPHAS
C     ROUTINE FOR F2PY to read the benchmark point.    
C     the include file with the values of the parameters and masses 
      INCLUDE 'coupl.inc'

      PI = 3.141592653589793D0
      G = 2* DSQRT(ALPHAS*PI)
C...VINCIA: only static MG couplings are interfaced
C      CALL UPDATE_AS_PARAM()
      IF (NHEL.NE.0) THEN
        CALL SHELgg_dxdgg(MCMODE,ICOL,P, NHEL, ANS)
      ELSE
        CALL Sgg_dxdgg(MCMODE,ICOL,P, ANS)
      ENDIF
      RETURN
      END


