C...gg_uxdxdug.f is a part of the VINCIA event generator.
C...This file was generated by MADGRAPH 5
C...Modified by VINCIA Thu  8 Jun 2017 15:37:51 CEST
C...VINCIA is licenced under the GNU GPL version 2.
C...Copyright (C) 2019 Peter Skands
C...Please respect the work of the MadGraph authors by
C...citing MadGraph 5 when this part of VINCIA is used.
C...See: https://arxiv.org/abs/1106.0522
 
      SUBROUTINE SHELgg_uxdxdug(MCMODE,ICOL,P,HEL,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=128)
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: HEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)

C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER HEL
C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C     ----------
C     BEGIN CODE
C     ----------
      USERHEL=HEL
      CALL Sgg_uxdxdug(MCMODE,ICOL,P,ANS)
      USERHEL=-1

      END

      SUBROUTINE Sgg_uxdxdug(MCMODE,ICOL,P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO StandAlone Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: g g > u~ d~ d u g WEIGHTED<=5 @310
C     Process: g g > s~ d~ d s g WEIGHTED<=5 @310
C     Process: g g > c~ d~ d c g WEIGHTED<=5 @310
C     Process: g g > s~ u~ u s g WEIGHTED<=5 @310
C     Process: g g > c~ u~ u c g WEIGHTED<=5 @310
C     Process: g g > c~ s~ s c g WEIGHTED<=5 @310
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
      INTEGER    NINITIAL
      PARAMETER (NINITIAL=2)
      INTEGER NPOLENTRIES
      PARAMETER (NPOLENTRIES=(NEXTERNAL+1)*6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=128)
      INTEGER HELAVGFACTOR
      PARAMETER (HELAVGFACTOR=4)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      DOUBLE PRECISION T
      DOUBLE PRECISION gg_uxdxdug
      INTEGER IHEL,IDEN, I, J
C     For a 1>N process, them BEAMTWO_HELAVGFACTOR would be set to 1.
      INTEGER BEAMS_HELAVGFACTOR(2)
      DATA (BEAMS_HELAVGFACTOR(I),I=1,2)/2,2/
      INTEGER JC(NEXTERNAL)
      LOGICAL GOODHEL(NCOMB)
      DATA NTRY/0/
      DATA GOODHEL/NCOMB*.FALSE./

C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C...VINCIA: USERHEL is initialised by MG5interface
C      DATA USERHEL/-1/

      DATA (NHEL(I,   1),I=1,7) /-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,   2),I=1,7) /-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,   3),I=1,7) /-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,   4),I=1,7) /-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,   5),I=1,7) /-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,   6),I=1,7) /-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,   7),I=1,7) /-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,   8),I=1,7) /-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,   9),I=1,7) /-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  10),I=1,7) /-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  11),I=1,7) /-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  12),I=1,7) /-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  13),I=1,7) /-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  14),I=1,7) /-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  15),I=1,7) /-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  16),I=1,7) /-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  17),I=1,7) /-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  18),I=1,7) /-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  19),I=1,7) /-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  20),I=1,7) /-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  21),I=1,7) /-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  22),I=1,7) /-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  23),I=1,7) /-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  24),I=1,7) /-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  25),I=1,7) /-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  26),I=1,7) /-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  27),I=1,7) /-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  28),I=1,7) /-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  29),I=1,7) /-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  30),I=1,7) /-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  31),I=1,7) /-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  32),I=1,7) /-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  33),I=1,7) /-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  34),I=1,7) /-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  35),I=1,7) /-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  36),I=1,7) /-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  37),I=1,7) /-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  38),I=1,7) /-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  39),I=1,7) /-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  40),I=1,7) /-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  41),I=1,7) /-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  42),I=1,7) /-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  43),I=1,7) /-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  44),I=1,7) /-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  45),I=1,7) /-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  46),I=1,7) /-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  47),I=1,7) /-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  48),I=1,7) /-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  49),I=1,7) /-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  50),I=1,7) /-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  51),I=1,7) /-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  52),I=1,7) /-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  53),I=1,7) /-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  54),I=1,7) /-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  55),I=1,7) /-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  56),I=1,7) /-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  57),I=1,7) /-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  58),I=1,7) /-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  59),I=1,7) /-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  60),I=1,7) /-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  61),I=1,7) /-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  62),I=1,7) /-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  63),I=1,7) /-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  64),I=1,7) /-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  65),I=1,7) / 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  66),I=1,7) / 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  67),I=1,7) / 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  68),I=1,7) / 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  69),I=1,7) / 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  70),I=1,7) / 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  71),I=1,7) / 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  72),I=1,7) / 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  73),I=1,7) / 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  74),I=1,7) / 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  75),I=1,7) / 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  76),I=1,7) / 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  77),I=1,7) / 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  78),I=1,7) / 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  79),I=1,7) / 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  80),I=1,7) / 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  81),I=1,7) / 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  82),I=1,7) / 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  83),I=1,7) / 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  84),I=1,7) / 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  85),I=1,7) / 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  86),I=1,7) / 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  87),I=1,7) / 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  88),I=1,7) / 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  89),I=1,7) / 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  90),I=1,7) / 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  91),I=1,7) / 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  92),I=1,7) / 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  93),I=1,7) / 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  94),I=1,7) / 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  95),I=1,7) / 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  96),I=1,7) / 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  97),I=1,7) / 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  98),I=1,7) / 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  99),I=1,7) / 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I, 100),I=1,7) / 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I, 101),I=1,7) / 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I, 102),I=1,7) / 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I, 103),I=1,7) / 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I, 104),I=1,7) / 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I, 105),I=1,7) / 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I, 106),I=1,7) / 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I, 107),I=1,7) / 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I, 108),I=1,7) / 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I, 109),I=1,7) / 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I, 110),I=1,7) / 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I, 111),I=1,7) / 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I, 112),I=1,7) / 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I, 113),I=1,7) / 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I, 114),I=1,7) / 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I, 115),I=1,7) / 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I, 116),I=1,7) / 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I, 117),I=1,7) / 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I, 118),I=1,7) / 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I, 119),I=1,7) / 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I, 120),I=1,7) / 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I, 121),I=1,7) / 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I, 122),I=1,7) / 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I, 123),I=1,7) / 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I, 124),I=1,7) / 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I, 125),I=1,7) / 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I, 126),I=1,7) / 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I, 127),I=1,7) / 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I, 128),I=1,7) / 1, 1,-1,-1, 1, 1, 1/
      DATA IDEN/256/

      INTEGER POLARIZATIONS(0:NEXTERNAL,0:5)
      DATA ((POLARIZATIONS(I,J),I=0,NEXTERNAL),J=0,5)/NPOLENTRIES*-1/
C...Vincia: BORN_BEAM_POL not used (POLARIZATIONS local and = -1)
C      COMMON/BORN_BEAM_POL/POLARIZATIONS
C     
C     FUNCTIONS
C     
C...Vincia conversion hardcodes for IS_BORN_HEL_SELECTED = .TRUE.
C      LOGICAL IS_BORN_HEL_SELECTED

C     ----------
C     BEGIN CODE
C     ----------
      IF(USERHEL.EQ.-1) NTRY=0
C...(VINCIA: no NTRY optimisation)
      DO IHEL=1,NEXTERNAL
        JC(IHEL) = +1
      ENDDO
C     When spin-2 particles are involved, the Helicity filtering is
C      dangerous for the 2->1 topology.
C     This is because depending on the MC setup the initial PS points
C      have back-to-back initial states
C     for which some of the spin-2 helicity configurations are zero.
C      But they are no longer zero
C     if the point is boosted on the z-axis. Remember that HELAS
C      helicity amplitudes are no longer
C     lorentz invariant with expternal spin-2 particles (only the
C      helicity sum is).
C     For this reason, we simply remove the filterin when there is
C      only three external particles.
      IF (NEXTERNAL.LE.3) THEN
        DO IHEL=1,NCOMB
          GOODHEL(IHEL)=.TRUE.
        ENDDO
      ENDIF
      ANS = 0D0
      DO IHEL=1,NCOMB
        IF (USERHEL.EQ.-1.OR.USERHEL.EQ.IHEL) THEN
          IF (GOODHEL(IHEL) .OR. NTRY .LT. 20.OR.USERHEL.NE.-1) THEN
            IF(NTRY.GE.2.AND.POLARIZATIONS(0,0).NE.
     $       -1.AND.(.FALSE.)) THEN
              CYCLE
            ENDIF
            T=gg_uxdxdug(MCMODE,ICOL,P ,NHEL(1,IHEL),JC(1))
            IF(POLARIZATIONS(0,0).EQ.-1.OR..TRUE.)
     $        THEN
              ANS=ANS+T
            ENDIF
            IF (T .NE. 0D0 .AND. .NOT.    GOODHEL(IHEL)) THEN
              GOODHEL(IHEL)=.TRUE.
            ENDIF
          ENDIF
        ENDIF
      ENDDO

C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/DBLE(IDEN)
      IF(USERHEL.NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
        ANS=ANS*HELAVGFACTOR
      ELSE
        DO J=1,NINITIAL
          IF (POLARIZATIONS(J,0).NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
            ANS=ANS*BEAMS_HELAVGFACTOR(J)
      
C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/POLARIZATIONS(J,0)
          ENDIF
        ENDDO
      ENDIF
      END


      DOUBLE PRECISION FUNCTION gg_uxdxdug(MCMODE,ICOL,P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: g g > u~ d~ d u g WEIGHTED<=5 @310
C     Process: g g > s~ d~ d s g WEIGHTED<=5 @310
C     Process: g g > c~ d~ d c g WEIGHTED<=5 @310
C     Process: g g > s~ u~ u s g WEIGHTED<=5 @310
C     Process: g g > c~ u~ u c g WEIGHTED<=5 @310
C     Process: g g > c~ s~ s c g WEIGHTED<=5 @310
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=393)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
      INTEGER    NWAVEFUNCS, NCOLOR
      PARAMETER (NWAVEFUNCS=54, NCOLOR=48)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
      DOUBLE PRECISION ZLCSUM, FSLC
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J
      COMPLEX*16 ZTEMP
      DOUBLE PRECISION DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(20,NWAVEFUNCS)
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'

C     
C     COLOR DATA
C     
      DATA DENOM(1)/9/
      DATA (CF(I,  1),I=  1,  6) /  192,   64,   64,   21,    0,   64/
      DATA (CF(I,  1),I=  7, 12) /    1,   24,    0,    0,   -8,   64/
      DATA (CF(I,  1),I= 13, 18) /   -8,    1,   -3,   24,    0,   -8/
      DATA (CF(I,  1),I= 19, 24) /   -8,   -3,   24,   64,    1,    0/
      DATA (CF(I,  1),I= 25, 30) /  -24,   -8,   -8,   -6,    0,   -8/
      DATA (CF(I,  1),I= 31, 36) /   10,   24,    0,   -8,   -8,   -3/
      DATA (CF(I,  1),I= 37, 42) /    0,    1,    1,   -3,   24,   24/
      DATA (CF(I,  1),I= 43, 48) /   64,   -8,    1,   10,    0,    0/
C     1 T(1,2,5,3) T(7,6,4)
      DATA DENOM(2)/9/
      DATA (CF(I,  2),I=  1,  6) /   64,  192,   21,   64,   64,    0/
      DATA (CF(I,  2),I=  7, 12) /   24,    1,   -8,   64,    0,    0/
      DATA (CF(I,  2),I= 13, 18) /   -3,   24,   -8,    1,   -8,    0/
      DATA (CF(I,  2),I= 19, 24) /   -3,   -8,   64,   24,    0,    1/
      DATA (CF(I,  2),I= 25, 30) /   -8,  -24,   -6,   -8,   -8,    0/
      DATA (CF(I,  2),I= 31, 36) /   24,   10,   -8,    0,   -3,   -8/
      DATA (CF(I,  2),I= 37, 42) /    1,    0,   -3,    1,   64,   -8/
      DATA (CF(I,  2),I= 43, 48) /   24,   24,    0,    0,    1,   10/
C     1 T(1,2,5,4) T(7,6,3)
      DATA DENOM(3)/9/
      DATA (CF(I,  3),I=  1,  6) /   64,   21,  192,   64,    1,   24/
      DATA (CF(I,  3),I=  7, 12) /    0,   64,   -8,    1,   -3,   24/
      DATA (CF(I,  3),I= 13, 18) /    0,    0,   -8,   64,   -8,   -3/
      DATA (CF(I,  3),I= 19, 24) /    0,   -8,    1,    0,   24,   64/
      DATA (CF(I,  3),I= 25, 30) /   -8,   -6,  -24,   -8,   10,   24/
      DATA (CF(I,  3),I= 31, 36) /    0,   -8,   -8,   -3,    0,   -8/
      DATA (CF(I,  3),I= 37, 42) /    1,   -3,    0,    1,    1,   10/
      DATA (CF(I,  3),I= 43, 48) /    0,    0,   24,   24,   64,   -8/
C     1 T(1,2,6,3) T(7,5,4)
      DATA DENOM(4)/9/
      DATA (CF(I,  4),I=  1,  6) /   21,   64,   64,  192,   24,    1/
      DATA (CF(I,  4),I=  7, 12) /   64,    0,   -3,   24,   -8,    1/
      DATA (CF(I,  4),I= 13, 18) /   -8,   64,    0,    0,   -3,   -8/
      DATA (CF(I,  4),I= 19, 24) /   -8,    0,    0,    1,   64,   24/
      DATA (CF(I,  4),I= 25, 30) /   -6,   -8,   -8,  -24,   24,   10/
      DATA (CF(I,  4),I= 31, 36) /   -8,    0,   -3,   -8,   -8,    0/
      DATA (CF(I,  4),I= 37, 42) /   -3,    1,    1,    0,    0,    0/
      DATA (CF(I,  4),I= 43, 48) /    1,   10,   64,   -8,   24,   24/
C     1 T(1,2,6,4) T(7,5,3)
      DATA DENOM(5)/9/
      DATA (CF(I,  5),I=  1,  6) /    0,   64,    1,   24,  192,   64/
      DATA (CF(I,  5),I=  7, 12) /   64,   21,   24,   24,   64,   -8/
      DATA (CF(I,  5),I= 13, 18) /    1,   10,    0,    0,  -24,   -8/
      DATA (CF(I,  5),I= 19, 24) /   -8,   -6,    0,   -8,   -8,   -3/
      DATA (CF(I,  5),I= 25, 30) /    0,   -8,   10,   24,  -24,   -8/
      DATA (CF(I,  5),I= 31, 36) /   -8,   -6,   -3,    1,    1,    0/
      DATA (CF(I,  5),I= 37, 42) /    3,    1,    1,   21,   21,   -6/
      DATA (CF(I,  5),I= 43, 48) /    1,   10,    1,   10,    3,   30/
C     1 T(1,2,7,5,3) T(6,4)
      DATA DENOM(6)/9/
      DATA (CF(I,  6),I=  1,  6) /   64,    0,   24,    1,   64,  192/
      DATA (CF(I,  6),I=  7, 12) /   21,   64,   64,   -8,   24,   24/
      DATA (CF(I,  6),I= 13, 18) /    0,    0,    1,   10,   -8,  -24/
      DATA (CF(I,  6),I= 19, 24) /   -6,   -8,   -8,    0,   -3,   -8/
      DATA (CF(I,  6),I= 25, 30) /   -8,    0,   24,   10,   -8,  -24/
      DATA (CF(I,  6),I= 31, 36) /   -6,   -8,    1,   -3,    0,    1/
      DATA (CF(I,  6),I= 37, 42) /    1,    3,   21,    1,    1,   10/
      DATA (CF(I,  6),I= 43, 48) /   21,   -6,    3,   30,    1,   10/
C     1 T(1,2,7,5,4) T(6,3)
      DATA DENOM(7)/9/
      DATA (CF(I,  7),I=  1,  6) /    1,   24,    0,   64,   64,   21/
      DATA (CF(I,  7),I=  7, 12) /  192,   64,    1,   10,    0,    0/
      DATA (CF(I,  7),I= 13, 18) /   24,   24,   64,   -8,   -8,   -6/
      DATA (CF(I,  7),I= 19, 24) /  -24,   -8,   -8,   -3,    0,   -8/
      DATA (CF(I,  7),I= 25, 30) /   10,   24,    0,   -8,   -8,   -6/
      DATA (CF(I,  7),I= 31, 36) /  -24,   -8,    1,    0,   -3,    1/
      DATA (CF(I,  7),I= 37, 42) /    1,   21,    3,    1,    1,   10/
      DATA (CF(I,  7),I= 43, 48) /    3,   30,   21,   -6,    1,   10/
C     1 T(1,2,7,6,3) T(5,4)
      DATA DENOM(8)/9/
      DATA (CF(I,  8),I=  1,  6) /   24,    1,   64,    0,   21,   64/
      DATA (CF(I,  8),I=  7, 12) /   64,  192,    0,    0,    1,   10/
      DATA (CF(I,  8),I= 13, 18) /   64,   -8,   24,   24,   -6,   -8/
      DATA (CF(I,  8),I= 19, 24) /   -8,  -24,   -3,   -8,   -8,    0/
      DATA (CF(I,  8),I= 25, 30) /   24,   10,   -8,    0,   -6,   -8/
      DATA (CF(I,  8),I= 31, 36) /   -8,  -24,    0,    1,    1,   -3/
      DATA (CF(I,  8),I= 37, 42) /   21,    1,    1,    3,    3,   30/
      DATA (CF(I,  8),I= 43, 48) /    1,   10,    1,   10,   21,   -6/
C     1 T(1,2,7,6,4) T(5,3)
      DATA DENOM(9)/9/
      DATA (CF(I,  9),I=  1,  6) /    0,   -8,   -8,   -3,   24,   64/
      DATA (CF(I,  9),I=  7, 12) /    1,    0,  192,  -24,   64,   -8/
      DATA (CF(I,  9),I= 13, 18) /   64,   -8,   21,   -6,   24,   -8/
      DATA (CF(I,  9),I= 19, 24) /   10,    0,    0,   64,    1,   24/
      DATA (CF(I,  9),I= 25, 30) /    0,    1,   64,   24,   -3,   -8/
      DATA (CF(I,  9),I= 31, 36) /   -8,    0,   -3,   -8,   -8,    0/
      DATA (CF(I,  9),I= 37, 42) /   24,    1,   64,    0,    0,    0/
      DATA (CF(I,  9),I= 43, 48) /    1,   -8,    1,   10,   -3,   24/
C     1 T(1,5,3) T(2,7,6,4)
      DATA DENOM(10)/9/
      DATA (CF(I, 10),I=  1,  6) /    0,   64,    1,   24,   24,   -8/
      DATA (CF(I, 10),I=  7, 12) /   10,    0,  -24,  192,   -8,   64/
      DATA (CF(I, 10),I= 13, 18) /   -8,   64,   -6,   21,   24,   64/
      DATA (CF(I, 10),I= 19, 24) /    1,    0,    0,   -8,   -8,   -3/
      DATA (CF(I, 10),I= 25, 30) /    0,   -8,   -8,   -3,   -3,    1/
      DATA (CF(I, 10),I= 31, 36) /    1,    0,   24,   64,    1,    0/
      DATA (CF(I, 10),I= 37, 42) /   24,   10,   -8,    0,    0,    0/
      DATA (CF(I, 10),I= 43, 48) /   -8,   64,   -8,    1,   -3,   24/
C     1 T(1,5,3) T(7,2,6,4)
      DATA DENOM(11)/9/
      DATA (CF(I, 11),I=  1,  6) /   -8,    0,   -3,   -8,   64,   24/
      DATA (CF(I, 11),I=  7, 12) /    0,    1,   64,   -8,  192,  -24/
      DATA (CF(I, 11),I= 13, 18) /   21,   -6,   64,   -8,   -8,   24/
      DATA (CF(I, 11),I= 19, 24) /    0,   10,   64,    0,   24,    1/
      DATA (CF(I, 11),I= 25, 30) /    1,    0,   24,   64,   -8,   -3/
      DATA (CF(I, 11),I= 31, 36) /    0,   -8,   -8,   -3,    0,   -8/
      DATA (CF(I, 11),I= 37, 42) /    1,   24,    0,   64,    1,   -8/
      DATA (CF(I, 11),I= 43, 48) /    0,    0,   -3,   24,    1,   10/
C     1 T(1,5,4) T(2,7,6,3)
      DATA DENOM(12)/9/
      DATA (CF(I, 12),I=  1,  6) /   64,    0,   24,    1,   -8,   24/
      DATA (CF(I, 12),I=  7, 12) /    0,   10,   -8,   64,  -24,  192/
      DATA (CF(I, 12),I= 13, 18) /   -6,   21,   -8,   64,   64,   24/
      DATA (CF(I, 12),I= 19, 24) /    0,    1,   -8,    0,   -3,   -8/
      DATA (CF(I, 12),I= 25, 30) /   -8,    0,   -3,   -8,    1,   -3/
      DATA (CF(I, 12),I= 31, 36) /    0,    1,   64,   24,    0,    1/
      DATA (CF(I, 12),I= 37, 42) /   10,   24,    0,   -8,   -8,   64/
      DATA (CF(I, 12),I= 43, 48) /    0,    0,   -3,   24,   -8,    1/
C     1 T(1,5,4) T(7,2,6,3)
      DATA DENOM(13)/9/
      DATA (CF(I, 13),I=  1,  6) /   -8,   -3,    0,   -8,    1,    0/
      DATA (CF(I, 13),I=  7, 12) /   24,   64,   64,   -8,   21,   -6/
      DATA (CF(I, 13),I= 13, 18) /  192,  -24,   64,   -8,   10,    0/
      DATA (CF(I, 13),I= 19, 24) /   24,   -8,    1,   24,    0,   64/
      DATA (CF(I, 13),I= 25, 30) /   64,   24,    0,    1,   -8,    0/
      DATA (CF(I, 13),I= 31, 36) /   -3,   -8,   -8,    0,   -3,   -8/
      DATA (CF(I, 13),I= 37, 42) /   64,    0,   24,    1,    1,   10/
      DATA (CF(I, 13),I= 43, 48) /   -3,   24,    0,    0,    1,   -8/
C     1 T(1,6,3) T(2,7,5,4)
      DATA DENOM(14)/9/
      DATA (CF(I, 14),I=  1,  6) /    1,   24,    0,   64,   10,    0/
      DATA (CF(I, 14),I=  7, 12) /   24,   -8,   -8,   64,   -6,   21/
      DATA (CF(I, 14),I= 13, 18) /  -24,  192,   -8,   64,    1,    0/
      DATA (CF(I, 14),I= 19, 24) /   24,   64,   -8,   -3,    0,   -8/
      DATA (CF(I, 14),I= 25, 30) /   -8,   -3,    0,   -8,    1,    0/
      DATA (CF(I, 14),I= 31, 36) /   -3,    1,    1,    0,   24,   64/
      DATA (CF(I, 14),I= 37, 42) /   -8,    0,   24,   10,   -8,    1/
      DATA (CF(I, 14),I= 43, 48) /   -3,   24,    0,    0,   -8,   64/
C     1 T(1,6,3) T(7,2,5,4)
      DATA DENOM(15)/9/
      DATA (CF(I, 15),I=  1,  6) /   -3,   -8,   -8,    0,    0,    1/
      DATA (CF(I, 15),I=  7, 12) /   64,   24,   21,   -6,   64,   -8/
      DATA (CF(I, 15),I= 13, 18) /   64,   -8,  192,  -24,    0,   10/
      DATA (CF(I, 15),I= 19, 24) /   -8,   24,   24,    1,   64,    0/
      DATA (CF(I, 15),I= 25, 30) /   24,   64,    1,    0,    0,   -8/
      DATA (CF(I, 15),I= 31, 36) /   -8,   -3,    0,   -8,   -8,   -3/
      DATA (CF(I, 15),I= 37, 42) /    0,   64,    1,   24,   -3,   24/
      DATA (CF(I, 15),I= 43, 48) /    1,   10,    1,   -8,    0,    0/
C     1 T(1,6,4) T(2,7,5,3)
      DATA DENOM(16)/9/
      DATA (CF(I, 16),I=  1,  6) /   24,    1,   64,    0,    0,   10/
      DATA (CF(I, 16),I=  7, 12) /   -8,   24,   -6,   21,   -8,   64/
      DATA (CF(I, 16),I= 13, 18) /   -8,   64,  -24,  192,    0,    1/
      DATA (CF(I, 16),I= 19, 24) /   64,   24,   -3,   -8,   -8,    0/
      DATA (CF(I, 16),I= 25, 30) /   -3,   -8,   -8,    0,    0,    1/
      DATA (CF(I, 16),I= 31, 36) /    1,   -3,    0,    1,   64,   24/
      DATA (CF(I, 16),I= 37, 42) /    0,   -8,   10,   24,   -3,   24/
      DATA (CF(I, 16),I= 43, 48) /   -8,    1,   -8,   64,    0,    0/
C     1 T(1,6,4) T(7,2,5,3)
      DATA DENOM(17)/9/
      DATA (CF(I, 17),I=  1,  6) /    0,   -8,   -8,   -3,  -24,   -8/
      DATA (CF(I, 17),I=  7, 12) /   -8,   -6,   24,   24,   -8,   64/
      DATA (CF(I, 17),I= 13, 18) /   10,    1,    0,    0,  192,   64/
      DATA (CF(I, 17),I= 19, 24) /   64,   21,    0,   64,    1,   24/
      DATA (CF(I, 17),I= 25, 30) /    0,    1,    1,   -3,    3,    1/
      DATA (CF(I, 17),I= 31, 36) /    1,   21,   24,   10,   -8,    0/
      DATA (CF(I, 17),I= 37, 42) /   30,   10,   10,   -6,   -6,   21/
      DATA (CF(I, 17),I= 43, 48) /   -8,    1,   -8,    1,  -24,    3/
C     1 T(1,7,2,5,3) T(6,4)
      DATA DENOM(18)/9/
      DATA (CF(I, 18),I=  1,  6) /   -8,    0,   -3,   -8,   -8,  -24/
      DATA (CF(I, 18),I=  7, 12) /   -6,   -8,   -8,   64,   24,   24/
      DATA (CF(I, 18),I= 13, 18) /    0,    0,   10,    1,   64,  192/
      DATA (CF(I, 18),I= 19, 24) /   21,   64,   64,    0,   24,    1/
      DATA (CF(I, 18),I= 25, 30) /    1,    0,   -3,    1,    1,    3/
      DATA (CF(I, 18),I= 31, 36) /   21,    1,   10,   24,    0,   -8/
      DATA (CF(I, 18),I= 37, 42) /   10,   30,   -6,   10,   -8,    1/
      DATA (CF(I, 18),I= 43, 48) /   -6,   21,  -24,    3,   -8,    1/
C     1 T(1,7,2,5,4) T(6,3)
      DATA DENOM(19)/9/
      DATA (CF(I, 19),I=  1,  6) /   -8,   -3,    0,   -8,   -8,   -6/
      DATA (CF(I, 19),I=  7, 12) /  -24,   -8,   10,    1,    0,    0/
      DATA (CF(I, 19),I= 13, 18) /   24,   24,   -8,   64,   64,   21/
      DATA (CF(I, 19),I= 19, 24) /  192,   64,    1,   24,    0,   64/
      DATA (CF(I, 19),I= 25, 30) /    1,   -3,    0,    1,    1,   21/
      DATA (CF(I, 19),I= 31, 36) /    3,    1,   -8,    0,   24,   10/
      DATA (CF(I, 19),I= 37, 42) /   10,   -6,   30,   10,   -8,    1/
      DATA (CF(I, 19),I= 43, 48) /  -24,    3,   -6,   21,   -8,    1/
C     1 T(1,7,2,6,3) T(5,4)
      DATA DENOM(20)/9/
      DATA (CF(I, 20),I=  1,  6) /   -3,   -8,   -8,    0,   -6,   -8/
      DATA (CF(I, 20),I=  7, 12) /   -8,  -24,    0,    0,   10,    1/
      DATA (CF(I, 20),I= 13, 18) /   -8,   64,   24,   24,   21,   64/
      DATA (CF(I, 20),I= 19, 24) /   64,  192,   24,    1,   64,    0/
      DATA (CF(I, 20),I= 25, 30) /   -3,    1,    1,    0,   21,    1/
      DATA (CF(I, 20),I= 31, 36) /    1,    3,    0,   -8,   10,   24/
      DATA (CF(I, 20),I= 37, 42) /   -6,   10,   10,   30,  -24,    3/
      DATA (CF(I, 20),I= 43, 48) /   -8,    1,   -8,    1,   -6,   21/
C     1 T(1,7,2,6,4) T(5,3)
      DATA DENOM(21)/9/
      DATA (CF(I, 21),I=  1,  6) /   24,   64,    1,    0,    0,   -8/
      DATA (CF(I, 21),I=  7, 12) /   -8,   -3,    0,    0,   64,   -8/
      DATA (CF(I, 21),I= 13, 18) /    1,   -8,   24,   -3,    0,   64/
      DATA (CF(I, 21),I= 19, 24) /    1,   24,  192,   64,   64,   21/
      DATA (CF(I, 21),I= 25, 30) /   -3,   -8,   -8,    0,    0,    1/
      DATA (CF(I, 21),I= 31, 36) /   64,   24,   -6,   -8,   -8,  -24/
      DATA (CF(I, 21),I= 37, 42) /    0,   10,   -8,   24,   24,   -3/
      DATA (CF(I, 21),I= 43, 48) /   10,    1,   -8,    1,    0,    0/
C     1 T(1,7,5,3) T(2,6,4)
      DATA DENOM(22)/9/
      DATA (CF(I, 22),I=  1,  6) /   64,   24,    0,    1,   -8,    0/
      DATA (CF(I, 22),I=  7, 12) /   -3,   -8,   64,   -8,    0,    0/
      DATA (CF(I, 22),I= 13, 18) /   24,   -3,    1,   -8,   64,    0/
      DATA (CF(I, 22),I= 19, 24) /   24,    1,   64,  192,   21,   64/
      DATA (CF(I, 22),I= 25, 30) /   -8,   -3,    0,   -8,    1,    0/
      DATA (CF(I, 22),I= 31, 36) /   24,   64,   -8,   -6,  -24,   -8/
      DATA (CF(I, 22),I= 37, 42) /   10,    0,   24,   -8,   10,    1/
      DATA (CF(I, 22),I= 43, 48) /   24,   -3,    0,    0,   -8,    1/
C     1 T(1,7,5,4) T(2,6,3)
      DATA DENOM(23)/9/
      DATA (CF(I, 23),I=  1,  6) /    1,    0,   24,   64,   -8,   -3/
      DATA (CF(I, 23),I=  7, 12) /    0,   -8,    1,   -8,   24,   -3/
      DATA (CF(I, 23),I= 13, 18) /    0,    0,   64,   -8,    1,   24/
      DATA (CF(I, 23),I= 19, 24) /    0,   64,   64,   21,  192,   64/
      DATA (CF(I, 23),I= 25, 30) /   -8,    0,   -3,   -8,   64,   24/
      DATA (CF(I, 23),I= 31, 36) /    0,    1,   -8,  -24,   -6,   -8/
      DATA (CF(I, 23),I= 37, 42) /   -8,   24,    0,   10,   -8,    1/
      DATA (CF(I, 23),I= 43, 48) /    0,    0,   24,   -3,   10,    1/
C     1 T(1,7,6,3) T(2,5,4)
      DATA DENOM(24)/9/
      DATA (CF(I, 24),I=  1,  6) /    0,    1,   64,   24,   -3,   -8/
      DATA (CF(I, 24),I=  7, 12) /   -8,    0,   24,   -3,    1,   -8/
      DATA (CF(I, 24),I= 13, 18) /   64,   -8,    0,    0,   24,    1/
      DATA (CF(I, 24),I= 19, 24) /   64,    0,   21,   64,   64,  192/
      DATA (CF(I, 24),I= 25, 30) /    0,   -8,   -8,   -3,   24,   64/
      DATA (CF(I, 24),I= 31, 36) /    1,    0,  -24,   -8,   -8,   -6/
      DATA (CF(I, 24),I= 37, 42) /   24,   -8,   10,    0,    0,    0/
      DATA (CF(I, 24),I= 43, 48) /   -8,    1,   10,    1,   24,   -3/
C     1 T(1,7,6,4) T(2,5,3)
      DATA DENOM(25)/9/
      DATA (CF(I, 25),I=  1,  6) /  -24,   -8,   -8,   -6,    0,   -8/
      DATA (CF(I, 25),I=  7, 12) /   10,   24,    0,    0,    1,   -8/
      DATA (CF(I, 25),I= 13, 18) /   64,   -8,   24,   -3,    0,    1/
      DATA (CF(I, 25),I= 19, 24) /    1,   -3,   -3,   -8,   -8,    0/
      DATA (CF(I, 25),I= 25, 30) /  192,   64,   64,   21,    0,   64/
      DATA (CF(I, 25),I= 31, 36) /    1,   24,    0,   64,    1,   24/
      DATA (CF(I, 25),I= 37, 42) /    0,   -8,   -8,   -3,   24,   24/
      DATA (CF(I, 25),I= 43, 48) /   -8,   64,   10,    1,    0,    0/
C     1 T(2,1,5,3) T(7,6,4)
      DATA DENOM(26)/9/
      DATA (CF(I, 26),I=  1,  6) /   -8,  -24,   -6,   -8,   -8,    0/
      DATA (CF(I, 26),I=  7, 12) /   24,   10,    1,   -8,    0,    0/
      DATA (CF(I, 26),I= 13, 18) /   24,   -3,   64,   -8,    1,    0/
      DATA (CF(I, 26),I= 19, 24) /   -3,    1,   -8,   -3,    0,   -8/
      DATA (CF(I, 26),I= 25, 30) /   64,  192,   21,   64,   64,    0/
      DATA (CF(I, 26),I= 31, 36) /   24,    1,   64,    0,   24,    1/
      DATA (CF(I, 26),I= 37, 42) /   -8,    0,   -3,   -8,   -8,   64/
      DATA (CF(I, 26),I= 43, 48) /   24,   24,    0,    0,   10,    1/
C     1 T(2,1,5,4) T(7,6,3)
      DATA DENOM(27)/9/
      DATA (CF(I, 27),I=  1,  6) /   -8,   -6,  -24,   -8,   10,   24/
      DATA (CF(I, 27),I=  7, 12) /    0,   -8,   64,   -8,   24,   -3/
      DATA (CF(I, 27),I= 13, 18) /    0,    0,    1,   -8,    1,   -3/
      DATA (CF(I, 27),I= 19, 24) /    0,    1,   -8,    0,   -3,   -8/
      DATA (CF(I, 27),I= 25, 30) /   64,   21,  192,   64,    1,   24/
      DATA (CF(I, 27),I= 31, 36) /    0,   64,    1,   24,    0,   64/
      DATA (CF(I, 27),I= 37, 42) /   -8,   -3,    0,   -8,   10,    1/
      DATA (CF(I, 27),I= 43, 48) /    0,    0,   24,   24,   -8,   64/
C     1 T(2,1,6,3) T(7,5,4)
      DATA DENOM(28)/9/
      DATA (CF(I, 28),I=  1,  6) /   -6,   -8,   -8,  -24,   24,   10/
      DATA (CF(I, 28),I=  7, 12) /   -8,    0,   24,   -3,   64,   -8/
      DATA (CF(I, 28),I= 13, 18) /    1,   -8,    0,    0,   -3,    1/
      DATA (CF(I, 28),I= 19, 24) /    1,    0,    0,   -8,   -8,   -3/
      DATA (CF(I, 28),I= 25, 30) /   21,   64,   64,  192,   24,    1/
      DATA (CF(I, 28),I= 31, 36) /   64,    0,   24,    1,   64,    0/
      DATA (CF(I, 28),I= 37, 42) /   -3,   -8,   -8,    0,    0,    0/
      DATA (CF(I, 28),I= 43, 48) /   10,    1,   -8,   64,   24,   24/
C     1 T(2,1,6,4) T(7,5,3)
      DATA DENOM(29)/9/
      DATA (CF(I, 29),I=  1,  6) /    0,   -8,   10,   24,  -24,   -8/
      DATA (CF(I, 29),I=  7, 12) /   -8,   -6,   -3,   -3,   -8,    1/
      DATA (CF(I, 29),I= 13, 18) /   -8,    1,    0,    0,    3,    1/
      DATA (CF(I, 29),I= 19, 24) /    1,   21,    0,    1,   64,   24/
      DATA (CF(I, 29),I= 25, 30) /    0,   64,    1,   24,  192,   64/
      DATA (CF(I, 29),I= 31, 36) /   64,   21,   24,   -8,   10,    0/
      DATA (CF(I, 29),I= 37, 42) /  -24,   -8,   -8,   -6,   -6,   21/
      DATA (CF(I, 29),I= 43, 48) /   10,    1,   10,    1,   30,    3/
C     1 T(2,1,7,5,3) T(6,4)
      DATA DENOM(30)/9/
      DATA (CF(I, 30),I=  1,  6) /   -8,    0,   24,   10,   -8,  -24/
      DATA (CF(I, 30),I=  7, 12) /   -6,   -8,   -8,    1,   -3,   -3/
      DATA (CF(I, 30),I= 13, 18) /    0,    0,   -8,    1,    1,    3/
      DATA (CF(I, 30),I= 19, 24) /   21,    1,    1,    0,   24,   64/
      DATA (CF(I, 30),I= 25, 30) /   64,    0,   24,    1,   64,  192/
      DATA (CF(I, 30),I= 31, 36) /   21,   64,   -8,   24,    0,   10/
      DATA (CF(I, 30),I= 37, 42) /   -8,  -24,   -6,   -8,   10,    1/
      DATA (CF(I, 30),I= 43, 48) /   -6,   21,   30,    3,   10,    1/
C     1 T(2,1,7,5,4) T(6,3)
      DATA DENOM(31)/9/
      DATA (CF(I, 31),I=  1,  6) /   10,   24,    0,   -8,   -8,   -6/
      DATA (CF(I, 31),I=  7, 12) /  -24,   -8,   -8,    1,    0,    0/
      DATA (CF(I, 31),I= 13, 18) /   -3,   -3,   -8,    1,    1,   21/
      DATA (CF(I, 31),I= 19, 24) /    3,    1,   64,   24,    0,    1/
      DATA (CF(I, 31),I= 25, 30) /    1,   24,    0,   64,   64,   21/
      DATA (CF(I, 31),I= 31, 36) /  192,   64,   10,    0,   24,   -8/
      DATA (CF(I, 31),I= 37, 42) /   -8,   -6,  -24,   -8,   10,    1/
      DATA (CF(I, 31),I= 43, 48) /   30,    3,   -6,   21,   10,    1/
C     1 T(2,1,7,6,3) T(5,4)
      DATA DENOM(32)/9/
      DATA (CF(I, 32),I=  1,  6) /   24,   10,   -8,    0,   -6,   -8/
      DATA (CF(I, 32),I=  7, 12) /   -8,  -24,    0,    0,   -8,    1/
      DATA (CF(I, 32),I= 13, 18) /   -8,    1,   -3,   -3,   21,    1/
      DATA (CF(I, 32),I= 19, 24) /    1,    3,   24,   64,    1,    0/
      DATA (CF(I, 32),I= 25, 30) /   24,    1,   64,    0,   21,   64/
      DATA (CF(I, 32),I= 31, 36) /   64,  192,    0,   10,   -8,   24/
      DATA (CF(I, 32),I= 37, 42) /   -6,   -8,   -8,  -24,   30,    3/
      DATA (CF(I, 32),I= 43, 48) /   10,    1,   10,    1,   -6,   21/
C     1 T(2,1,7,6,4) T(5,3)
      DATA DENOM(33)/9/
      DATA (CF(I, 33),I=  1,  6) /    0,   -8,   -8,   -3,   -3,    1/
      DATA (CF(I, 33),I=  7, 12) /    1,    0,   -3,   24,   -8,   64/
      DATA (CF(I, 33),I= 13, 18) /   -8,    1,    0,    0,   24,   10/
      DATA (CF(I, 33),I= 19, 24) /   -8,    0,   -6,   -8,   -8,  -24/
      DATA (CF(I, 33),I= 25, 30) /    0,   64,    1,   24,   24,   -8/
      DATA (CF(I, 33),I= 31, 36) /   10,    0,  192,   64,   64,   21/
      DATA (CF(I, 33),I= 37, 42) /   24,   64,    1,    0,    0,    0/
      DATA (CF(I, 33),I= 43, 48) /   64,   -8,    1,   -8,   24,   -3/
C     1 T(2,5,3) T(7,1,6,4)
      DATA DENOM(34)/9/
      DATA (CF(I, 34),I=  1,  6) /   -8,    0,   -3,   -8,    1,   -3/
      DATA (CF(I, 34),I=  7, 12) /    0,    1,   -8,   64,   -3,   24/
      DATA (CF(I, 34),I= 13, 18) /    0,    0,   -8,    1,   10,   24/
      DATA (CF(I, 34),I= 19, 24) /    0,   -8,   -8,   -6,  -24,   -8/
      DATA (CF(I, 34),I= 25, 30) /   64,    0,   24,    1,   -8,   24/
      DATA (CF(I, 34),I= 31, 36) /    0,   10,   64,  192,   21,   64/
      DATA (CF(I, 34),I= 37, 42) /   64,   24,    0,    1,   64,   -8/
      DATA (CF(I, 34),I= 43, 48) /    0,    0,   24,   -3,    1,   -8/
C     1 T(2,5,4) T(7,1,6,3)
      DATA DENOM(35)/9/
      DATA (CF(I, 35),I=  1,  6) /   -8,   -3,    0,   -8,    1,    0/
      DATA (CF(I, 35),I=  7, 12) /   -3,    1,   -8,    1,    0,    0/
      DATA (CF(I, 35),I= 13, 18) /   -3,   24,   -8,   64,   -8,    0/
      DATA (CF(I, 35),I= 19, 24) /   24,   10,   -8,  -24,   -6,   -8/
      DATA (CF(I, 35),I= 25, 30) /    1,   24,    0,   64,   10,    0/
      DATA (CF(I, 35),I= 31, 36) /   24,   -8,   64,   21,  192,   64/
      DATA (CF(I, 35),I= 37, 42) /    1,    0,   24,   64,    1,   -8/
      DATA (CF(I, 35),I= 43, 48) /   24,   -3,    0,    0,   64,   -8/
C     1 T(2,6,3) T(7,1,5,4)
      DATA DENOM(36)/9/
      DATA (CF(I, 36),I=  1,  6) /   -3,   -8,   -8,    0,    0,    1/
      DATA (CF(I, 36),I=  7, 12) /    1,   -3,    0,    0,   -8,    1/
      DATA (CF(I, 36),I= 13, 18) /   -8,   64,   -3,   24,    0,   -8/
      DATA (CF(I, 36),I= 19, 24) /   10,   24,  -24,   -8,   -8,   -6/
      DATA (CF(I, 36),I= 25, 30) /   24,    1,   64,    0,    0,   10/
      DATA (CF(I, 36),I= 31, 36) /   -8,   24,   21,   64,   64,  192/
      DATA (CF(I, 36),I= 37, 42) /    0,    1,   64,   24,   24,   -3/
      DATA (CF(I, 36),I= 43, 48) /    1,   -8,   64,   -8,    0,    0/
C     1 T(2,6,4) T(7,1,5,3)
      DATA DENOM(37)/9/
      DATA (CF(I, 37),I=  1,  6) /    0,    1,    1,   -3,    3,    1/
      DATA (CF(I, 37),I=  7, 12) /    1,   21,   24,   24,    1,   10/
      DATA (CF(I, 37),I= 13, 18) /   64,   -8,    0,    0,   30,   10/
      DATA (CF(I, 37),I= 19, 24) /   10,   -6,    0,   10,   -8,   24/
      DATA (CF(I, 37),I= 25, 30) /    0,   -8,   -8,   -3,  -24,   -8/
      DATA (CF(I, 37),I= 31, 36) /   -8,   -6,   24,   64,    1,    0/
      DATA (CF(I, 37),I= 37, 42) /  192,   64,   64,   21,   21,   -6/
      DATA (CF(I, 37),I= 43, 48) /    1,   -8,    1,   -8,    3,  -24/
C     1 T(2,7,1,5,3) T(6,4)
      DATA DENOM(38)/9/
      DATA (CF(I, 38),I=  1,  6) /    1,    0,   -3,    1,    1,    3/
      DATA (CF(I, 38),I=  7, 12) /   21,    1,    1,   10,   24,   24/
      DATA (CF(I, 38),I= 13, 18) /    0,    0,   64,   -8,   10,   30/
      DATA (CF(I, 38),I= 19, 24) /   -6,   10,   10,    0,   24,   -8/
      DATA (CF(I, 38),I= 25, 30) /   -8,    0,   -3,   -8,   -8,  -24/
      DATA (CF(I, 38),I= 31, 36) /   -6,   -8,   64,   24,    0,    1/
      DATA (CF(I, 38),I= 37, 42) /   64,  192,   21,   64,    1,   -8/
      DATA (CF(I, 38),I= 43, 48) /   21,   -6,    3,  -24,    1,   -8/
C     1 T(2,7,1,5,4) T(6,3)
      DATA DENOM(39)/9/
      DATA (CF(I, 39),I=  1,  6) /    1,   -3,    0,    1,    1,   21/
      DATA (CF(I, 39),I=  7, 12) /    3,    1,   64,   -8,    0,    0/
      DATA (CF(I, 39),I= 13, 18) /   24,   24,    1,   10,   10,   -6/
      DATA (CF(I, 39),I= 19, 24) /   30,   10,   -8,   24,    0,   10/
      DATA (CF(I, 39),I= 25, 30) /   -8,   -3,    0,   -8,   -8,   -6/
      DATA (CF(I, 39),I= 31, 36) /  -24,   -8,    1,    0,   24,   64/
      DATA (CF(I, 39),I= 37, 42) /   64,   21,  192,   64,    1,   -8/
      DATA (CF(I, 39),I= 43, 48) /    3,  -24,   21,   -6,    1,   -8/
C     1 T(2,7,1,6,3) T(5,4)
      DATA DENOM(40)/9/
      DATA (CF(I, 40),I=  1,  6) /   -3,    1,    1,    0,   21,    1/
      DATA (CF(I, 40),I=  7, 12) /    1,    3,    0,    0,   64,   -8/
      DATA (CF(I, 40),I= 13, 18) /    1,   10,   24,   24,   -6,   10/
      DATA (CF(I, 40),I= 19, 24) /   10,   30,   24,   -8,   10,    0/
      DATA (CF(I, 40),I= 25, 30) /   -3,   -8,   -8,    0,   -6,   -8/
      DATA (CF(I, 40),I= 31, 36) /   -8,  -24,    0,    1,   64,   24/
      DATA (CF(I, 40),I= 37, 42) /   21,   64,   64,  192,    3,  -24/
      DATA (CF(I, 40),I= 43, 48) /    1,   -8,    1,   -8,   21,   -6/
C     1 T(2,7,1,6,4) T(5,3)
      DATA DENOM(41)/9/
      DATA (CF(I, 41),I=  1,  6) /   24,   64,    1,    0,   21,    1/
      DATA (CF(I, 41),I=  7, 12) /    1,    3,    0,    0,    1,   -8/
      DATA (CF(I, 41),I= 13, 18) /    1,   -8,   -3,   -3,   -6,   -8/
      DATA (CF(I, 41),I= 19, 24) /   -8,  -24,   24,   10,   -8,    0/
      DATA (CF(I, 41),I= 25, 30) /   24,   -8,   10,    0,   -6,   10/
      DATA (CF(I, 41),I= 31, 36) /   10,   30,    0,   64,    1,   24/
      DATA (CF(I, 41),I= 37, 42) /   21,    1,    1,    3,  192,  -24/
      DATA (CF(I, 41),I= 43, 48) /   64,   -8,   64,   -8,   21,   -6/
C     1 T(5,3) T(7,1,2,6,4)
      DATA DENOM(42)/9/
      DATA (CF(I, 42),I=  1,  6) /   24,   -8,   10,    0,   -6,   10/
      DATA (CF(I, 42),I=  7, 12) /   10,   30,    0,    0,   -8,   64/
      DATA (CF(I, 42),I= 13, 18) /   10,    1,   24,   24,   21,    1/
      DATA (CF(I, 42),I= 19, 24) /    1,    3,   -3,    1,    1,    0/
      DATA (CF(I, 42),I= 25, 30) /   24,   64,    1,    0,   21,    1/
      DATA (CF(I, 42),I= 31, 36) /    1,    3,    0,   -8,   -8,   -3/
      DATA (CF(I, 42),I= 37, 42) /   -6,   -8,   -8,  -24,  -24,  192/
      DATA (CF(I, 42),I= 43, 48) /   -8,   64,   -8,   64,   -6,   21/
C     1 T(5,3) T(7,2,1,6,4)
      DATA DENOM(43)/9/
      DATA (CF(I, 43),I=  1,  6) /   64,   24,    0,    1,    1,   21/
      DATA (CF(I, 43),I=  7, 12) /    3,    1,    1,   -8,    0,    0/
      DATA (CF(I, 43),I= 13, 18) /   -3,   -3,    1,   -8,   -8,   -6/
      DATA (CF(I, 43),I= 19, 24) /  -24,   -8,   10,   24,    0,   -8/
      DATA (CF(I, 43),I= 25, 30) /   -8,   24,    0,   10,   10,   -6/
      DATA (CF(I, 43),I= 31, 36) /   30,   10,   64,    0,   24,    1/
      DATA (CF(I, 43),I= 37, 42) /    1,   21,    3,    1,   64,   -8/
      DATA (CF(I, 43),I= 43, 48) /  192,  -24,   21,   -6,   64,   -8/
C     1 T(5,4) T(7,1,2,6,3)
      DATA DENOM(44)/9/
      DATA (CF(I, 44),I=  1,  6) /   -8,   24,    0,   10,   10,   -6/
      DATA (CF(I, 44),I=  7, 12) /   30,   10,   -8,   64,    0,    0/
      DATA (CF(I, 44),I= 13, 18) /   24,   24,   10,    1,    1,   21/
      DATA (CF(I, 44),I= 19, 24) /    3,    1,    1,   -3,    0,    1/
      DATA (CF(I, 44),I= 25, 30) /   64,   24,    0,    1,    1,   21/
      DATA (CF(I, 44),I= 31, 36) /    3,    1,   -8,    0,   -3,   -8/
      DATA (CF(I, 44),I= 37, 42) /   -8,   -6,  -24,   -8,   -8,   64/
      DATA (CF(I, 44),I= 43, 48) /  -24,  192,   -6,   21,   -8,   64/
C     1 T(5,4) T(7,2,1,6,3)
      DATA DENOM(45)/9/
      DATA (CF(I, 45),I=  1,  6) /    1,    0,   24,   64,    1,    3/
      DATA (CF(I, 45),I=  7, 12) /   21,    1,    1,   -8,   -3,   -3/
      DATA (CF(I, 45),I= 13, 18) /    0,    0,    1,   -8,   -8,  -24/
      DATA (CF(I, 45),I= 19, 24) /   -6,   -8,   -8,    0,   24,   10/
      DATA (CF(I, 45),I= 25, 30) /   10,    0,   24,   -8,   10,   30/
      DATA (CF(I, 45),I= 31, 36) /   -6,   10,    1,   24,    0,   64/
      DATA (CF(I, 45),I= 37, 42) /    1,    3,   21,    1,   64,   -8/
      DATA (CF(I, 45),I= 43, 48) /   21,   -6,  192,  -24,   64,   -8/
C     1 T(6,3) T(7,1,2,5,4)
      DATA DENOM(46)/9/
      DATA (CF(I, 46),I=  1,  6) /   10,    0,   24,   -8,   10,   30/
      DATA (CF(I, 46),I=  7, 12) /   -6,   10,   10,    1,   24,   24/
      DATA (CF(I, 46),I= 13, 18) /    0,    0,   -8,   64,    1,    3/
      DATA (CF(I, 46),I= 19, 24) /   21,    1,    1,    0,   -3,    1/
      DATA (CF(I, 46),I= 25, 30) /    1,    0,   24,   64,    1,    3/
      DATA (CF(I, 46),I= 31, 36) /   21,    1,   -8,   -3,    0,   -8/
      DATA (CF(I, 46),I= 37, 42) /   -8,  -24,   -6,   -8,   -8,   64/
      DATA (CF(I, 46),I= 43, 48) /   -6,   21,  -24,  192,   -8,   64/
C     1 T(6,3) T(7,2,1,5,4)
      DATA DENOM(47)/9/
      DATA (CF(I, 47),I=  1,  6) /    0,    1,   64,   24,    3,    1/
      DATA (CF(I, 47),I=  7, 12) /    1,   21,   -3,   -3,    1,   -8/
      DATA (CF(I, 47),I= 13, 18) /    1,   -8,    0,    0,  -24,   -8/
      DATA (CF(I, 47),I= 19, 24) /   -8,   -6,    0,   -8,   10,   24/
      DATA (CF(I, 47),I= 25, 30) /    0,   10,   -8,   24,   30,   10/
      DATA (CF(I, 47),I= 31, 36) /   10,   -6,   24,    1,   64,    0/
      DATA (CF(I, 47),I= 37, 42) /    3,    1,    1,   21,   21,   -6/
      DATA (CF(I, 47),I= 43, 48) /   64,   -8,   64,   -8,  192,  -24/
C     1 T(6,4) T(7,1,2,5,3)
      DATA DENOM(48)/9/
      DATA (CF(I, 48),I=  1,  6) /    0,   10,   -8,   24,   30,   10/
      DATA (CF(I, 48),I=  7, 12) /   10,   -6,   24,   24,   10,    1/
      DATA (CF(I, 48),I= 13, 18) /   -8,   64,    0,    0,    3,    1/
      DATA (CF(I, 48),I= 19, 24) /    1,   21,    0,    1,    1,   -3/
      DATA (CF(I, 48),I= 25, 30) /    0,    1,   64,   24,    3,    1/
      DATA (CF(I, 48),I= 31, 36) /    1,   21,   -3,   -8,   -8,    0/
      DATA (CF(I, 48),I= 37, 42) /  -24,   -8,   -8,   -6,   -6,   21/
      DATA (CF(I, 48),I= 43, 48) /   -8,   64,   -8,   64,  -24,  192/
C     1 T(6,4) T(7,2,1,5,3)
C     ----------
C     BEGIN CODE
C     ----------
      CALL VXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
      CALL VXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
      CALL IXXXXX(P(0,4),ZERO,NHEL(4),-1*IC(4),W(1,4))
      CALL OXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      CALL OXXXXX(P(0,6),ZERO,NHEL(6),+1*IC(6),W(1,6))
      CALL VXXXXX(P(0,7),ZERO,NHEL(7),+1*IC(7),W(1,7))
      CALL VVV1P0_1(W(1,1),W(1,2),GC_10,ZERO,ZERO,W(1,8))
      CALL FFV1P0_3(W(1,3),W(1,6),GC_11,ZERO,ZERO,W(1,9))
      CALL FFV1_2(W(1,4),W(1,8),GC_11,ZERO,ZERO,W(1,10))
      CALL FFV1_1(W(1,5),W(1,9),GC_11,ZERO,ZERO,W(1,11))
C     Amplitude(s) for diagram number 1
      CALL FFV1_0(W(1,10),W(1,11),W(1,7),GC_11,AMP(1))
      CALL VVV1P0_1(W(1,9),W(1,7),GC_10,ZERO,ZERO,W(1,12))
C     Amplitude(s) for diagram number 2
      CALL FFV1_0(W(1,10),W(1,5),W(1,12),GC_11,AMP(2))
      CALL FFV1_1(W(1,5),W(1,8),GC_11,ZERO,ZERO,W(1,13))
      CALL FFV1_2(W(1,4),W(1,9),GC_11,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 3
      CALL FFV1_0(W(1,14),W(1,13),W(1,7),GC_11,AMP(3))
C     Amplitude(s) for diagram number 4
      CALL FFV1_0(W(1,4),W(1,13),W(1,12),GC_11,AMP(4))
      CALL VVV1P0_1(W(1,8),W(1,7),GC_10,ZERO,ZERO,W(1,15))
C     Amplitude(s) for diagram number 5
      CALL FFV1_0(W(1,14),W(1,5),W(1,15),GC_11,AMP(5))
C     Amplitude(s) for diagram number 6
      CALL FFV1_0(W(1,4),W(1,11),W(1,15),GC_11,AMP(6))
      CALL FFV1P0_3(W(1,4),W(1,5),GC_11,ZERO,ZERO,W(1,16))
C     Amplitude(s) for diagram number 7
      CALL VVVV1_0(W(1,8),W(1,9),W(1,16),W(1,7),GC_12,AMP(7))
      CALL VVVV3_0(W(1,8),W(1,9),W(1,16),W(1,7),GC_12,AMP(8))
      CALL VVVV4_0(W(1,8),W(1,9),W(1,16),W(1,7),GC_12,AMP(9))
      CALL VVV1P0_1(W(1,8),W(1,9),GC_10,ZERO,ZERO,W(1,17))
C     Amplitude(s) for diagram number 8
      CALL VVV1_0(W(1,16),W(1,7),W(1,17),GC_10,AMP(10))
      CALL VVV1P0_1(W(1,8),W(1,16),GC_10,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 9
      CALL VVV1_0(W(1,9),W(1,7),W(1,18),GC_10,AMP(11))
C     Amplitude(s) for diagram number 10
      CALL VVV1_0(W(1,9),W(1,16),W(1,15),GC_10,AMP(12))
      CALL FFV1_2(W(1,4),W(1,7),GC_11,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 11
      CALL FFV1_0(W(1,19),W(1,5),W(1,17),GC_11,AMP(13))
      CALL FFV1_2(W(1,19),W(1,8),GC_11,ZERO,ZERO,W(1,20))
C     Amplitude(s) for diagram number 12
      CALL FFV1_0(W(1,20),W(1,5),W(1,9),GC_11,AMP(14))
C     Amplitude(s) for diagram number 13
      CALL FFV1_0(W(1,19),W(1,13),W(1,9),GC_11,AMP(15))
      CALL FFV1_1(W(1,5),W(1,7),GC_11,ZERO,ZERO,W(1,20))
C     Amplitude(s) for diagram number 14
      CALL FFV1_0(W(1,4),W(1,20),W(1,17),GC_11,AMP(16))
C     Amplitude(s) for diagram number 15
      CALL FFV1_0(W(1,10),W(1,20),W(1,9),GC_11,AMP(17))
      CALL FFV1_1(W(1,20),W(1,8),GC_11,ZERO,ZERO,W(1,17))
C     Amplitude(s) for diagram number 16
      CALL FFV1_0(W(1,4),W(1,17),W(1,9),GC_11,AMP(18))
      CALL FFV1_2(W(1,3),W(1,7),GC_11,ZERO,ZERO,W(1,17))
      CALL FFV1P0_3(W(1,17),W(1,6),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 17
      CALL FFV1_0(W(1,10),W(1,5),W(1,21),GC_11,AMP(19))
C     Amplitude(s) for diagram number 18
      CALL FFV1_0(W(1,4),W(1,13),W(1,21),GC_11,AMP(20))
      CALL FFV1_2(W(1,17),W(1,8),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 19
      CALL FFV1_0(W(1,22),W(1,6),W(1,16),GC_11,AMP(21))
C     Amplitude(s) for diagram number 20
      CALL FFV1_0(W(1,17),W(1,6),W(1,18),GC_11,AMP(22))
      CALL FFV1_1(W(1,6),W(1,8),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 21
      CALL FFV1_0(W(1,17),W(1,22),W(1,16),GC_11,AMP(23))
      CALL FFV1_2(W(1,3),W(1,8),GC_11,ZERO,ZERO,W(1,23))
      CALL FFV1_1(W(1,6),W(1,16),GC_11,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 22
      CALL FFV1_0(W(1,23),W(1,24),W(1,7),GC_11,AMP(24))
      CALL VVV1P0_1(W(1,16),W(1,7),GC_10,ZERO,ZERO,W(1,25))
C     Amplitude(s) for diagram number 23
      CALL FFV1_0(W(1,23),W(1,6),W(1,25),GC_11,AMP(25))
      CALL FFV1_2(W(1,3),W(1,16),GC_11,ZERO,ZERO,W(1,26))
C     Amplitude(s) for diagram number 24
      CALL FFV1_0(W(1,26),W(1,22),W(1,7),GC_11,AMP(26))
C     Amplitude(s) for diagram number 25
      CALL FFV1_0(W(1,3),W(1,22),W(1,25),GC_11,AMP(27))
C     Amplitude(s) for diagram number 26
      CALL FFV1_0(W(1,26),W(1,6),W(1,15),GC_11,AMP(28))
C     Amplitude(s) for diagram number 27
      CALL FFV1_0(W(1,3),W(1,24),W(1,15),GC_11,AMP(29))
      CALL FFV1_1(W(1,6),W(1,7),GC_11,ZERO,ZERO,W(1,15))
C     Amplitude(s) for diagram number 28
      CALL FFV1_0(W(1,23),W(1,15),W(1,16),GC_11,AMP(30))
C     Amplitude(s) for diagram number 29
      CALL FFV1_0(W(1,3),W(1,15),W(1,18),GC_11,AMP(31))
      CALL FFV1_1(W(1,15),W(1,8),GC_11,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 30
      CALL FFV1_0(W(1,3),W(1,18),W(1,16),GC_11,AMP(32))
      CALL FFV1P0_3(W(1,19),W(1,5),GC_11,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 31
      CALL FFV1_0(W(1,23),W(1,6),W(1,18),GC_11,AMP(33))
C     Amplitude(s) for diagram number 32
      CALL FFV1_0(W(1,3),W(1,22),W(1,18),GC_11,AMP(34))
      CALL FFV1P0_3(W(1,4),W(1,20),GC_11,ZERO,ZERO,W(1,8))
C     Amplitude(s) for diagram number 33
      CALL FFV1_0(W(1,23),W(1,6),W(1,8),GC_11,AMP(35))
C     Amplitude(s) for diagram number 34
      CALL FFV1_0(W(1,3),W(1,22),W(1,8),GC_11,AMP(36))
      CALL FFV1P0_3(W(1,3),W(1,15),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 35
      CALL FFV1_0(W(1,10),W(1,5),W(1,22),GC_11,AMP(37))
C     Amplitude(s) for diagram number 36
      CALL FFV1_0(W(1,4),W(1,13),W(1,22),GC_11,AMP(38))
      CALL FFV1_2(W(1,3),W(1,1),GC_11,ZERO,ZERO,W(1,13))
      CALL FFV1_2(W(1,4),W(1,2),GC_11,ZERO,ZERO,W(1,10))
      CALL FFV1P0_3(W(1,13),W(1,6),GC_11,ZERO,ZERO,W(1,23))
      CALL FFV1P0_3(W(1,10),W(1,5),GC_11,ZERO,ZERO,W(1,27))
C     Amplitude(s) for diagram number 37
      CALL VVV1_0(W(1,23),W(1,27),W(1,7),GC_10,AMP(39))
      CALL FFV1_2(W(1,10),W(1,7),GC_11,ZERO,ZERO,W(1,28))
C     Amplitude(s) for diagram number 38
      CALL FFV1_0(W(1,28),W(1,5),W(1,23),GC_11,AMP(40))
      CALL FFV1_2(W(1,13),W(1,7),GC_11,ZERO,ZERO,W(1,29))
C     Amplitude(s) for diagram number 39
      CALL FFV1_0(W(1,29),W(1,6),W(1,27),GC_11,AMP(41))
C     Amplitude(s) for diagram number 40
      CALL FFV1_0(W(1,10),W(1,20),W(1,23),GC_11,AMP(42))
      CALL FFV1P0_3(W(1,13),W(1,15),GC_11,ZERO,ZERO,W(1,30))
C     Amplitude(s) for diagram number 41
      CALL FFV1_0(W(1,10),W(1,5),W(1,30),GC_11,AMP(43))
      CALL FFV1_1(W(1,5),W(1,2),GC_11,ZERO,ZERO,W(1,31))
      CALL FFV1P0_3(W(1,4),W(1,31),GC_11,ZERO,ZERO,W(1,32))
C     Amplitude(s) for diagram number 42
      CALL VVV1_0(W(1,23),W(1,32),W(1,7),GC_10,AMP(44))
      CALL FFV1_1(W(1,31),W(1,7),GC_11,ZERO,ZERO,W(1,33))
C     Amplitude(s) for diagram number 43
      CALL FFV1_0(W(1,4),W(1,33),W(1,23),GC_11,AMP(45))
C     Amplitude(s) for diagram number 44
      CALL FFV1_0(W(1,29),W(1,6),W(1,32),GC_11,AMP(46))
C     Amplitude(s) for diagram number 45
      CALL FFV1_0(W(1,19),W(1,31),W(1,23),GC_11,AMP(47))
C     Amplitude(s) for diagram number 46
      CALL FFV1_0(W(1,4),W(1,31),W(1,30),GC_11,AMP(48))
      CALL FFV1_1(W(1,6),W(1,2),GC_11,ZERO,ZERO,W(1,34))
      CALL FFV1P0_3(W(1,13),W(1,34),GC_11,ZERO,ZERO,W(1,35))
C     Amplitude(s) for diagram number 47
      CALL VVV1_0(W(1,16),W(1,7),W(1,35),GC_10,AMP(49))
      CALL FFV1_2(W(1,13),W(1,16),GC_11,ZERO,ZERO,W(1,36))
C     Amplitude(s) for diagram number 48
      CALL FFV1_0(W(1,36),W(1,34),W(1,7),GC_11,AMP(50))
C     Amplitude(s) for diagram number 49
      CALL FFV1_0(W(1,29),W(1,34),W(1,16),GC_11,AMP(51))
C     Amplitude(s) for diagram number 50
      CALL FFV1_0(W(1,19),W(1,5),W(1,35),GC_11,AMP(52))
C     Amplitude(s) for diagram number 51
      CALL FFV1_0(W(1,4),W(1,20),W(1,35),GC_11,AMP(53))
      CALL VVV1P0_1(W(1,2),W(1,7),GC_10,ZERO,ZERO,W(1,35))
      CALL FFV1_2(W(1,4),W(1,35),GC_11,ZERO,ZERO,W(1,37))
C     Amplitude(s) for diagram number 52
      CALL FFV1_0(W(1,37),W(1,5),W(1,23),GC_11,AMP(54))
      CALL FFV1_1(W(1,5),W(1,35),GC_11,ZERO,ZERO,W(1,38))
C     Amplitude(s) for diagram number 53
      CALL FFV1_0(W(1,4),W(1,38),W(1,23),GC_11,AMP(55))
      CALL FFV1_2(W(1,13),W(1,35),GC_11,ZERO,ZERO,W(1,39))
C     Amplitude(s) for diagram number 54
      CALL FFV1_0(W(1,39),W(1,6),W(1,16),GC_11,AMP(56))
C     Amplitude(s) for diagram number 55
      CALL FFV1_0(W(1,36),W(1,6),W(1,35),GC_11,AMP(57))
C     Amplitude(s) for diagram number 56
      CALL VVV1_0(W(1,35),W(1,16),W(1,23),GC_10,AMP(58))
      CALL FFV1_2(W(1,13),W(1,2),GC_11,ZERO,ZERO,W(1,39))
C     Amplitude(s) for diagram number 57
      CALL FFV1_0(W(1,39),W(1,24),W(1,7),GC_11,AMP(59))
C     Amplitude(s) for diagram number 58
      CALL FFV1_0(W(1,39),W(1,6),W(1,25),GC_11,AMP(60))
      CALL VVV1P0_1(W(1,2),W(1,16),GC_10,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 59
      CALL VVV1_0(W(1,23),W(1,13),W(1,7),GC_10,AMP(61))
C     Amplitude(s) for diagram number 60
      CALL VVV1_0(W(1,23),W(1,2),W(1,25),GC_10,AMP(62))
C     Amplitude(s) for diagram number 61
      CALL VVVV1_0(W(1,2),W(1,16),W(1,7),W(1,23),GC_12,AMP(63))
      CALL VVVV3_0(W(1,2),W(1,16),W(1,7),W(1,23),GC_12,AMP(64))
      CALL VVVV4_0(W(1,2),W(1,16),W(1,7),W(1,23),GC_12,AMP(65))
C     Amplitude(s) for diagram number 62
      CALL FFV1_0(W(1,29),W(1,6),W(1,13),GC_11,AMP(66))
C     Amplitude(s) for diagram number 63
      CALL FFV1_0(W(1,29),W(1,24),W(1,2),GC_11,AMP(67))
C     Amplitude(s) for diagram number 64
      CALL FFV1_0(W(1,39),W(1,15),W(1,16),GC_11,AMP(68))
C     Amplitude(s) for diagram number 65
      CALL FFV1_0(W(1,36),W(1,15),W(1,2),GC_11,AMP(69))
C     Amplitude(s) for diagram number 66
      CALL VVV1_0(W(1,2),W(1,16),W(1,30),GC_10,AMP(70))
C     Amplitude(s) for diagram number 67
      CALL FFV1_0(W(1,39),W(1,6),W(1,18),GC_11,AMP(71))
      CALL FFV1_2(W(1,19),W(1,2),GC_11,ZERO,ZERO,W(1,30))
C     Amplitude(s) for diagram number 68
      CALL FFV1_0(W(1,30),W(1,5),W(1,23),GC_11,AMP(72))
C     Amplitude(s) for diagram number 69
      CALL VVV1_0(W(1,23),W(1,2),W(1,18),GC_10,AMP(73))
C     Amplitude(s) for diagram number 70
      CALL FFV1_0(W(1,39),W(1,6),W(1,8),GC_11,AMP(74))
      CALL FFV1_1(W(1,20),W(1,2),GC_11,ZERO,ZERO,W(1,39))
C     Amplitude(s) for diagram number 71
      CALL FFV1_0(W(1,4),W(1,39),W(1,23),GC_11,AMP(75))
C     Amplitude(s) for diagram number 72
      CALL VVV1_0(W(1,23),W(1,2),W(1,8),GC_10,AMP(76))
      CALL FFV1_2(W(1,4),W(1,1),GC_11,ZERO,ZERO,W(1,23))
      CALL FFV1_2(W(1,3),W(1,2),GC_11,ZERO,ZERO,W(1,36))
      CALL FFV1P0_3(W(1,23),W(1,5),GC_11,ZERO,ZERO,W(1,29))
      CALL FFV1P0_3(W(1,36),W(1,6),GC_11,ZERO,ZERO,W(1,40))
C     Amplitude(s) for diagram number 73
      CALL VVV1_0(W(1,29),W(1,40),W(1,7),GC_10,AMP(77))
      CALL FFV1_2(W(1,36),W(1,7),GC_11,ZERO,ZERO,W(1,41))
C     Amplitude(s) for diagram number 74
      CALL FFV1_0(W(1,41),W(1,6),W(1,29),GC_11,AMP(78))
      CALL FFV1_2(W(1,23),W(1,7),GC_11,ZERO,ZERO,W(1,42))
C     Amplitude(s) for diagram number 75
      CALL FFV1_0(W(1,42),W(1,5),W(1,40),GC_11,AMP(79))
      CALL FFV1P0_3(W(1,23),W(1,20),GC_11,ZERO,ZERO,W(1,43))
C     Amplitude(s) for diagram number 76
      CALL FFV1_0(W(1,36),W(1,6),W(1,43),GC_11,AMP(80))
C     Amplitude(s) for diagram number 77
      CALL FFV1_0(W(1,36),W(1,15),W(1,29),GC_11,AMP(81))
      CALL FFV1P0_3(W(1,23),W(1,31),GC_11,ZERO,ZERO,W(1,44))
C     Amplitude(s) for diagram number 78
      CALL VVV1_0(W(1,9),W(1,7),W(1,44),GC_10,AMP(82))
      CALL FFV1_2(W(1,23),W(1,9),GC_11,ZERO,ZERO,W(1,45))
C     Amplitude(s) for diagram number 79
      CALL FFV1_0(W(1,45),W(1,31),W(1,7),GC_11,AMP(83))
C     Amplitude(s) for diagram number 80
      CALL FFV1_0(W(1,42),W(1,31),W(1,9),GC_11,AMP(84))
C     Amplitude(s) for diagram number 81
      CALL FFV1_0(W(1,17),W(1,6),W(1,44),GC_11,AMP(85))
C     Amplitude(s) for diagram number 82
      CALL FFV1_0(W(1,3),W(1,15),W(1,44),GC_11,AMP(86))
      CALL FFV1P0_3(W(1,3),W(1,34),GC_11,ZERO,ZERO,W(1,44))
C     Amplitude(s) for diagram number 83
      CALL VVV1_0(W(1,29),W(1,44),W(1,7),GC_10,AMP(87))
      CALL FFV1_1(W(1,34),W(1,7),GC_11,ZERO,ZERO,W(1,46))
C     Amplitude(s) for diagram number 84
      CALL FFV1_0(W(1,3),W(1,46),W(1,29),GC_11,AMP(88))
C     Amplitude(s) for diagram number 85
      CALL FFV1_0(W(1,42),W(1,5),W(1,44),GC_11,AMP(89))
C     Amplitude(s) for diagram number 86
      CALL FFV1_0(W(1,17),W(1,34),W(1,29),GC_11,AMP(90))
C     Amplitude(s) for diagram number 87
      CALL FFV1_0(W(1,3),W(1,34),W(1,43),GC_11,AMP(91))
      CALL FFV1_2(W(1,3),W(1,35),GC_11,ZERO,ZERO,W(1,47))
C     Amplitude(s) for diagram number 88
      CALL FFV1_0(W(1,47),W(1,6),W(1,29),GC_11,AMP(92))
      CALL FFV1_1(W(1,6),W(1,35),GC_11,ZERO,ZERO,W(1,48))
C     Amplitude(s) for diagram number 89
      CALL FFV1_0(W(1,3),W(1,48),W(1,29),GC_11,AMP(93))
      CALL FFV1_2(W(1,23),W(1,35),GC_11,ZERO,ZERO,W(1,49))
C     Amplitude(s) for diagram number 90
      CALL FFV1_0(W(1,49),W(1,5),W(1,9),GC_11,AMP(94))
C     Amplitude(s) for diagram number 91
      CALL FFV1_0(W(1,45),W(1,5),W(1,35),GC_11,AMP(95))
C     Amplitude(s) for diagram number 92
      CALL VVV1_0(W(1,35),W(1,9),W(1,29),GC_10,AMP(96))
      CALL FFV1_2(W(1,23),W(1,2),GC_11,ZERO,ZERO,W(1,49))
C     Amplitude(s) for diagram number 93
      CALL FFV1_0(W(1,49),W(1,11),W(1,7),GC_11,AMP(97))
C     Amplitude(s) for diagram number 94
      CALL FFV1_0(W(1,49),W(1,5),W(1,12),GC_11,AMP(98))
      CALL VVV1P0_1(W(1,2),W(1,9),GC_10,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 95
      CALL VVV1_0(W(1,29),W(1,23),W(1,7),GC_10,AMP(99))
C     Amplitude(s) for diagram number 96
      CALL VVV1_0(W(1,29),W(1,2),W(1,12),GC_10,AMP(100))
C     Amplitude(s) for diagram number 97
      CALL VVVV1_0(W(1,2),W(1,9),W(1,7),W(1,29),GC_12,AMP(101))
      CALL VVVV3_0(W(1,2),W(1,9),W(1,7),W(1,29),GC_12,AMP(102))
      CALL VVVV4_0(W(1,2),W(1,9),W(1,7),W(1,29),GC_12,AMP(103))
C     Amplitude(s) for diagram number 98
      CALL FFV1_0(W(1,42),W(1,5),W(1,23),GC_11,AMP(104))
C     Amplitude(s) for diagram number 99
      CALL FFV1_0(W(1,42),W(1,11),W(1,2),GC_11,AMP(105))
C     Amplitude(s) for diagram number 100
      CALL FFV1_0(W(1,49),W(1,20),W(1,9),GC_11,AMP(106))
C     Amplitude(s) for diagram number 101
      CALL FFV1_0(W(1,45),W(1,20),W(1,2),GC_11,AMP(107))
C     Amplitude(s) for diagram number 102
      CALL VVV1_0(W(1,2),W(1,9),W(1,43),GC_10,AMP(108))
C     Amplitude(s) for diagram number 103
      CALL FFV1_0(W(1,49),W(1,5),W(1,21),GC_11,AMP(109))
      CALL FFV1_2(W(1,17),W(1,2),GC_11,ZERO,ZERO,W(1,43))
C     Amplitude(s) for diagram number 104
      CALL FFV1_0(W(1,43),W(1,6),W(1,29),GC_11,AMP(110))
C     Amplitude(s) for diagram number 105
      CALL VVV1_0(W(1,29),W(1,2),W(1,21),GC_10,AMP(111))
C     Amplitude(s) for diagram number 106
      CALL FFV1_0(W(1,49),W(1,5),W(1,22),GC_11,AMP(112))
      CALL FFV1_1(W(1,15),W(1,2),GC_11,ZERO,ZERO,W(1,49))
C     Amplitude(s) for diagram number 107
      CALL FFV1_0(W(1,3),W(1,49),W(1,29),GC_11,AMP(113))
C     Amplitude(s) for diagram number 108
      CALL VVV1_0(W(1,29),W(1,2),W(1,22),GC_10,AMP(114))
      CALL FFV1_1(W(1,5),W(1,1),GC_11,ZERO,ZERO,W(1,29))
      CALL FFV1P0_3(W(1,4),W(1,29),GC_11,ZERO,ZERO,W(1,45))
C     Amplitude(s) for diagram number 109
      CALL VVV1_0(W(1,45),W(1,40),W(1,7),GC_10,AMP(115))
C     Amplitude(s) for diagram number 110
      CALL FFV1_0(W(1,41),W(1,6),W(1,45),GC_11,AMP(116))
      CALL FFV1_1(W(1,29),W(1,7),GC_11,ZERO,ZERO,W(1,42))
C     Amplitude(s) for diagram number 111
      CALL FFV1_0(W(1,4),W(1,42),W(1,40),GC_11,AMP(117))
      CALL FFV1P0_3(W(1,19),W(1,29),GC_11,ZERO,ZERO,W(1,50))
C     Amplitude(s) for diagram number 112
      CALL FFV1_0(W(1,36),W(1,6),W(1,50),GC_11,AMP(118))
C     Amplitude(s) for diagram number 113
      CALL FFV1_0(W(1,36),W(1,15),W(1,45),GC_11,AMP(119))
      CALL FFV1P0_3(W(1,10),W(1,29),GC_11,ZERO,ZERO,W(1,51))
C     Amplitude(s) for diagram number 114
      CALL VVV1_0(W(1,9),W(1,7),W(1,51),GC_10,AMP(120))
      CALL FFV1_1(W(1,29),W(1,9),GC_11,ZERO,ZERO,W(1,52))
C     Amplitude(s) for diagram number 115
      CALL FFV1_0(W(1,10),W(1,52),W(1,7),GC_11,AMP(121))
C     Amplitude(s) for diagram number 116
      CALL FFV1_0(W(1,10),W(1,42),W(1,9),GC_11,AMP(122))
C     Amplitude(s) for diagram number 117
      CALL FFV1_0(W(1,17),W(1,6),W(1,51),GC_11,AMP(123))
C     Amplitude(s) for diagram number 118
      CALL FFV1_0(W(1,3),W(1,15),W(1,51),GC_11,AMP(124))
C     Amplitude(s) for diagram number 119
      CALL VVV1_0(W(1,45),W(1,44),W(1,7),GC_10,AMP(125))
C     Amplitude(s) for diagram number 120
      CALL FFV1_0(W(1,3),W(1,46),W(1,45),GC_11,AMP(126))
C     Amplitude(s) for diagram number 121
      CALL FFV1_0(W(1,4),W(1,42),W(1,44),GC_11,AMP(127))
C     Amplitude(s) for diagram number 122
      CALL FFV1_0(W(1,17),W(1,34),W(1,45),GC_11,AMP(128))
C     Amplitude(s) for diagram number 123
      CALL FFV1_0(W(1,3),W(1,34),W(1,50),GC_11,AMP(129))
C     Amplitude(s) for diagram number 124
      CALL FFV1_0(W(1,47),W(1,6),W(1,45),GC_11,AMP(130))
C     Amplitude(s) for diagram number 125
      CALL FFV1_0(W(1,3),W(1,48),W(1,45),GC_11,AMP(131))
      CALL FFV1_1(W(1,29),W(1,35),GC_11,ZERO,ZERO,W(1,51))
C     Amplitude(s) for diagram number 126
      CALL FFV1_0(W(1,4),W(1,51),W(1,9),GC_11,AMP(132))
C     Amplitude(s) for diagram number 127
      CALL FFV1_0(W(1,4),W(1,52),W(1,35),GC_11,AMP(133))
C     Amplitude(s) for diagram number 128
      CALL VVV1_0(W(1,35),W(1,9),W(1,45),GC_10,AMP(134))
      CALL FFV1_1(W(1,29),W(1,2),GC_11,ZERO,ZERO,W(1,51))
C     Amplitude(s) for diagram number 129
      CALL FFV1_0(W(1,14),W(1,51),W(1,7),GC_11,AMP(135))
C     Amplitude(s) for diagram number 130
      CALL FFV1_0(W(1,4),W(1,51),W(1,12),GC_11,AMP(136))
C     Amplitude(s) for diagram number 131
      CALL VVV1_0(W(1,45),W(1,23),W(1,7),GC_10,AMP(137))
C     Amplitude(s) for diagram number 132
      CALL VVV1_0(W(1,45),W(1,2),W(1,12),GC_10,AMP(138))
C     Amplitude(s) for diagram number 133
      CALL VVVV1_0(W(1,2),W(1,9),W(1,7),W(1,45),GC_12,AMP(139))
      CALL VVVV3_0(W(1,2),W(1,9),W(1,7),W(1,45),GC_12,AMP(140))
      CALL VVVV4_0(W(1,2),W(1,9),W(1,7),W(1,45),GC_12,AMP(141))
C     Amplitude(s) for diagram number 134
      CALL FFV1_0(W(1,4),W(1,42),W(1,23),GC_11,AMP(142))
C     Amplitude(s) for diagram number 135
      CALL FFV1_0(W(1,14),W(1,42),W(1,2),GC_11,AMP(143))
C     Amplitude(s) for diagram number 136
      CALL FFV1_0(W(1,19),W(1,51),W(1,9),GC_11,AMP(144))
C     Amplitude(s) for diagram number 137
      CALL FFV1_0(W(1,19),W(1,52),W(1,2),GC_11,AMP(145))
C     Amplitude(s) for diagram number 138
      CALL VVV1_0(W(1,2),W(1,9),W(1,50),GC_10,AMP(146))
C     Amplitude(s) for diagram number 139
      CALL FFV1_0(W(1,4),W(1,51),W(1,21),GC_11,AMP(147))
C     Amplitude(s) for diagram number 140
      CALL FFV1_0(W(1,43),W(1,6),W(1,45),GC_11,AMP(148))
C     Amplitude(s) for diagram number 141
      CALL VVV1_0(W(1,45),W(1,2),W(1,21),GC_10,AMP(149))
C     Amplitude(s) for diagram number 142
      CALL FFV1_0(W(1,4),W(1,51),W(1,22),GC_11,AMP(150))
C     Amplitude(s) for diagram number 143
      CALL FFV1_0(W(1,3),W(1,49),W(1,45),GC_11,AMP(151))
C     Amplitude(s) for diagram number 144
      CALL VVV1_0(W(1,45),W(1,2),W(1,22),GC_10,AMP(152))
      CALL FFV1_1(W(1,6),W(1,1),GC_11,ZERO,ZERO,W(1,45))
      CALL FFV1P0_3(W(1,36),W(1,45),GC_11,ZERO,ZERO,W(1,51))
C     Amplitude(s) for diagram number 145
      CALL VVV1_0(W(1,16),W(1,7),W(1,51),GC_10,AMP(153))
      CALL FFV1_1(W(1,45),W(1,16),GC_11,ZERO,ZERO,W(1,50))
C     Amplitude(s) for diagram number 146
      CALL FFV1_0(W(1,36),W(1,50),W(1,7),GC_11,AMP(154))
      CALL FFV1_1(W(1,45),W(1,7),GC_11,ZERO,ZERO,W(1,52))
C     Amplitude(s) for diagram number 147
      CALL FFV1_0(W(1,36),W(1,52),W(1,16),GC_11,AMP(155))
C     Amplitude(s) for diagram number 148
      CALL FFV1_0(W(1,19),W(1,5),W(1,51),GC_11,AMP(156))
C     Amplitude(s) for diagram number 149
      CALL FFV1_0(W(1,4),W(1,20),W(1,51),GC_11,AMP(157))
      CALL FFV1P0_3(W(1,3),W(1,45),GC_11,ZERO,ZERO,W(1,51))
C     Amplitude(s) for diagram number 150
      CALL VVV1_0(W(1,51),W(1,27),W(1,7),GC_10,AMP(158))
C     Amplitude(s) for diagram number 151
      CALL FFV1_0(W(1,28),W(1,5),W(1,51),GC_11,AMP(159))
C     Amplitude(s) for diagram number 152
      CALL FFV1_0(W(1,3),W(1,52),W(1,27),GC_11,AMP(160))
      CALL FFV1P0_3(W(1,17),W(1,45),GC_11,ZERO,ZERO,W(1,42))
C     Amplitude(s) for diagram number 153
      CALL FFV1_0(W(1,10),W(1,5),W(1,42),GC_11,AMP(161))
C     Amplitude(s) for diagram number 154
      CALL FFV1_0(W(1,10),W(1,20),W(1,51),GC_11,AMP(162))
C     Amplitude(s) for diagram number 155
      CALL VVV1_0(W(1,51),W(1,32),W(1,7),GC_10,AMP(163))
C     Amplitude(s) for diagram number 156
      CALL FFV1_0(W(1,4),W(1,33),W(1,51),GC_11,AMP(164))
C     Amplitude(s) for diagram number 157
      CALL FFV1_0(W(1,3),W(1,52),W(1,32),GC_11,AMP(165))
C     Amplitude(s) for diagram number 158
      CALL FFV1_0(W(1,4),W(1,31),W(1,42),GC_11,AMP(166))
C     Amplitude(s) for diagram number 159
      CALL FFV1_0(W(1,19),W(1,31),W(1,51),GC_11,AMP(167))
C     Amplitude(s) for diagram number 160
      CALL FFV1_0(W(1,37),W(1,5),W(1,51),GC_11,AMP(168))
C     Amplitude(s) for diagram number 161
      CALL FFV1_0(W(1,4),W(1,38),W(1,51),GC_11,AMP(169))
      CALL FFV1_1(W(1,45),W(1,35),GC_11,ZERO,ZERO,W(1,29))
C     Amplitude(s) for diagram number 162
      CALL FFV1_0(W(1,3),W(1,29),W(1,16),GC_11,AMP(170))
C     Amplitude(s) for diagram number 163
      CALL VVV1_0(W(1,35),W(1,16),W(1,51),GC_10,AMP(171))
C     Amplitude(s) for diagram number 164
      CALL FFV1_0(W(1,3),W(1,50),W(1,35),GC_11,AMP(172))
      CALL FFV1_1(W(1,45),W(1,2),GC_11,ZERO,ZERO,W(1,29))
C     Amplitude(s) for diagram number 165
      CALL FFV1_0(W(1,17),W(1,29),W(1,16),GC_11,AMP(173))
C     Amplitude(s) for diagram number 166
      CALL VVV1_0(W(1,2),W(1,16),W(1,42),GC_10,AMP(174))
C     Amplitude(s) for diagram number 167
      CALL FFV1_0(W(1,17),W(1,50),W(1,2),GC_11,AMP(175))
C     Amplitude(s) for diagram number 168
      CALL FFV1_0(W(1,26),W(1,29),W(1,7),GC_11,AMP(176))
C     Amplitude(s) for diagram number 169
      CALL FFV1_0(W(1,3),W(1,29),W(1,25),GC_11,AMP(177))
C     Amplitude(s) for diagram number 170
      CALL VVV1_0(W(1,51),W(1,13),W(1,7),GC_10,AMP(178))
C     Amplitude(s) for diagram number 171
      CALL VVV1_0(W(1,51),W(1,2),W(1,25),GC_10,AMP(179))
C     Amplitude(s) for diagram number 172
      CALL VVVV1_0(W(1,2),W(1,16),W(1,7),W(1,51),GC_12,AMP(180))
      CALL VVVV3_0(W(1,2),W(1,16),W(1,7),W(1,51),GC_12,AMP(181))
      CALL VVVV4_0(W(1,2),W(1,16),W(1,7),W(1,51),GC_12,AMP(182))
C     Amplitude(s) for diagram number 173
      CALL FFV1_0(W(1,3),W(1,52),W(1,13),GC_11,AMP(183))
C     Amplitude(s) for diagram number 174
      CALL FFV1_0(W(1,26),W(1,52),W(1,2),GC_11,AMP(184))
C     Amplitude(s) for diagram number 175
      CALL FFV1_0(W(1,3),W(1,29),W(1,18),GC_11,AMP(185))
C     Amplitude(s) for diagram number 176
      CALL FFV1_0(W(1,30),W(1,5),W(1,51),GC_11,AMP(186))
C     Amplitude(s) for diagram number 177
      CALL VVV1_0(W(1,51),W(1,2),W(1,18),GC_10,AMP(187))
C     Amplitude(s) for diagram number 178
      CALL FFV1_0(W(1,3),W(1,29),W(1,8),GC_11,AMP(188))
C     Amplitude(s) for diagram number 179
      CALL FFV1_0(W(1,4),W(1,39),W(1,51),GC_11,AMP(189))
C     Amplitude(s) for diagram number 180
      CALL VVV1_0(W(1,51),W(1,2),W(1,8),GC_10,AMP(190))
      CALL VVV1P0_1(W(1,1),W(1,7),GC_10,ZERO,ZERO,W(1,51))
      CALL FFV1_2(W(1,4),W(1,51),GC_11,ZERO,ZERO,W(1,29))
C     Amplitude(s) for diagram number 181
      CALL FFV1_0(W(1,29),W(1,5),W(1,40),GC_11,AMP(191))
      CALL FFV1_1(W(1,5),W(1,51),GC_11,ZERO,ZERO,W(1,52))
C     Amplitude(s) for diagram number 182
      CALL FFV1_0(W(1,4),W(1,52),W(1,40),GC_11,AMP(192))
      CALL FFV1_2(W(1,36),W(1,51),GC_11,ZERO,ZERO,W(1,50))
C     Amplitude(s) for diagram number 183
      CALL FFV1_0(W(1,50),W(1,6),W(1,16),GC_11,AMP(193))
      CALL VVV1P0_1(W(1,51),W(1,16),GC_10,ZERO,ZERO,W(1,50))
C     Amplitude(s) for diagram number 184
      CALL FFV1_0(W(1,36),W(1,6),W(1,50),GC_11,AMP(194))
      CALL FFV1_1(W(1,6),W(1,51),GC_11,ZERO,ZERO,W(1,42))
C     Amplitude(s) for diagram number 185
      CALL FFV1_0(W(1,36),W(1,42),W(1,16),GC_11,AMP(195))
      CALL FFV1_2(W(1,3),W(1,51),GC_11,ZERO,ZERO,W(1,45))
C     Amplitude(s) for diagram number 186
      CALL FFV1_0(W(1,45),W(1,6),W(1,27),GC_11,AMP(196))
C     Amplitude(s) for diagram number 187
      CALL FFV1_0(W(1,3),W(1,42),W(1,27),GC_11,AMP(197))
      CALL FFV1_2(W(1,10),W(1,51),GC_11,ZERO,ZERO,W(1,53))
C     Amplitude(s) for diagram number 188
      CALL FFV1_0(W(1,53),W(1,5),W(1,9),GC_11,AMP(198))
      CALL VVV1P0_1(W(1,51),W(1,9),GC_10,ZERO,ZERO,W(1,53))
C     Amplitude(s) for diagram number 189
      CALL FFV1_0(W(1,10),W(1,5),W(1,53),GC_11,AMP(199))
C     Amplitude(s) for diagram number 190
      CALL FFV1_0(W(1,10),W(1,52),W(1,9),GC_11,AMP(200))
C     Amplitude(s) for diagram number 191
      CALL FFV1_0(W(1,45),W(1,6),W(1,32),GC_11,AMP(201))
C     Amplitude(s) for diagram number 192
      CALL FFV1_0(W(1,3),W(1,42),W(1,32),GC_11,AMP(202))
      CALL FFV1_1(W(1,31),W(1,51),GC_11,ZERO,ZERO,W(1,54))
C     Amplitude(s) for diagram number 193
      CALL FFV1_0(W(1,4),W(1,54),W(1,9),GC_11,AMP(203))
C     Amplitude(s) for diagram number 194
      CALL FFV1_0(W(1,4),W(1,31),W(1,53),GC_11,AMP(204))
C     Amplitude(s) for diagram number 195
      CALL FFV1_0(W(1,29),W(1,31),W(1,9),GC_11,AMP(205))
C     Amplitude(s) for diagram number 196
      CALL FFV1_0(W(1,29),W(1,5),W(1,44),GC_11,AMP(206))
C     Amplitude(s) for diagram number 197
      CALL FFV1_0(W(1,4),W(1,52),W(1,44),GC_11,AMP(207))
      CALL FFV1_1(W(1,34),W(1,51),GC_11,ZERO,ZERO,W(1,54))
C     Amplitude(s) for diagram number 198
      CALL FFV1_0(W(1,3),W(1,54),W(1,16),GC_11,AMP(208))
C     Amplitude(s) for diagram number 199
      CALL FFV1_0(W(1,45),W(1,34),W(1,16),GC_11,AMP(209))
C     Amplitude(s) for diagram number 200
      CALL FFV1_0(W(1,3),W(1,34),W(1,50),GC_11,AMP(210))
      CALL VVV1P0_1(W(1,51),W(1,2),GC_10,ZERO,ZERO,W(1,54))
C     Amplitude(s) for diagram number 201
      CALL FFV1_0(W(1,14),W(1,5),W(1,54),GC_11,AMP(211))
C     Amplitude(s) for diagram number 202
      CALL FFV1_0(W(1,4),W(1,11),W(1,54),GC_11,AMP(212))
C     Amplitude(s) for diagram number 203
      CALL FFV1_0(W(1,29),W(1,5),W(1,23),GC_11,AMP(213))
C     Amplitude(s) for diagram number 204
      CALL FFV1_0(W(1,29),W(1,11),W(1,2),GC_11,AMP(214))
C     Amplitude(s) for diagram number 205
      CALL FFV1_0(W(1,4),W(1,52),W(1,23),GC_11,AMP(215))
C     Amplitude(s) for diagram number 206
      CALL FFV1_0(W(1,14),W(1,52),W(1,2),GC_11,AMP(216))
C     Amplitude(s) for diagram number 207
      CALL VVVV1_0(W(1,51),W(1,2),W(1,9),W(1,16),GC_12,AMP(217))
      CALL VVVV3_0(W(1,51),W(1,2),W(1,9),W(1,16),GC_12,AMP(218))
      CALL VVVV4_0(W(1,51),W(1,2),W(1,9),W(1,16),GC_12,AMP(219))
C     Amplitude(s) for diagram number 208
      CALL VVV1_0(W(1,9),W(1,16),W(1,54),GC_10,AMP(220))
C     Amplitude(s) for diagram number 209
      CALL VVV1_0(W(1,2),W(1,16),W(1,53),GC_10,AMP(221))
C     Amplitude(s) for diagram number 210
      CALL VVV1_0(W(1,2),W(1,9),W(1,50),GC_10,AMP(222))
C     Amplitude(s) for diagram number 211
      CALL FFV1_0(W(1,26),W(1,6),W(1,54),GC_11,AMP(223))
C     Amplitude(s) for diagram number 212
      CALL FFV1_0(W(1,3),W(1,24),W(1,54),GC_11,AMP(224))
C     Amplitude(s) for diagram number 213
      CALL FFV1_0(W(1,45),W(1,6),W(1,13),GC_11,AMP(225))
C     Amplitude(s) for diagram number 214
      CALL FFV1_0(W(1,45),W(1,24),W(1,2),GC_11,AMP(226))
C     Amplitude(s) for diagram number 215
      CALL FFV1_0(W(1,3),W(1,42),W(1,13),GC_11,AMP(227))
C     Amplitude(s) for diagram number 216
      CALL FFV1_0(W(1,26),W(1,42),W(1,2),GC_11,AMP(228))
      CALL FFV1_2(W(1,36),W(1,1),GC_11,ZERO,ZERO,W(1,42))
C     Amplitude(s) for diagram number 217
      CALL FFV1_0(W(1,42),W(1,24),W(1,7),GC_11,AMP(229))
C     Amplitude(s) for diagram number 218
      CALL FFV1_0(W(1,42),W(1,6),W(1,25),GC_11,AMP(230))
      CALL VVV1P0_1(W(1,1),W(1,16),GC_10,ZERO,ZERO,W(1,45))
C     Amplitude(s) for diagram number 219
      CALL VVV1_0(W(1,45),W(1,40),W(1,7),GC_10,AMP(231))
C     Amplitude(s) for diagram number 220
      CALL FFV1_0(W(1,41),W(1,6),W(1,45),GC_11,AMP(232))
C     Amplitude(s) for diagram number 221
      CALL VVV1_0(W(1,1),W(1,40),W(1,25),GC_10,AMP(233))
C     Amplitude(s) for diagram number 222
      CALL FFV1_0(W(1,41),W(1,24),W(1,1),GC_11,AMP(234))
      CALL VVVV1P0_1(W(1,1),W(1,16),W(1,7),GC_12,ZERO,ZERO,W(1,41))
      CALL VVVV3P0_1(W(1,1),W(1,16),W(1,7),GC_12,ZERO,ZERO,W(1,54))
      CALL VVVV4P0_1(W(1,1),W(1,16),W(1,7),GC_12,ZERO,ZERO,W(1,50))
C     Amplitude(s) for diagram number 223
      CALL FFV1_0(W(1,36),W(1,6),W(1,41),GC_11,AMP(235))
      CALL FFV1_0(W(1,36),W(1,6),W(1,54),GC_11,AMP(236))
      CALL FFV1_0(W(1,36),W(1,6),W(1,50),GC_11,AMP(237))
C     Amplitude(s) for diagram number 224
      CALL FFV1_0(W(1,42),W(1,15),W(1,16),GC_11,AMP(238))
C     Amplitude(s) for diagram number 225
      CALL FFV1_0(W(1,36),W(1,15),W(1,45),GC_11,AMP(239))
      CALL FFV1_1(W(1,15),W(1,1),GC_11,ZERO,ZERO,W(1,53))
C     Amplitude(s) for diagram number 226
      CALL FFV1_0(W(1,36),W(1,53),W(1,16),GC_11,AMP(240))
C     Amplitude(s) for diagram number 227
      CALL FFV1_0(W(1,42),W(1,6),W(1,18),GC_11,AMP(241))
      CALL FFV1_2(W(1,19),W(1,1),GC_11,ZERO,ZERO,W(1,36))
C     Amplitude(s) for diagram number 228
      CALL FFV1_0(W(1,36),W(1,5),W(1,40),GC_11,AMP(242))
C     Amplitude(s) for diagram number 229
      CALL VVV1_0(W(1,1),W(1,40),W(1,18),GC_10,AMP(243))
C     Amplitude(s) for diagram number 230
      CALL FFV1_0(W(1,42),W(1,6),W(1,8),GC_11,AMP(244))
      CALL FFV1_1(W(1,20),W(1,1),GC_11,ZERO,ZERO,W(1,42))
C     Amplitude(s) for diagram number 231
      CALL FFV1_0(W(1,4),W(1,42),W(1,40),GC_11,AMP(245))
C     Amplitude(s) for diagram number 232
      CALL VVV1_0(W(1,1),W(1,40),W(1,8),GC_10,AMP(246))
      CALL FFV1_2(W(1,10),W(1,1),GC_11,ZERO,ZERO,W(1,40))
C     Amplitude(s) for diagram number 233
      CALL FFV1_0(W(1,40),W(1,11),W(1,7),GC_11,AMP(247))
C     Amplitude(s) for diagram number 234
      CALL FFV1_0(W(1,40),W(1,5),W(1,12),GC_11,AMP(248))
      CALL VVV1P0_1(W(1,1),W(1,9),GC_10,ZERO,ZERO,W(1,51))
C     Amplitude(s) for diagram number 235
      CALL VVV1_0(W(1,51),W(1,27),W(1,7),GC_10,AMP(249))
C     Amplitude(s) for diagram number 236
      CALL FFV1_0(W(1,28),W(1,5),W(1,51),GC_11,AMP(250))
C     Amplitude(s) for diagram number 237
      CALL VVV1_0(W(1,1),W(1,27),W(1,12),GC_10,AMP(251))
C     Amplitude(s) for diagram number 238
      CALL FFV1_0(W(1,28),W(1,11),W(1,1),GC_11,AMP(252))
      CALL VVVV1P0_1(W(1,1),W(1,9),W(1,7),GC_12,ZERO,ZERO,W(1,28))
      CALL VVVV3P0_1(W(1,1),W(1,9),W(1,7),GC_12,ZERO,ZERO,W(1,52))
      CALL VVVV4P0_1(W(1,1),W(1,9),W(1,7),GC_12,ZERO,ZERO,W(1,29))
C     Amplitude(s) for diagram number 239
      CALL FFV1_0(W(1,10),W(1,5),W(1,28),GC_11,AMP(253))
      CALL FFV1_0(W(1,10),W(1,5),W(1,52),GC_11,AMP(254))
      CALL FFV1_0(W(1,10),W(1,5),W(1,29),GC_11,AMP(255))
C     Amplitude(s) for diagram number 240
      CALL FFV1_0(W(1,40),W(1,20),W(1,9),GC_11,AMP(256))
C     Amplitude(s) for diagram number 241
      CALL FFV1_0(W(1,10),W(1,20),W(1,51),GC_11,AMP(257))
C     Amplitude(s) for diagram number 242
      CALL FFV1_0(W(1,10),W(1,42),W(1,9),GC_11,AMP(258))
C     Amplitude(s) for diagram number 243
      CALL FFV1_0(W(1,40),W(1,5),W(1,21),GC_11,AMP(259))
      CALL FFV1_2(W(1,17),W(1,1),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 244
      CALL FFV1_0(W(1,10),W(1,6),W(1,27),GC_11,AMP(260))
C     Amplitude(s) for diagram number 245
      CALL VVV1_0(W(1,1),W(1,27),W(1,21),GC_10,AMP(261))
C     Amplitude(s) for diagram number 246
      CALL FFV1_0(W(1,40),W(1,5),W(1,22),GC_11,AMP(262))
C     Amplitude(s) for diagram number 247
      CALL FFV1_0(W(1,3),W(1,53),W(1,27),GC_11,AMP(263))
C     Amplitude(s) for diagram number 248
      CALL VVV1_0(W(1,1),W(1,27),W(1,22),GC_10,AMP(264))
      CALL FFV1_1(W(1,31),W(1,1),GC_11,ZERO,ZERO,W(1,27))
C     Amplitude(s) for diagram number 249
      CALL FFV1_0(W(1,14),W(1,27),W(1,7),GC_11,AMP(265))
C     Amplitude(s) for diagram number 250
      CALL FFV1_0(W(1,4),W(1,27),W(1,12),GC_11,AMP(266))
C     Amplitude(s) for diagram number 251
      CALL VVV1_0(W(1,51),W(1,32),W(1,7),GC_10,AMP(267))
C     Amplitude(s) for diagram number 252
      CALL FFV1_0(W(1,4),W(1,33),W(1,51),GC_11,AMP(268))
C     Amplitude(s) for diagram number 253
      CALL VVV1_0(W(1,1),W(1,32),W(1,12),GC_10,AMP(269))
C     Amplitude(s) for diagram number 254
      CALL FFV1_0(W(1,14),W(1,33),W(1,1),GC_11,AMP(270))
C     Amplitude(s) for diagram number 255
      CALL FFV1_0(W(1,4),W(1,31),W(1,28),GC_11,AMP(271))
      CALL FFV1_0(W(1,4),W(1,31),W(1,52),GC_11,AMP(272))
      CALL FFV1_0(W(1,4),W(1,31),W(1,29),GC_11,AMP(273))
C     Amplitude(s) for diagram number 256
      CALL FFV1_0(W(1,19),W(1,27),W(1,9),GC_11,AMP(274))
C     Amplitude(s) for diagram number 257
      CALL FFV1_0(W(1,19),W(1,31),W(1,51),GC_11,AMP(275))
C     Amplitude(s) for diagram number 258
      CALL FFV1_0(W(1,36),W(1,31),W(1,9),GC_11,AMP(276))
C     Amplitude(s) for diagram number 259
      CALL FFV1_0(W(1,4),W(1,27),W(1,21),GC_11,AMP(277))
C     Amplitude(s) for diagram number 260
      CALL FFV1_0(W(1,10),W(1,6),W(1,32),GC_11,AMP(278))
C     Amplitude(s) for diagram number 261
      CALL VVV1_0(W(1,1),W(1,32),W(1,21),GC_10,AMP(279))
C     Amplitude(s) for diagram number 262
      CALL FFV1_0(W(1,4),W(1,27),W(1,22),GC_11,AMP(280))
C     Amplitude(s) for diagram number 263
      CALL FFV1_0(W(1,3),W(1,53),W(1,32),GC_11,AMP(281))
C     Amplitude(s) for diagram number 264
      CALL VVV1_0(W(1,1),W(1,32),W(1,22),GC_10,AMP(282))
      CALL FFV1_1(W(1,34),W(1,1),GC_11,ZERO,ZERO,W(1,32))
C     Amplitude(s) for diagram number 265
      CALL FFV1_0(W(1,17),W(1,32),W(1,16),GC_11,AMP(283))
C     Amplitude(s) for diagram number 266
      CALL FFV1_0(W(1,10),W(1,34),W(1,16),GC_11,AMP(284))
C     Amplitude(s) for diagram number 267
      CALL FFV1_0(W(1,17),W(1,34),W(1,45),GC_11,AMP(285))
C     Amplitude(s) for diagram number 268
      CALL FFV1_0(W(1,26),W(1,32),W(1,7),GC_11,AMP(286))
C     Amplitude(s) for diagram number 269
      CALL FFV1_0(W(1,3),W(1,32),W(1,25),GC_11,AMP(287))
C     Amplitude(s) for diagram number 270
      CALL VVV1_0(W(1,45),W(1,44),W(1,7),GC_10,AMP(288))
C     Amplitude(s) for diagram number 271
      CALL FFV1_0(W(1,3),W(1,46),W(1,45),GC_11,AMP(289))
C     Amplitude(s) for diagram number 272
      CALL VVV1_0(W(1,1),W(1,44),W(1,25),GC_10,AMP(290))
C     Amplitude(s) for diagram number 273
      CALL FFV1_0(W(1,26),W(1,46),W(1,1),GC_11,AMP(291))
C     Amplitude(s) for diagram number 274
      CALL FFV1_0(W(1,3),W(1,34),W(1,41),GC_11,AMP(292))
      CALL FFV1_0(W(1,3),W(1,34),W(1,54),GC_11,AMP(293))
      CALL FFV1_0(W(1,3),W(1,34),W(1,50),GC_11,AMP(294))
C     Amplitude(s) for diagram number 275
      CALL FFV1_0(W(1,3),W(1,32),W(1,18),GC_11,AMP(295))
C     Amplitude(s) for diagram number 276
      CALL FFV1_0(W(1,36),W(1,5),W(1,44),GC_11,AMP(296))
C     Amplitude(s) for diagram number 277
      CALL VVV1_0(W(1,1),W(1,44),W(1,18),GC_10,AMP(297))
C     Amplitude(s) for diagram number 278
      CALL FFV1_0(W(1,3),W(1,32),W(1,8),GC_11,AMP(298))
C     Amplitude(s) for diagram number 279
      CALL FFV1_0(W(1,4),W(1,42),W(1,44),GC_11,AMP(299))
C     Amplitude(s) for diagram number 280
      CALL VVV1_0(W(1,1),W(1,44),W(1,8),GC_10,AMP(300))
      CALL VVV1P0_1(W(1,1),W(1,35),GC_10,ZERO,ZERO,W(1,44))
C     Amplitude(s) for diagram number 281
      CALL FFV1_0(W(1,14),W(1,5),W(1,44),GC_11,AMP(301))
C     Amplitude(s) for diagram number 282
      CALL FFV1_0(W(1,4),W(1,11),W(1,44),GC_11,AMP(302))
C     Amplitude(s) for diagram number 283
      CALL FFV1_0(W(1,37),W(1,5),W(1,51),GC_11,AMP(303))
C     Amplitude(s) for diagram number 284
      CALL FFV1_0(W(1,4),W(1,38),W(1,51),GC_11,AMP(304))
C     Amplitude(s) for diagram number 285
      CALL FFV1_0(W(1,37),W(1,11),W(1,1),GC_11,AMP(305))
C     Amplitude(s) for diagram number 286
      CALL FFV1_0(W(1,14),W(1,38),W(1,1),GC_11,AMP(306))
C     Amplitude(s) for diagram number 287
      CALL VVVV1_0(W(1,1),W(1,35),W(1,9),W(1,16),GC_12,AMP(307))
      CALL VVVV3_0(W(1,1),W(1,35),W(1,9),W(1,16),GC_12,AMP(308))
      CALL VVVV4_0(W(1,1),W(1,35),W(1,9),W(1,16),GC_12,AMP(309))
C     Amplitude(s) for diagram number 288
      CALL VVV1_0(W(1,9),W(1,16),W(1,44),GC_10,AMP(310))
C     Amplitude(s) for diagram number 289
      CALL VVV1_0(W(1,35),W(1,16),W(1,51),GC_10,AMP(311))
C     Amplitude(s) for diagram number 290
      CALL VVV1_0(W(1,35),W(1,9),W(1,45),GC_10,AMP(312))
C     Amplitude(s) for diagram number 291
      CALL FFV1_0(W(1,26),W(1,6),W(1,44),GC_11,AMP(313))
C     Amplitude(s) for diagram number 292
      CALL FFV1_0(W(1,3),W(1,24),W(1,44),GC_11,AMP(314))
C     Amplitude(s) for diagram number 293
      CALL FFV1_0(W(1,47),W(1,6),W(1,45),GC_11,AMP(315))
C     Amplitude(s) for diagram number 294
      CALL FFV1_0(W(1,3),W(1,48),W(1,45),GC_11,AMP(316))
C     Amplitude(s) for diagram number 295
      CALL FFV1_0(W(1,47),W(1,24),W(1,1),GC_11,AMP(317))
C     Amplitude(s) for diagram number 296
      CALL FFV1_0(W(1,26),W(1,48),W(1,1),GC_11,AMP(318))
C     Amplitude(s) for diagram number 297
      CALL VVV1_0(W(1,51),W(1,13),W(1,7),GC_10,AMP(319))
C     Amplitude(s) for diagram number 298
      CALL VVV1_0(W(1,51),W(1,2),W(1,25),GC_10,AMP(320))
C     Amplitude(s) for diagram number 299
      CALL VVVV1_0(W(1,2),W(1,16),W(1,7),W(1,51),GC_12,AMP(321))
      CALL VVVV3_0(W(1,2),W(1,16),W(1,7),W(1,51),GC_12,AMP(322))
      CALL VVVV4_0(W(1,2),W(1,16),W(1,7),W(1,51),GC_12,AMP(323))
C     Amplitude(s) for diagram number 300
      CALL VVV1_0(W(1,45),W(1,23),W(1,7),GC_10,AMP(324))
C     Amplitude(s) for diagram number 301
      CALL VVV1_0(W(1,45),W(1,2),W(1,12),GC_10,AMP(325))
C     Amplitude(s) for diagram number 302
      CALL VVVV1_0(W(1,2),W(1,9),W(1,7),W(1,45),GC_12,AMP(326))
      CALL VVVV3_0(W(1,2),W(1,9),W(1,7),W(1,45),GC_12,AMP(327))
      CALL VVVV4_0(W(1,2),W(1,9),W(1,7),W(1,45),GC_12,AMP(328))
C     Amplitude(s) for diagram number 303
      CALL VVV1_0(W(1,1),W(1,23),W(1,25),GC_10,AMP(329))
C     Amplitude(s) for diagram number 304
      CALL VVV1_0(W(1,1),W(1,13),W(1,12),GC_10,AMP(330))
      CALL VVVV1P0_1(W(1,1),W(1,2),W(1,9),GC_12,ZERO,ZERO,W(1,12))
      CALL VVVV3P0_1(W(1,1),W(1,2),W(1,9),GC_12,ZERO,ZERO,W(1,25))
      CALL VVVV4P0_1(W(1,1),W(1,2),W(1,9),GC_12,ZERO,ZERO,W(1,48))
C     Amplitude(s) for diagram number 305
      CALL VVV1_0(W(1,16),W(1,7),W(1,12),GC_10,AMP(331))
      CALL VVV1_0(W(1,16),W(1,7),W(1,25),GC_10,AMP(332))
      CALL VVV1_0(W(1,16),W(1,7),W(1,48),GC_10,AMP(333))
      CALL VVVV1P0_1(W(1,1),W(1,2),W(1,16),GC_12,ZERO,ZERO,W(1,47))
      CALL VVVV3P0_1(W(1,1),W(1,2),W(1,16),GC_12,ZERO,ZERO,W(1,44))
      CALL VVVV4P0_1(W(1,1),W(1,2),W(1,16),GC_12,ZERO,ZERO,W(1,35))
C     Amplitude(s) for diagram number 306
      CALL VVV1_0(W(1,9),W(1,7),W(1,47),GC_10,AMP(334))
      CALL VVV1_0(W(1,9),W(1,7),W(1,44),GC_10,AMP(335))
      CALL VVV1_0(W(1,9),W(1,7),W(1,35),GC_10,AMP(336))
C     Amplitude(s) for diagram number 307
      CALL VVV1_0(W(1,2),W(1,16),W(1,28),GC_10,AMP(337))
      CALL VVV1_0(W(1,2),W(1,16),W(1,52),GC_10,AMP(338))
      CALL VVV1_0(W(1,2),W(1,16),W(1,29),GC_10,AMP(339))
C     Amplitude(s) for diagram number 308
      CALL VVV1_0(W(1,2),W(1,9),W(1,41),GC_10,AMP(340))
      CALL VVV1_0(W(1,2),W(1,9),W(1,54),GC_10,AMP(341))
      CALL VVV1_0(W(1,2),W(1,9),W(1,50),GC_10,AMP(342))
C     Amplitude(s) for diagram number 309
      CALL FFV1_0(W(1,30),W(1,5),W(1,51),GC_11,AMP(343))
C     Amplitude(s) for diagram number 310
      CALL VVV1_0(W(1,51),W(1,2),W(1,18),GC_10,AMP(344))
C     Amplitude(s) for diagram number 311
      CALL FFV1_0(W(1,36),W(1,5),W(1,23),GC_11,AMP(345))
C     Amplitude(s) for diagram number 312
      CALL FFV1_0(W(1,36),W(1,11),W(1,2),GC_11,AMP(346))
C     Amplitude(s) for diagram number 313
      CALL VVV1_0(W(1,1),W(1,23),W(1,18),GC_10,AMP(347))
C     Amplitude(s) for diagram number 314
      CALL FFV1_0(W(1,30),W(1,11),W(1,1),GC_11,AMP(348))
C     Amplitude(s) for diagram number 315
      CALL FFV1_0(W(1,19),W(1,5),W(1,12),GC_11,AMP(349))
      CALL FFV1_0(W(1,19),W(1,5),W(1,25),GC_11,AMP(350))
      CALL FFV1_0(W(1,19),W(1,5),W(1,48),GC_11,AMP(351))
C     Amplitude(s) for diagram number 316
      CALL FFV1_0(W(1,4),W(1,39),W(1,51),GC_11,AMP(352))
C     Amplitude(s) for diagram number 317
      CALL VVV1_0(W(1,51),W(1,2),W(1,8),GC_10,AMP(353))
C     Amplitude(s) for diagram number 318
      CALL FFV1_0(W(1,4),W(1,42),W(1,23),GC_11,AMP(354))
C     Amplitude(s) for diagram number 319
      CALL FFV1_0(W(1,14),W(1,42),W(1,2),GC_11,AMP(355))
C     Amplitude(s) for diagram number 320
      CALL VVV1_0(W(1,1),W(1,23),W(1,8),GC_10,AMP(356))
C     Amplitude(s) for diagram number 321
      CALL FFV1_0(W(1,14),W(1,39),W(1,1),GC_11,AMP(357))
C     Amplitude(s) for diagram number 322
      CALL FFV1_0(W(1,4),W(1,20),W(1,12),GC_11,AMP(358))
      CALL FFV1_0(W(1,4),W(1,20),W(1,25),GC_11,AMP(359))
      CALL FFV1_0(W(1,4),W(1,20),W(1,48),GC_11,AMP(360))
C     Amplitude(s) for diagram number 323
      CALL FFV1_0(W(1,10),W(1,6),W(1,13),GC_11,AMP(361))
C     Amplitude(s) for diagram number 324
      CALL FFV1_0(W(1,10),W(1,24),W(1,2),GC_11,AMP(362))
C     Amplitude(s) for diagram number 325
      CALL FFV1_0(W(1,43),W(1,6),W(1,45),GC_11,AMP(363))
C     Amplitude(s) for diagram number 326
      CALL VVV1_0(W(1,45),W(1,2),W(1,21),GC_10,AMP(364))
C     Amplitude(s) for diagram number 327
      CALL FFV1_0(W(1,43),W(1,24),W(1,1),GC_11,AMP(365))
C     Amplitude(s) for diagram number 328
      CALL VVV1_0(W(1,1),W(1,13),W(1,21),GC_10,AMP(366))
C     Amplitude(s) for diagram number 329
      CALL FFV1_0(W(1,17),W(1,6),W(1,47),GC_11,AMP(367))
      CALL FFV1_0(W(1,17),W(1,6),W(1,44),GC_11,AMP(368))
      CALL FFV1_0(W(1,17),W(1,6),W(1,35),GC_11,AMP(369))
C     Amplitude(s) for diagram number 330
      CALL FFV1_0(W(1,3),W(1,49),W(1,45),GC_11,AMP(370))
C     Amplitude(s) for diagram number 331
      CALL VVV1_0(W(1,45),W(1,2),W(1,22),GC_10,AMP(371))
C     Amplitude(s) for diagram number 332
      CALL FFV1_0(W(1,3),W(1,53),W(1,13),GC_11,AMP(372))
C     Amplitude(s) for diagram number 333
      CALL FFV1_0(W(1,26),W(1,53),W(1,2),GC_11,AMP(373))
C     Amplitude(s) for diagram number 334
      CALL VVV1_0(W(1,1),W(1,13),W(1,22),GC_10,AMP(374))
C     Amplitude(s) for diagram number 335
      CALL FFV1_0(W(1,26),W(1,49),W(1,1),GC_11,AMP(375))
C     Amplitude(s) for diagram number 336
      CALL FFV1_0(W(1,3),W(1,15),W(1,47),GC_11,AMP(376))
      CALL FFV1_0(W(1,3),W(1,15),W(1,44),GC_11,AMP(377))
      CALL FFV1_0(W(1,3),W(1,15),W(1,35),GC_11,AMP(378))
      CALL VVVV1P0_1(W(1,1),W(1,2),W(1,7),GC_12,ZERO,ZERO,W(1,35))
      CALL VVVV3P0_1(W(1,1),W(1,2),W(1,7),GC_12,ZERO,ZERO,W(1,15))
      CALL VVVV4P0_1(W(1,1),W(1,2),W(1,7),GC_12,ZERO,ZERO,W(1,44))
      CALL FFV1_2(W(1,4),W(1,35),GC_11,ZERO,ZERO,W(1,7))
      CALL FFV1_2(W(1,4),W(1,15),GC_11,ZERO,ZERO,W(1,2))
      CALL FFV1_2(W(1,4),W(1,44),GC_11,ZERO,ZERO,W(1,1))
C     Amplitude(s) for diagram number 337
      CALL FFV1_0(W(1,7),W(1,5),W(1,9),GC_11,AMP(379))
      CALL FFV1_0(W(1,2),W(1,5),W(1,9),GC_11,AMP(380))
      CALL FFV1_0(W(1,1),W(1,5),W(1,9),GC_11,AMP(381))
      CALL FFV1_1(W(1,5),W(1,35),GC_11,ZERO,ZERO,W(1,1))
      CALL FFV1_1(W(1,5),W(1,15),GC_11,ZERO,ZERO,W(1,2))
      CALL FFV1_1(W(1,5),W(1,44),GC_11,ZERO,ZERO,W(1,7))
C     Amplitude(s) for diagram number 338
      CALL FFV1_0(W(1,4),W(1,1),W(1,9),GC_11,AMP(382))
      CALL FFV1_0(W(1,4),W(1,2),W(1,9),GC_11,AMP(383))
      CALL FFV1_0(W(1,4),W(1,7),W(1,9),GC_11,AMP(384))
C     Amplitude(s) for diagram number 339
      CALL VVV1_0(W(1,35),W(1,9),W(1,16),GC_10,AMP(385))
      CALL VVV1_0(W(1,15),W(1,9),W(1,16),GC_10,AMP(386))
      CALL VVV1_0(W(1,44),W(1,9),W(1,16),GC_10,AMP(387))
      CALL FFV1_2(W(1,3),W(1,35),GC_11,ZERO,ZERO,W(1,9))
      CALL FFV1_2(W(1,3),W(1,15),GC_11,ZERO,ZERO,W(1,7))
      CALL FFV1_2(W(1,3),W(1,44),GC_11,ZERO,ZERO,W(1,4))
C     Amplitude(s) for diagram number 340
      CALL FFV1_0(W(1,9),W(1,6),W(1,16),GC_11,AMP(388))
      CALL FFV1_0(W(1,7),W(1,6),W(1,16),GC_11,AMP(389))
      CALL FFV1_0(W(1,4),W(1,6),W(1,16),GC_11,AMP(390))
      CALL FFV1_1(W(1,6),W(1,35),GC_11,ZERO,ZERO,W(1,4))
      CALL FFV1_1(W(1,6),W(1,15),GC_11,ZERO,ZERO,W(1,35))
      CALL FFV1_1(W(1,6),W(1,44),GC_11,ZERO,ZERO,W(1,15))
C     Amplitude(s) for diagram number 341
      CALL FFV1_0(W(1,3),W(1,4),W(1,16),GC_11,AMP(391))
      CALL FFV1_0(W(1,3),W(1,35),W(1,16),GC_11,AMP(392))
      CALL FFV1_0(W(1,3),W(1,15),W(1,16),GC_11,AMP(393))
      JAMP(1)=+1D0/2D0*(-AMP(4)-IMAG1*AMP(8)-IMAG1*AMP(7)-IMAG1*AMP(10)
     $ -IMAG1*AMP(11)-AMP(13)-IMAG1*AMP(15)+AMP(25)-IMAG1*AMP(30)
     $ +AMP(31)-IMAG1*AMP(33)-IMAG1*AMP(38)-IMAG1*AMP(115)+AMP(118)
     $ +AMP(119)-IMAG1*AMP(136)-AMP(137)-AMP(138)+AMP(141)-AMP(139)
     $ +AMP(144)-IMAG1*AMP(146)+AMP(150)-IMAG1*AMP(152)+IMAG1*AMP(230)
     $ +AMP(231)+AMP(233)+AMP(237)-AMP(235)+AMP(238)+IMAG1*AMP(239)
     $ +AMP(241)-IMAG1*AMP(243)-IMAG1*AMP(324)-IMAG1*AMP(325)+IMAG1
     $ *AMP(328)-IMAG1*AMP(326)-IMAG1*AMP(329)+IMAG1*AMP(333)-IMAG1
     $ *AMP(331)+IMAG1*AMP(336)+IMAG1*AMP(335)-IMAG1*AMP(342)+IMAG1
     $ *AMP(340)-AMP(347)+AMP(351)-AMP(349)+AMP(371)-AMP(378)-AMP(377))
      JAMP(2)=+1D0/2D0*(+1D0/3D0*IMAG1*AMP(19)+1D0/3D0*IMAG1*AMP(20)
     $ +1D0/3D0*IMAG1*AMP(37)+1D0/3D0*IMAG1*AMP(38)-1D0/3D0*AMP(123)
     $ -1D0/3D0*AMP(124)-1D0/3D0*AMP(147)-1D0/3D0*AMP(150)-1D0/3D0
     $ *AMP(259)-1D0/3D0*AMP(262))
      JAMP(3)=+1D0/2D0*(+1D0/3D0*IMAG1*AMP(33)+1D0/3D0*IMAG1*AMP(34)
     $ +1D0/3D0*IMAG1*AMP(35)+1D0/3D0*IMAG1*AMP(36)-1D0/3D0*AMP(156)
     $ -1D0/3D0*AMP(157)-1D0/3D0*AMP(185)-1D0/3D0*AMP(188)-1D0/3D0
     $ *AMP(241)-1D0/3D0*AMP(244))
      JAMP(4)=+1D0/2D0*(+AMP(2)-IMAG1*AMP(8)-IMAG1*AMP(7)-IMAG1*AMP(10)
     $ -IMAG1*AMP(11)+AMP(16)-IMAG1*AMP(17)-IMAG1*AMP(19)-AMP(22)
     $ -IMAG1*AMP(23)-AMP(27)-IMAG1*AMP(36)-IMAG1*AMP(158)+AMP(161)
     $ +AMP(162)+AMP(173)-IMAG1*AMP(174)-IMAG1*AMP(177)-AMP(178)
     $ -AMP(179)+AMP(182)-AMP(180)+AMP(188)-IMAG1*AMP(190)+IMAG1
     $ *AMP(248)+AMP(249)+AMP(251)+AMP(255)-AMP(253)+AMP(256)+IMAG1
     $ *AMP(257)+AMP(259)-IMAG1*AMP(261)-IMAG1*AMP(319)-IMAG1*AMP(320)
     $ +IMAG1*AMP(323)-IMAG1*AMP(321)-IMAG1*AMP(330)+IMAG1*AMP(333)
     $ +IMAG1*AMP(332)+IMAG1*AMP(336)-IMAG1*AMP(334)-IMAG1*AMP(339)
     $ +IMAG1*AMP(337)+AMP(353)-AMP(360)-AMP(359)-AMP(366)+AMP(369)
     $ -AMP(367))
      JAMP(5)=+1D0/2D0*(-IMAG1*AMP(3)+AMP(4)-AMP(5)+IMAG1*AMP(9)+IMAG1
     $ *AMP(8)+IMAG1*AMP(11)+IMAG1*AMP(12)-IMAG1*AMP(20)-IMAG1*AMP(21)
     $ +AMP(22)-AMP(29)-IMAG1*AMP(130)-IMAG1*AMP(132)-AMP(134)+AMP(135)
     $ +IMAG1*AMP(136)+AMP(138)-AMP(141)-AMP(140)+AMP(147)+AMP(148)
     $ -IMAG1*AMP(149)-AMP(301)-IMAG1*AMP(309)+IMAG1*AMP(307)+IMAG1
     $ *AMP(310)-IMAG1*AMP(312)-AMP(314)+AMP(315)-IMAG1*AMP(317)+IMAG1
     $ *AMP(325)-IMAG1*AMP(328)-IMAG1*AMP(327)-IMAG1*AMP(336)-IMAG1
     $ *AMP(335)+IMAG1*AMP(363)+AMP(364)+AMP(365)-AMP(369)-AMP(368)
     $ -AMP(382)+AMP(384)+IMAG1*AMP(385)-IMAG1*AMP(387)-AMP(388)
     $ +AMP(390))
      JAMP(6)=+1D0/2D0*(+1D0/3D0*IMAG1*AMP(3)+1D0/3D0*AMP(5)+1D0/3D0
     $ *AMP(6)+1D0/3D0*IMAG1*AMP(14)+1D0/3D0*IMAG1*AMP(15)+1D0/3D0
     $ *IMAG1*AMP(132)+1D0/3D0*IMAG1*AMP(133)-1D0/3D0*AMP(135)-1D0/3D0
     $ *AMP(144)-1D0/3D0*AMP(145)+1D0/3D0*AMP(301)+1D0/3D0*AMP(302)
     $ +1D0/3D0*IMAG1*AMP(305)-1D0/3D0*AMP(348)+1D0/3D0*AMP(379)-1D0
     $ /3D0*AMP(381)+1D0/3D0*AMP(382)-1D0/3D0*AMP(384))
      JAMP(7)=+1D0/2D0*(+1D0/3D0*IMAG1*AMP(21)+1D0/3D0*IMAG1*AMP(23)
     $ +1D0/3D0*IMAG1*AMP(26)+1D0/3D0*AMP(28)+1D0/3D0*AMP(29)+1D0/3D0
     $ *IMAG1*AMP(170)+1D0/3D0*IMAG1*AMP(172)-1D0/3D0*AMP(173)-1D0/3D0
     $ *AMP(175)-1D0/3D0*AMP(176)+1D0/3D0*AMP(313)+1D0/3D0*AMP(314)
     $ +1D0/3D0*IMAG1*AMP(317)-1D0/3D0*AMP(365)+1D0/3D0*AMP(388)-1D0
     $ /3D0*AMP(390)+1D0/3D0*AMP(391)-1D0/3D0*AMP(393))
      JAMP(8)=+1D0/2D0*(-AMP(6)-IMAG1*AMP(9)+IMAG1*AMP(7)+IMAG1*AMP(10)
     $ -IMAG1*AMP(12)+AMP(13)-IMAG1*AMP(14)-IMAG1*AMP(26)+AMP(27)
     $ -AMP(28)-IMAG1*AMP(34)-IMAG1*AMP(168)-IMAG1*AMP(170)-AMP(171)
     $ +AMP(176)+IMAG1*AMP(177)+AMP(179)-AMP(182)-AMP(181)+AMP(185)
     $ +AMP(186)-IMAG1*AMP(187)-AMP(302)+AMP(303)-IMAG1*AMP(305)-IMAG1
     $ *AMP(308)-IMAG1*AMP(307)-IMAG1*AMP(310)-IMAG1*AMP(311)-AMP(313)
     $ +IMAG1*AMP(320)-IMAG1*AMP(323)-IMAG1*AMP(322)-IMAG1*AMP(333)
     $ -IMAG1*AMP(332)+IMAG1*AMP(343)+AMP(344)+AMP(348)-AMP(351)
     $ -AMP(350)-AMP(379)+AMP(381)-IMAG1*AMP(385)+IMAG1*AMP(387)
     $ -AMP(391)+AMP(393))
      JAMP(9)=+1D0/2D0*(+IMAG1*AMP(49)+AMP(50)+AMP(52)-IMAG1*AMP(54)
     $ -IMAG1*AMP(57)-AMP(58)+AMP(62)-AMP(65)-AMP(64)+AMP(72)-IMAG1
     $ *AMP(73)-IMAG1*AMP(125)+AMP(126)+AMP(129)-IMAG1*AMP(131)-IMAG1
     $ *AMP(133)+AMP(134)+AMP(137)+AMP(140)+AMP(139)+AMP(145)+IMAG1
     $ *AMP(146)+AMP(288)+IMAG1*AMP(289)+AMP(290)+AMP(294)-AMP(292)
     $ -IMAG1*AMP(297)-AMP(303)+IMAG1*AMP(309)+IMAG1*AMP(308)+IMAG1
     $ *AMP(311)+IMAG1*AMP(312)+AMP(316)-IMAG1*AMP(320)+IMAG1*AMP(323)
     $ +IMAG1*AMP(322)+IMAG1*AMP(324)+IMAG1*AMP(327)+IMAG1*AMP(326)
     $ +IMAG1*AMP(329)+IMAG1*AMP(331)+IMAG1*AMP(332)+IMAG1*AMP(342)
     $ -IMAG1*AMP(340)-IMAG1*AMP(343)-AMP(344)+AMP(347)+AMP(349)
     $ +AMP(350))
      JAMP(10)=+1D0/2D0*(+IMAG1*AMP(39)+AMP(40)+AMP(43)+IMAG1*AMP(54)
     $ +IMAG1*AMP(57)+AMP(58)+AMP(61)+AMP(64)+AMP(63)+AMP(69)-IMAG1
     $ *AMP(70)-IMAG1*AMP(120)+AMP(121)+AMP(124)+IMAG1*AMP(131)+IMAG1
     $ *AMP(133)-AMP(134)+AMP(138)-AMP(141)-AMP(140)+AMP(151)+IMAG1
     $ *AMP(152)+AMP(249)-IMAG1*AMP(250)+AMP(251)+AMP(255)-AMP(253)
     $ +IMAG1*AMP(264)+AMP(303)-IMAG1*AMP(309)-IMAG1*AMP(308)-IMAG1
     $ *AMP(311)-IMAG1*AMP(312)-AMP(316)-IMAG1*AMP(319)-IMAG1*AMP(322)
     $ -IMAG1*AMP(321)+IMAG1*AMP(325)-IMAG1*AMP(328)-IMAG1*AMP(327)
     $ -IMAG1*AMP(330)-IMAG1*AMP(334)-IMAG1*AMP(335)-IMAG1*AMP(339)
     $ +IMAG1*AMP(337)+IMAG1*AMP(370)-AMP(371)+AMP(374)+AMP(376)
     $ +AMP(377))
      JAMP(11)=+1D0/2D0*(-1D0/3D0*AMP(88)-1D0/3D0*AMP(90)+1D0/3D0
     $ *IMAG1*AMP(92)+1D0/3D0*IMAG1*AMP(93)-1D0/3D0*AMP(110)-1D0/3D0
     $ *AMP(126)-1D0/3D0*AMP(128)+1D0/3D0*IMAG1*AMP(130)+1D0/3D0*IMAG1
     $ *AMP(131)-1D0/3D0*AMP(148))
      JAMP(12)=+1D0/2D0*(-1D0/3D0*AMP(78)-1D0/3D0*AMP(81)-1D0/3D0
     $ *IMAG1*AMP(92)-1D0/3D0*IMAG1*AMP(93)-1D0/3D0*AMP(113)-1D0/3D0
     $ *AMP(116)-1D0/3D0*AMP(119)-1D0/3D0*IMAG1*AMP(130)-1D0/3D0*IMAG1
     $ *AMP(131)-1D0/3D0*AMP(151))
      JAMP(13)=+1D0/2D0*(-1D0/3D0*AMP(45)-1D0/3D0*AMP(47)+1D0/3D0
     $ *IMAG1*AMP(54)+1D0/3D0*IMAG1*AMP(55)-1D0/3D0*AMP(72)-1D0/3D0
     $ *AMP(164)-1D0/3D0*AMP(167)+1D0/3D0*IMAG1*AMP(168)+1D0/3D0*IMAG1
     $ *AMP(169)-1D0/3D0*AMP(186))
      JAMP(14)=+1D0/2D0*(-1D0/3D0*AMP(40)-1D0/3D0*AMP(42)-1D0/3D0
     $ *IMAG1*AMP(54)-1D0/3D0*IMAG1*AMP(55)-1D0/3D0*AMP(75)-1D0/3D0
     $ *AMP(159)-1D0/3D0*AMP(162)-1D0/3D0*IMAG1*AMP(168)-1D0/3D0*IMAG1
     $ *AMP(169)-1D0/3D0*AMP(189))
      JAMP(15)=+1D0/2D0*(+IMAG1*AMP(82)+AMP(83)+AMP(85)-IMAG1*AMP(92)
     $ -IMAG1*AMP(95)-AMP(96)+AMP(100)-AMP(103)-AMP(102)+AMP(110)
     $ -IMAG1*AMP(111)-IMAG1*AMP(163)+AMP(164)+AMP(166)-IMAG1*AMP(169)
     $ +AMP(171)-IMAG1*AMP(172)+IMAG1*AMP(174)+AMP(175)+AMP(178)
     $ +AMP(181)+AMP(180)+AMP(267)+IMAG1*AMP(268)+AMP(269)+AMP(273)
     $ -AMP(271)-IMAG1*AMP(279)+AMP(304)+IMAG1*AMP(309)+IMAG1*AMP(308)
     $ +IMAG1*AMP(311)+IMAG1*AMP(312)-AMP(315)+IMAG1*AMP(319)+IMAG1
     $ *AMP(322)+IMAG1*AMP(321)-IMAG1*AMP(325)+IMAG1*AMP(328)+IMAG1
     $ *AMP(327)+IMAG1*AMP(330)+IMAG1*AMP(334)+IMAG1*AMP(335)+IMAG1
     $ *AMP(339)-IMAG1*AMP(337)-IMAG1*AMP(363)-AMP(364)+AMP(366)
     $ +AMP(367)+AMP(368))
      JAMP(16)=+1D0/2D0*(+IMAG1*AMP(77)+AMP(78)+AMP(80)+IMAG1*AMP(92)
     $ +IMAG1*AMP(95)+AMP(96)+AMP(99)+AMP(102)+AMP(101)+AMP(107)-IMAG1
     $ *AMP(108)-IMAG1*AMP(153)+AMP(154)+AMP(157)+IMAG1*AMP(169)
     $ -AMP(171)+IMAG1*AMP(172)+AMP(179)-AMP(182)-AMP(181)+AMP(189)
     $ +IMAG1*AMP(190)+AMP(231)-IMAG1*AMP(232)+AMP(233)+AMP(237)
     $ -AMP(235)+IMAG1*AMP(246)-AMP(304)-IMAG1*AMP(309)-IMAG1*AMP(308)
     $ -IMAG1*AMP(311)-IMAG1*AMP(312)+AMP(315)+IMAG1*AMP(320)-IMAG1
     $ *AMP(323)-IMAG1*AMP(322)-IMAG1*AMP(324)-IMAG1*AMP(327)-IMAG1
     $ *AMP(326)-IMAG1*AMP(329)-IMAG1*AMP(331)-IMAG1*AMP(332)-IMAG1
     $ *AMP(342)+IMAG1*AMP(340)+IMAG1*AMP(352)-AMP(353)+AMP(356)
     $ +AMP(358)+AMP(359))
      JAMP(17)=+1D0/2D0*(+IMAG1*AMP(115)+AMP(116)+AMP(117)+IMAG1
     $ *AMP(130)+IMAG1*AMP(132)+AMP(134)+AMP(137)+AMP(140)+AMP(139)
     $ -IMAG1*AMP(142)+AMP(143)-IMAG1*AMP(192)-IMAG1*AMP(193)+AMP(194)
     $ -AMP(211)-AMP(215)-IMAG1*AMP(216)-IMAG1*AMP(219)+IMAG1*AMP(217)
     $ +IMAG1*AMP(220)-IMAG1*AMP(222)-AMP(224)-AMP(231)+IMAG1*AMP(232)
     $ +AMP(234)-AMP(237)-AMP(236)+AMP(301)+IMAG1*AMP(309)-IMAG1
     $ *AMP(307)-IMAG1*AMP(310)+IMAG1*AMP(312)+AMP(314)-AMP(315)+IMAG1
     $ *AMP(317)+IMAG1*AMP(324)+IMAG1*AMP(327)+IMAG1*AMP(326)+IMAG1
     $ *AMP(342)+IMAG1*AMP(341)+AMP(382)+AMP(383)-IMAG1*AMP(385)-IMAG1
     $ *AMP(386)+AMP(388)+AMP(389))
      JAMP(18)=+1D0/2D0*(-1D0/3D0*AMP(121)-1D0/3D0*AMP(122)-1D0/3D0
     $ *IMAG1*AMP(132)-1D0/3D0*IMAG1*AMP(133)-1D0/3D0*AMP(143)+1D0/3D0
     $ *IMAG1*AMP(198)+1D0/3D0*IMAG1*AMP(200)+1D0/3D0*AMP(211)+1D0/3D0
     $ *AMP(212)+1D0/3D0*IMAG1*AMP(216)-1D0/3D0*AMP(252)-1D0/3D0
     $ *AMP(301)-1D0/3D0*AMP(302)-1D0/3D0*IMAG1*AMP(305)-1D0/3D0
     $ *AMP(379)-1D0/3D0*AMP(380)-1D0/3D0*AMP(382)-1D0/3D0*AMP(383))
      JAMP(19)=+1D0/2D0*(-1D0/3D0*AMP(154)-1D0/3D0*AMP(155)-1D0/3D0
     $ *IMAG1*AMP(170)-1D0/3D0*IMAG1*AMP(172)-1D0/3D0*AMP(184)+1D0/3D0
     $ *IMAG1*AMP(193)+1D0/3D0*IMAG1*AMP(195)+1D0/3D0*AMP(223)+1D0/3D0
     $ *AMP(224)+1D0/3D0*IMAG1*AMP(228)-1D0/3D0*AMP(234)-1D0/3D0
     $ *AMP(313)-1D0/3D0*AMP(314)-1D0/3D0*IMAG1*AMP(317)-1D0/3D0
     $ *AMP(388)-1D0/3D0*AMP(389)-1D0/3D0*AMP(391)-1D0/3D0*AMP(392))
      JAMP(20)=+1D0/2D0*(+IMAG1*AMP(158)+AMP(159)+AMP(160)+IMAG1
     $ *AMP(168)+IMAG1*AMP(170)+AMP(171)+AMP(178)+AMP(181)+AMP(180)
     $ -IMAG1*AMP(183)+AMP(184)-IMAG1*AMP(197)-IMAG1*AMP(198)+AMP(199)
     $ -AMP(212)-IMAG1*AMP(218)-IMAG1*AMP(217)-IMAG1*AMP(220)-IMAG1
     $ *AMP(221)-AMP(223)-AMP(227)-IMAG1*AMP(228)-AMP(249)+IMAG1
     $ *AMP(250)+AMP(252)-AMP(255)-AMP(254)+AMP(302)-AMP(303)+IMAG1
     $ *AMP(305)+IMAG1*AMP(308)+IMAG1*AMP(307)+IMAG1*AMP(310)+IMAG1
     $ *AMP(311)+AMP(313)+IMAG1*AMP(319)+IMAG1*AMP(322)+IMAG1*AMP(321)
     $ +IMAG1*AMP(339)+IMAG1*AMP(338)+AMP(379)+AMP(380)+IMAG1*AMP(385)
     $ +IMAG1*AMP(386)+AMP(391)+AMP(392))
      JAMP(21)=+1D0/2D0*(+IMAG1*AMP(120)+AMP(122)+AMP(123)+IMAG1
     $ *AMP(125)+AMP(127)+AMP(128)-AMP(137)-AMP(138)+AMP(141)-AMP(139)
     $ +IMAG1*AMP(142)+IMAG1*AMP(149)-IMAG1*AMP(196)-AMP(199)-IMAG1
     $ *AMP(200)-IMAG1*AMP(207)-IMAG1*AMP(209)+AMP(210)+AMP(215)+IMAG1
     $ *AMP(219)+IMAG1*AMP(218)+IMAG1*AMP(221)+IMAG1*AMP(222)-AMP(225)
     $ -AMP(251)+AMP(253)+AMP(254)+AMP(260)+IMAG1*AMP(261)+AMP(284)
     $ +IMAG1*AMP(285)-AMP(288)-AMP(294)-AMP(293)-IMAG1*AMP(324)-IMAG1
     $ *AMP(325)+IMAG1*AMP(328)-IMAG1*AMP(326)+IMAG1*AMP(330)+IMAG1
     $ *AMP(334)+IMAG1*AMP(335)-IMAG1*AMP(337)-IMAG1*AMP(338)-IMAG1
     $ *AMP(342)-IMAG1*AMP(341)-IMAG1*AMP(361)-AMP(364)+AMP(366)
     $ +AMP(367)+AMP(368))
      JAMP(22)=+1D0/2D0*(-1D0/3D0*AMP(117)-1D0/3D0*AMP(118)-1D0/3D0
     $ *AMP(127)-1D0/3D0*AMP(129)+1D0/3D0*IMAG1*AMP(191)+1D0/3D0*IMAG1
     $ *AMP(192)+1D0/3D0*IMAG1*AMP(206)+1D0/3D0*IMAG1*AMP(207)-1D0/3D0
     $ *AMP(242)-1D0/3D0*AMP(296))
      JAMP(23)=+1D0/2D0*(-1D0/3D0*AMP(160)-1D0/3D0*AMP(161)-1D0/3D0
     $ *AMP(165)-1D0/3D0*AMP(166)+1D0/3D0*IMAG1*AMP(196)+1D0/3D0*IMAG1
     $ *AMP(197)+1D0/3D0*IMAG1*AMP(201)+1D0/3D0*IMAG1*AMP(202)-1D0/3D0
     $ *AMP(260)-1D0/3D0*AMP(278))
      JAMP(24)=+1D0/2D0*(+IMAG1*AMP(153)+AMP(155)+AMP(156)+IMAG1
     $ *AMP(163)+AMP(165)+AMP(167)-AMP(178)-AMP(179)+AMP(182)-AMP(180)
     $ +IMAG1*AMP(183)+IMAG1*AMP(187)-IMAG1*AMP(191)-AMP(194)-IMAG1
     $ *AMP(195)-IMAG1*AMP(202)+AMP(204)-IMAG1*AMP(205)-AMP(213)+IMAG1
     $ *AMP(219)+IMAG1*AMP(218)+IMAG1*AMP(221)+IMAG1*AMP(222)+AMP(227)
     $ -AMP(233)+AMP(235)+AMP(236)+AMP(242)+IMAG1*AMP(243)-AMP(267)
     $ -AMP(273)-AMP(272)+IMAG1*AMP(275)+AMP(276)-IMAG1*AMP(319)-IMAG1
     $ *AMP(320)+IMAG1*AMP(323)-IMAG1*AMP(321)+IMAG1*AMP(329)+IMAG1
     $ *AMP(331)+IMAG1*AMP(332)-IMAG1*AMP(339)-IMAG1*AMP(338)-IMAG1
     $ *AMP(340)-IMAG1*AMP(341)-AMP(344)-IMAG1*AMP(345)+AMP(347)
     $ +AMP(349)+AMP(350))
      JAMP(25)=+1D0/2D0*(+AMP(4)+IMAG1*AMP(8)+IMAG1*AMP(7)+IMAG1
     $ *AMP(10)+IMAG1*AMP(11)+AMP(13)+IMAG1*AMP(15)-AMP(25)+IMAG1
     $ *AMP(30)-AMP(31)+IMAG1*AMP(33)+IMAG1*AMP(38)+IMAG1*AMP(44)
     $ +AMP(47)+AMP(48)+IMAG1*AMP(60)-AMP(61)-AMP(62)+AMP(65)-AMP(63)
     $ +AMP(68)+IMAG1*AMP(70)+AMP(71)+IMAG1*AMP(73)-IMAG1*AMP(266)
     $ +AMP(267)+AMP(269)+AMP(273)-AMP(271)+AMP(274)-IMAG1*AMP(275)
     $ +AMP(280)+IMAG1*AMP(282)+IMAG1*AMP(319)+IMAG1*AMP(320)-IMAG1
     $ *AMP(323)+IMAG1*AMP(321)+IMAG1*AMP(330)-IMAG1*AMP(333)-IMAG1
     $ *AMP(332)-IMAG1*AMP(336)+IMAG1*AMP(334)+IMAG1*AMP(339)-IMAG1
     $ *AMP(337)+AMP(344)-AMP(351)-AMP(350)-AMP(374)+AMP(378)-AMP(376))
      JAMP(26)=+1D0/2D0*(-1D0/3D0*IMAG1*AMP(19)-1D0/3D0*IMAG1*AMP(20)
     $ -1D0/3D0*IMAG1*AMP(37)-1D0/3D0*IMAG1*AMP(38)-1D0/3D0*AMP(85)
     $ -1D0/3D0*AMP(86)-1D0/3D0*AMP(109)-1D0/3D0*AMP(112)-1D0/3D0
     $ *AMP(277)-1D0/3D0*AMP(280))
      JAMP(27)=+1D0/2D0*(-1D0/3D0*IMAG1*AMP(33)-1D0/3D0*IMAG1*AMP(34)
     $ -1D0/3D0*IMAG1*AMP(35)-1D0/3D0*IMAG1*AMP(36)-1D0/3D0*AMP(52)
     $ -1D0/3D0*AMP(53)-1D0/3D0*AMP(71)-1D0/3D0*AMP(74)-1D0/3D0
     $ *AMP(295)-1D0/3D0*AMP(298))
      JAMP(28)=+1D0/2D0*(-AMP(2)+IMAG1*AMP(8)+IMAG1*AMP(7)+IMAG1
     $ *AMP(10)+IMAG1*AMP(11)-AMP(16)+IMAG1*AMP(17)+IMAG1*AMP(19)
     $ +AMP(22)+IMAG1*AMP(23)+AMP(27)+IMAG1*AMP(36)+IMAG1*AMP(87)
     $ +AMP(90)+AMP(91)+IMAG1*AMP(98)-AMP(99)-AMP(100)+AMP(103)
     $ -AMP(101)+AMP(106)+IMAG1*AMP(108)+AMP(109)+IMAG1*AMP(111)
     $ +AMP(283)-IMAG1*AMP(285)-IMAG1*AMP(287)+AMP(288)+AMP(290)
     $ +AMP(294)-AMP(292)+AMP(298)+IMAG1*AMP(300)+IMAG1*AMP(324)+IMAG1
     $ *AMP(325)-IMAG1*AMP(328)+IMAG1*AMP(326)+IMAG1*AMP(329)-IMAG1
     $ *AMP(333)+IMAG1*AMP(331)-IMAG1*AMP(336)-IMAG1*AMP(335)+IMAG1
     $ *AMP(342)-IMAG1*AMP(340)-AMP(356)+AMP(360)-AMP(358)+AMP(364)
     $ -AMP(369)-AMP(368))
      JAMP(29)=+1D0/2D0*(+IMAG1*AMP(3)-AMP(4)+AMP(5)-IMAG1*AMP(9)
     $ -IMAG1*AMP(8)-IMAG1*AMP(11)-IMAG1*AMP(12)+IMAG1*AMP(20)+IMAG1
     $ *AMP(21)-AMP(22)+AMP(29)-IMAG1*AMP(201)-IMAG1*AMP(203)-AMP(204)
     $ +AMP(211)-IMAG1*AMP(218)-IMAG1*AMP(217)-IMAG1*AMP(220)-IMAG1
     $ *AMP(221)+AMP(224)+AMP(225)-IMAG1*AMP(226)+AMP(265)+IMAG1
     $ *AMP(266)-AMP(269)+AMP(271)+AMP(272)+AMP(277)+AMP(278)+IMAG1
     $ *AMP(279)-IMAG1*AMP(330)+IMAG1*AMP(336)-IMAG1*AMP(334)+IMAG1
     $ *AMP(337)+IMAG1*AMP(338)+IMAG1*AMP(361)+AMP(362)-AMP(366)
     $ +AMP(369)-AMP(367)-AMP(383)-AMP(384)+IMAG1*AMP(386)+IMAG1
     $ *AMP(387)-AMP(389)-AMP(390))
      JAMP(30)=+1D0/2D0*(-1D0/3D0*IMAG1*AMP(3)-1D0/3D0*AMP(5)-1D0/3D0
     $ *AMP(6)-1D0/3D0*IMAG1*AMP(14)-1D0/3D0*IMAG1*AMP(15)+1D0/3D0
     $ *IMAG1*AMP(203)+1D0/3D0*IMAG1*AMP(205)-1D0/3D0*AMP(211)-1D0/3D0
     $ *AMP(212)+1D0/3D0*IMAG1*AMP(214)-1D0/3D0*AMP(265)-1D0/3D0
     $ *AMP(274)-1D0/3D0*AMP(276)-1D0/3D0*AMP(346)+1D0/3D0*AMP(380)
     $ +1D0/3D0*AMP(381)+1D0/3D0*AMP(383)+1D0/3D0*AMP(384))
      JAMP(31)=+1D0/2D0*(-1D0/3D0*IMAG1*AMP(21)-1D0/3D0*IMAG1*AMP(23)
     $ -1D0/3D0*IMAG1*AMP(26)-1D0/3D0*AMP(28)-1D0/3D0*AMP(29)+1D0/3D0
     $ *IMAG1*AMP(208)+1D0/3D0*IMAG1*AMP(209)-1D0/3D0*AMP(223)-1D0/3D0
     $ *AMP(224)+1D0/3D0*IMAG1*AMP(226)-1D0/3D0*AMP(283)-1D0/3D0
     $ *AMP(284)-1D0/3D0*AMP(286)-1D0/3D0*AMP(362)+1D0/3D0*AMP(389)
     $ +1D0/3D0*AMP(390)+1D0/3D0*AMP(392)+1D0/3D0*AMP(393))
      JAMP(32)=+1D0/2D0*(+AMP(6)+IMAG1*AMP(9)-IMAG1*AMP(7)-IMAG1
     $ *AMP(10)+IMAG1*AMP(12)-AMP(13)+IMAG1*AMP(14)+IMAG1*AMP(26)
     $ -AMP(27)+AMP(28)+IMAG1*AMP(34)-IMAG1*AMP(206)-IMAG1*AMP(208)
     $ -AMP(210)+AMP(212)+AMP(213)-IMAG1*AMP(214)-IMAG1*AMP(219)+IMAG1
     $ *AMP(217)+IMAG1*AMP(220)-IMAG1*AMP(222)+AMP(223)+AMP(286)+IMAG1
     $ *AMP(287)-AMP(290)+AMP(292)+AMP(293)+AMP(295)+AMP(296)+IMAG1
     $ *AMP(297)-IMAG1*AMP(329)+IMAG1*AMP(333)-IMAG1*AMP(331)+IMAG1
     $ *AMP(340)+IMAG1*AMP(341)+IMAG1*AMP(345)+AMP(346)-AMP(347)
     $ +AMP(351)-AMP(349)-AMP(380)-AMP(381)-IMAG1*AMP(386)-IMAG1
     $ *AMP(387)-AMP(392)-AMP(393))
      JAMP(33)=+1D0/2D0*(-IMAG1*AMP(77)+AMP(79)+AMP(81)-IMAG1*AMP(82)
     $ +AMP(84)+AMP(86)-AMP(99)-AMP(100)+AMP(103)-AMP(101)-IMAG1
     $ *AMP(104)-IMAG1*AMP(114)+IMAG1*AMP(191)+AMP(194)+IMAG1*AMP(195)
     $ +IMAG1*AMP(202)-AMP(204)+IMAG1*AMP(205)+AMP(213)-IMAG1*AMP(219)
     $ -IMAG1*AMP(218)-IMAG1*AMP(221)-IMAG1*AMP(222)-AMP(227)-AMP(231)
     $ -AMP(237)-AMP(236)-IMAG1*AMP(239)+AMP(240)-AMP(269)+AMP(271)
     $ +AMP(272)+AMP(281)-IMAG1*AMP(282)+IMAG1*AMP(324)+IMAG1*AMP(325)
     $ -IMAG1*AMP(328)+IMAG1*AMP(326)-IMAG1*AMP(330)-IMAG1*AMP(334)
     $ -IMAG1*AMP(335)+IMAG1*AMP(337)+IMAG1*AMP(338)+IMAG1*AMP(342)
     $ +IMAG1*AMP(341)-AMP(371)+IMAG1*AMP(372)+AMP(374)+AMP(376)
     $ +AMP(377))
      JAMP(34)=+1D0/2D0*(-1D0/3D0*AMP(41)-1D0/3D0*AMP(43)-1D0/3D0
     $ *AMP(46)-1D0/3D0*AMP(48)-1D0/3D0*IMAG1*AMP(196)-1D0/3D0*IMAG1
     $ *AMP(197)-1D0/3D0*IMAG1*AMP(201)-1D0/3D0*IMAG1*AMP(202)-1D0/3D0
     $ *AMP(263)-1D0/3D0*AMP(281))
      JAMP(35)=+1D0/2D0*(-1D0/3D0*AMP(79)-1D0/3D0*AMP(80)-1D0/3D0
     $ *AMP(89)-1D0/3D0*AMP(91)-1D0/3D0*IMAG1*AMP(191)-1D0/3D0*IMAG1
     $ *AMP(192)-1D0/3D0*IMAG1*AMP(206)-1D0/3D0*IMAG1*AMP(207)-1D0/3D0
     $ *AMP(245)-1D0/3D0*AMP(299))
      JAMP(36)=+1D0/2D0*(-IMAG1*AMP(39)+AMP(41)+AMP(42)-IMAG1*AMP(49)
     $ +AMP(51)+AMP(53)-AMP(61)-AMP(62)+AMP(65)-AMP(63)-IMAG1*AMP(66)
     $ -IMAG1*AMP(76)+IMAG1*AMP(196)+AMP(199)+IMAG1*AMP(200)+IMAG1
     $ *AMP(207)+IMAG1*AMP(209)-AMP(210)-AMP(215)-IMAG1*AMP(219)-IMAG1
     $ *AMP(218)-IMAG1*AMP(221)-IMAG1*AMP(222)+AMP(225)-AMP(249)
     $ -AMP(255)-AMP(254)-IMAG1*AMP(257)+AMP(258)-AMP(290)+AMP(292)
     $ +AMP(293)+AMP(299)-IMAG1*AMP(300)+IMAG1*AMP(319)+IMAG1*AMP(320)
     $ -IMAG1*AMP(323)+IMAG1*AMP(321)-IMAG1*AMP(329)-IMAG1*AMP(331)
     $ -IMAG1*AMP(332)+IMAG1*AMP(339)+IMAG1*AMP(338)+IMAG1*AMP(340)
     $ +IMAG1*AMP(341)-AMP(353)+IMAG1*AMP(354)+AMP(356)+AMP(358)
     $ +AMP(359))
      JAMP(37)=+1D0/2D0*(-IMAG1*AMP(44)+AMP(45)+AMP(46)-IMAG1*AMP(55)
     $ -IMAG1*AMP(56)+AMP(58)+AMP(61)+AMP(64)+AMP(63)+IMAG1*AMP(66)
     $ +AMP(67)+IMAG1*AMP(201)+IMAG1*AMP(203)+AMP(204)-AMP(211)+IMAG1
     $ *AMP(218)+IMAG1*AMP(217)+IMAG1*AMP(220)+IMAG1*AMP(221)-AMP(224)
     $ -AMP(225)+IMAG1*AMP(226)-AMP(267)-IMAG1*AMP(268)+AMP(270)
     $ -AMP(273)-AMP(272)+AMP(301)-AMP(304)-IMAG1*AMP(306)-IMAG1
     $ *AMP(308)-IMAG1*AMP(307)-IMAG1*AMP(310)-IMAG1*AMP(311)+AMP(314)
     $ -IMAG1*AMP(319)-IMAG1*AMP(322)-IMAG1*AMP(321)-IMAG1*AMP(339)
     $ -IMAG1*AMP(338)+AMP(382)+AMP(383)-IMAG1*AMP(385)-IMAG1*AMP(386)
     $ +AMP(388)+AMP(389))
      JAMP(38)=+1D0/2D0*(-1D0/3D0*AMP(83)-1D0/3D0*AMP(84)+1D0/3D0
     $ *IMAG1*AMP(94)+1D0/3D0*IMAG1*AMP(95)-1D0/3D0*AMP(105)-1D0/3D0
     $ *IMAG1*AMP(203)-1D0/3D0*IMAG1*AMP(205)+1D0/3D0*AMP(211)+1D0/3D0
     $ *AMP(212)-1D0/3D0*IMAG1*AMP(214)-1D0/3D0*AMP(270)-1D0/3D0
     $ *AMP(301)-1D0/3D0*AMP(302)+1D0/3D0*IMAG1*AMP(306)-1D0/3D0
     $ *AMP(379)-1D0/3D0*AMP(380)-1D0/3D0*AMP(382)-1D0/3D0*AMP(383))
      JAMP(39)=+1D0/2D0*(-1D0/3D0*AMP(50)-1D0/3D0*AMP(51)+1D0/3D0
     $ *IMAG1*AMP(56)+1D0/3D0*IMAG1*AMP(57)-1D0/3D0*AMP(67)-1D0/3D0
     $ *IMAG1*AMP(208)-1D0/3D0*IMAG1*AMP(209)+1D0/3D0*AMP(223)+1D0/3D0
     $ *AMP(224)-1D0/3D0*IMAG1*AMP(226)-1D0/3D0*AMP(291)-1D0/3D0
     $ *AMP(313)-1D0/3D0*AMP(314)+1D0/3D0*IMAG1*AMP(318)-1D0/3D0
     $ *AMP(388)-1D0/3D0*AMP(389)-1D0/3D0*AMP(391)-1D0/3D0*AMP(392))
      JAMP(40)=+1D0/2D0*(-IMAG1*AMP(87)+AMP(88)+AMP(89)-IMAG1*AMP(93)
     $ -IMAG1*AMP(94)+AMP(96)+AMP(99)+AMP(102)+AMP(101)+IMAG1*AMP(104)
     $ +AMP(105)+IMAG1*AMP(206)+IMAG1*AMP(208)+AMP(210)-AMP(212)
     $ -AMP(213)+IMAG1*AMP(214)+IMAG1*AMP(219)-IMAG1*AMP(217)-IMAG1
     $ *AMP(220)+IMAG1*AMP(222)-AMP(223)-AMP(288)-IMAG1*AMP(289)
     $ +AMP(291)-AMP(294)-AMP(293)+AMP(302)-IMAG1*AMP(309)+IMAG1
     $ *AMP(307)+IMAG1*AMP(310)-IMAG1*AMP(312)+AMP(313)-AMP(316)-IMAG1
     $ *AMP(318)-IMAG1*AMP(324)-IMAG1*AMP(327)-IMAG1*AMP(326)-IMAG1
     $ *AMP(342)-IMAG1*AMP(341)+AMP(379)+AMP(380)+IMAG1*AMP(385)+IMAG1
     $ *AMP(386)+AMP(391)+AMP(392))
      JAMP(41)=+1D0/2D0*(-IMAG1*AMP(1)-AMP(2)+AMP(6)+IMAG1*AMP(9)
     $ +IMAG1*AMP(8)+IMAG1*AMP(11)+IMAG1*AMP(12)+AMP(28)-AMP(31)-IMAG1
     $ *AMP(32)-IMAG1*AMP(37)+IMAG1*AMP(197)+IMAG1*AMP(198)-AMP(199)
     $ +AMP(212)+IMAG1*AMP(218)+IMAG1*AMP(217)+IMAG1*AMP(220)+IMAG1
     $ *AMP(221)+AMP(223)+AMP(227)+IMAG1*AMP(228)+AMP(247)-IMAG1
     $ *AMP(248)-AMP(251)+AMP(253)+AMP(254)+AMP(262)+AMP(263)-IMAG1
     $ *AMP(264)+IMAG1*AMP(330)-IMAG1*AMP(336)+IMAG1*AMP(334)-IMAG1
     $ *AMP(337)-IMAG1*AMP(338)-IMAG1*AMP(372)+AMP(373)-AMP(374)
     $ +AMP(378)-AMP(376)-AMP(380)-AMP(381)-IMAG1*AMP(386)-IMAG1
     $ *AMP(387)-AMP(392)-AMP(393))
      JAMP(42)=+1D0/2D0*(+IMAG1*AMP(1)+AMP(2)-AMP(6)-IMAG1*AMP(9)
     $ -IMAG1*AMP(8)-IMAG1*AMP(11)-IMAG1*AMP(12)-AMP(28)+AMP(31)+IMAG1
     $ *AMP(32)+IMAG1*AMP(37)+IMAG1*AMP(93)+IMAG1*AMP(94)-AMP(96)
     $ +AMP(97)-IMAG1*AMP(98)+AMP(100)-AMP(103)-AMP(102)+AMP(112)
     $ +AMP(113)+IMAG1*AMP(114)-AMP(302)+IMAG1*AMP(309)-IMAG1*AMP(307)
     $ -IMAG1*AMP(310)+IMAG1*AMP(312)-AMP(313)+AMP(316)+IMAG1*AMP(318)
     $ -IMAG1*AMP(325)+IMAG1*AMP(328)+IMAG1*AMP(327)+IMAG1*AMP(336)
     $ +IMAG1*AMP(335)-IMAG1*AMP(370)+AMP(371)+AMP(375)-AMP(378)
     $ -AMP(377)-AMP(379)+AMP(381)-IMAG1*AMP(385)+IMAG1*AMP(387)
     $ -AMP(391)+AMP(393))
      JAMP(43)=+1D0/2D0*(+1D0/3D0*IMAG1*AMP(24)-1D0/3D0*AMP(28)-1D0
     $ /3D0*AMP(29)+1D0/3D0*IMAG1*AMP(30)+1D0/3D0*IMAG1*AMP(32)-1D0
     $ /3D0*IMAG1*AMP(193)-1D0/3D0*IMAG1*AMP(195)-1D0/3D0*AMP(223)-1D0
     $ /3D0*AMP(224)-1D0/3D0*IMAG1*AMP(228)-1D0/3D0*AMP(229)-1D0/3D0
     $ *AMP(238)-1D0/3D0*AMP(240)-1D0/3D0*AMP(373)+1D0/3D0*AMP(389)
     $ +1D0/3D0*AMP(390)+1D0/3D0*AMP(392)+1D0/3D0*AMP(393))
      JAMP(44)=+1D0/2D0*(-1D0/3D0*IMAG1*AMP(24)+1D0/3D0*AMP(28)+1D0
     $ /3D0*AMP(29)-1D0/3D0*IMAG1*AMP(30)-1D0/3D0*IMAG1*AMP(32)-1D0
     $ /3D0*IMAG1*AMP(56)-1D0/3D0*IMAG1*AMP(57)-1D0/3D0*AMP(59)-1D0
     $ /3D0*AMP(68)-1D0/3D0*AMP(69)+1D0/3D0*AMP(313)+1D0/3D0*AMP(314)
     $ -1D0/3D0*IMAG1*AMP(318)-1D0/3D0*AMP(375)+1D0/3D0*AMP(388)-1D0
     $ /3D0*AMP(390)+1D0/3D0*AMP(391)-1D0/3D0*AMP(393))
      JAMP(45)=+1D0/2D0*(+1D0/3D0*IMAG1*AMP(1)-1D0/3D0*AMP(5)-1D0/3D0
     $ *AMP(6)+1D0/3D0*IMAG1*AMP(17)+1D0/3D0*IMAG1*AMP(18)-1D0/3D0
     $ *IMAG1*AMP(198)-1D0/3D0*IMAG1*AMP(200)-1D0/3D0*AMP(211)-1D0/3D0
     $ *AMP(212)-1D0/3D0*IMAG1*AMP(216)-1D0/3D0*AMP(247)-1D0/3D0
     $ *AMP(256)-1D0/3D0*AMP(258)-1D0/3D0*AMP(355)+1D0/3D0*AMP(380)
     $ +1D0/3D0*AMP(381)+1D0/3D0*AMP(383)+1D0/3D0*AMP(384))
      JAMP(46)=+1D0/2D0*(-1D0/3D0*IMAG1*AMP(1)+1D0/3D0*AMP(5)+1D0/3D0
     $ *AMP(6)-1D0/3D0*IMAG1*AMP(17)-1D0/3D0*IMAG1*AMP(18)-1D0/3D0
     $ *IMAG1*AMP(94)-1D0/3D0*IMAG1*AMP(95)-1D0/3D0*AMP(97)-1D0/3D0
     $ *AMP(106)-1D0/3D0*AMP(107)+1D0/3D0*AMP(301)+1D0/3D0*AMP(302)
     $ -1D0/3D0*IMAG1*AMP(306)-1D0/3D0*AMP(357)+1D0/3D0*AMP(379)-1D0
     $ /3D0*AMP(381)+1D0/3D0*AMP(382)-1D0/3D0*AMP(384))
      JAMP(47)=+1D0/2D0*(+AMP(5)-IMAG1*AMP(9)+IMAG1*AMP(7)+IMAG1
     $ *AMP(10)-IMAG1*AMP(12)-AMP(16)-IMAG1*AMP(18)-IMAG1*AMP(24)
     $ -AMP(25)+AMP(29)-IMAG1*AMP(35)+IMAG1*AMP(192)+IMAG1*AMP(193)
     $ -AMP(194)+AMP(211)+AMP(215)+IMAG1*AMP(216)+IMAG1*AMP(219)-IMAG1
     $ *AMP(217)-IMAG1*AMP(220)+IMAG1*AMP(222)+AMP(224)+AMP(229)-IMAG1
     $ *AMP(230)-AMP(233)+AMP(235)+AMP(236)+AMP(244)+AMP(245)-IMAG1
     $ *AMP(246)+IMAG1*AMP(329)-IMAG1*AMP(333)+IMAG1*AMP(331)-IMAG1
     $ *AMP(340)-IMAG1*AMP(341)-IMAG1*AMP(354)+AMP(355)-AMP(356)
     $ +AMP(360)-AMP(358)-AMP(383)-AMP(384)+IMAG1*AMP(386)+IMAG1
     $ *AMP(387)-AMP(389)-AMP(390))
      JAMP(48)=+1D0/2D0*(-AMP(5)+IMAG1*AMP(9)-IMAG1*AMP(7)-IMAG1
     $ *AMP(10)+IMAG1*AMP(12)+AMP(16)+IMAG1*AMP(18)+IMAG1*AMP(24)
     $ +AMP(25)-AMP(29)+IMAG1*AMP(35)+IMAG1*AMP(55)+IMAG1*AMP(56)
     $ -AMP(58)+AMP(59)-IMAG1*AMP(60)+AMP(62)-AMP(65)-AMP(64)+AMP(74)
     $ +AMP(75)+IMAG1*AMP(76)-AMP(301)+AMP(304)+IMAG1*AMP(306)+IMAG1
     $ *AMP(308)+IMAG1*AMP(307)+IMAG1*AMP(310)+IMAG1*AMP(311)-AMP(314)
     $ -IMAG1*AMP(320)+IMAG1*AMP(323)+IMAG1*AMP(322)+IMAG1*AMP(333)
     $ +IMAG1*AMP(332)-IMAG1*AMP(352)+AMP(353)+AMP(357)-AMP(360)
     $ -AMP(359)-AMP(382)+AMP(384)+IMAG1*AMP(385)-IMAG1*AMP(387)
     $ -AMP(388)+AMP(390))

C...VINCIA: Leading Color for Diagonal Entry ICOL
      gg_uxdxdug = CF(ICOL,ICOL)*JAMP(ICOL)
     &         *DCONJG(JAMP(ICOL))/DENOM(ICOL)
C...VINCIA: Absorb subleading color proportional to FSLC = LC/Sum(LC)
      IF (MCMODE.EQ.0) RETURN
      IF (MCMODE.EQ.1.AND.gg_uxdxdug.LE.ZERO) RETURN
        ZLCSUM = 0D0
        DO I = 1, NCOLOR
          ZLCSUM = ZLCSUM + CF(I,I)*JAMP(I)*DCONJG(JAMP(I))/DENOM(I)
        ENDDO
C...VINCIA: MCMODE = 2 returns full colour-summed ME
        IF (MCMODE.EQ.2) gg_uxdxdug = ZLCSUM
C...VINCIA: Fraction of subleading color to absorb into this permutation
        FSLC = gg_uxdxdug/ZLCSUM
C...VINCIA: Sum over subleading contributions multiplied by FSLC
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          IF (I.NE.J) ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
        ENDDO
        gg_uxdxdug = gg_uxdxdug+FSLC*ZTEMP*DCONJG(JAMP(I))/DENOM(I)
      ENDDO

      END

      SUBROUTINE GETgg_uxdxdug(MCMODE,ICOL,P, ALPHAS, NHEL ,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL
      DOUBLE PRECISION ALPHAS
      DOUBLE PRECISION PI
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: NHEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
CF2PY INTENT(IN) :: ALPHAS
C     ROUTINE FOR F2PY to read the benchmark point.    
C     the include file with the values of the parameters and masses 
      INCLUDE 'coupl.inc'

      PI = 3.141592653589793D0
      G = 2* DSQRT(ALPHAS*PI)
C...VINCIA: only static MG couplings are interfaced
C      CALL UPDATE_AS_PARAM()
      IF (NHEL.NE.0) THEN
        CALL SHELgg_uxdxdug(MCMODE,ICOL,P, NHEL, ANS)
      ELSE
        CALL Sgg_uxdxdug(MCMODE,ICOL,P, ANS)
      ENDIF
      RETURN
      END


